UNIT Bas7000;   (* Globale Variable: S_Register, Datazeiger *)

(* 23.10.96 H-J Ersetze_KS_Daten nach Goto, Return, Return aufgerufen *)

INTERFACE

USES LuchsTyp;


PROCEDURE Basic;

IMPLEMENTATION
{$IFDEF DElphi }
USES Codesave, CommWin, BasmScan, ASS7000;
{$ELSE }
USES CodeSave, CommDOS, BasmScan, ASS7000;
{$ENDIF }

TYPE  T_Inserttyp = (Onebyte,Twobyte);

CONST Push_R0=$2F06;     (* mov.l R0,@-R15 *)
      Push_R1=$2F16;     (* mov.l R1,@-R15 *)
      Push_R2=$2F26;     (* mov.l R2,@-R15 *)
      Push_R3=$2F36;     (* mov.l R3,@-R15 *)
      Pull_R0=$60F6;     (* mov.l @R15+,R0 *)
      Pull_R1=$61F6;     (* mov.l @R15+,R1 *)
      Pull_R2=$62F6;     (* mov.l @R15+,R2 *)
      Pull_R3=$63F6;     (* mov.l @R15+,R3 *)
      Push_PR=$4F22;     (* sts.l PR,@-R15 *)
      Pull_PR=$4F26;     (* lds.l @R15+,PR *)

      AddReg=12;         (* bezeichnet den Variablenstart             *)
                         (* der Datazeiger liegt unterhalb von AddReg *)
CONST Startreg=4;
      Endreg=11;         (* Registervariable *)
      LastTask   =-$50;
      maxTask    = 96;

PROCEDURE Basic;

CONST StartStrLaenge=79;

VAR  Scanresult : T_Scanresult;
     StrLaenge,Varzeiger,DefParAdr: LongInt;
     Datazeiger: Longint;
     Baum,StdBezBaum: T_Baum;
     DimHeap: T_DimHeap;
     Insertheap: T_Insertheap;
     Ist_Befehl,Rechenzeichen,List:Boolean;
     DefAktiv,Ende: Boolean;
     DefParameterName: T_Bezeichner;
     LastOpcode: T_Opcode;
     IncFName,HexString: Str80;
     Typ: Op_Typ;
     DataSchlange: T_DataSchlange;
     DataAdrInfo,EndVarAdrInfo : T_AdrInfo;
     RegNr: Word;
     Plus_Menge, Mal_Menge: Set OF T_Basicsymbol;

PROCEDURE Error(f: Str80);
BEGIN Fehler('BASIC-Fehler: '+f) END;

PROCEDURE Parser;

VAR Symbol  : T_BasicSymbol;

 PROCEDURE LiesZ;
 BEGIN
 {  IF List AND (Input.z=#10)
      THEN BEGIN IF Input.Include THEN write(lst,'i ');
		 HexAdresse(PC,HexString); write(lst,'$',Hexstring,': ')
           END; }
   Lies
 END;

 PROCEDURE LiesNoSpace;
 BEGIN WHILE InputRec.z = ' ' DO LiesZ END;

 PROCEDURE Scanner;
 BEGIN Basic_scanner(Scanresult, StdBezBaum); Symbol:=Scanresult.Basicsymbol END;

PROCEDURE Anweisung_P;  Forward;
PROCEDURE I_Expression; Forward;
PROCEDURE R_Expression; Forward;
PROCEDURE S_Expression; Forward;
PROCEDURE I_Ausdruck; Forward;
PROCEDURE R_Ausdruck; Forward;
PROCEDURE S_Ausdruck; Forward;

PROCEDURE Komma_P;
BEGIN IF Symbol <> Komma_BS THEN Error('Komma erwartet'); Scanner END;

PROCEDURE Klammerauf_P;
BEGIN
  IF Symbol <> Klammerauf_BS THEN Error('Klammerauf erwartet'); Scanner
END;

PROCEDURE Klammerzu_P;
BEGIN
  IF Symbol <> Klammerzu_BS THEN Error('Klammerzu erwartet'); Scanner
END;

PROCEDURE Gleich_P;
BEGIN
  IF Symbol <> Gleich_BS THEN Error('Gleichheitszeichen erwartet');
  Scanner
END;

PROCEDURE TestPush;    (* evtl. Push-Anweisungen nachtragen *)
BEGIN
  CASE Lastopcode OF
       PushInt:  CodiereCodeWord(Push_R0);
       PushReal: BEGIN CodiereCodeWord(Push_R3);
                       CodiereCodeWord(Push_R2);
                 END;
  END;
  Lastopcode:=Other
END;

PROCEDURE CodiereK_Long(x : LongInt; Reg : Word);
BEGIN
   TestPush;
   KS_CodiereS_long(x,Reg);
END;

PROCEDURE Codiere_Adr(Adr: LongInt; Reg: Word);
BEGIN
 TestPush;
 IF Adr <= 128
    THEN CodiereCodeWord($E000+$100*Reg+(Adr AND $FC)) (* mov #adr,Reg *)
    ELSE IF Adr <= 512
            THEN BEGIN CodiereCodeWord($E000+$100*Reg+(Adr shr 2)); (* mov #adr/4,Reg *)
                       CodiereCodeWord($4008+$100*Reg);             (* shll2 Reg*)
                 END
            ELSE KS_CodiereS_long(Adr,Reg);
 CodiereCodeWord($300C+$100*Reg+$10*Addreg); (* add Addreg,Reg *)
END;

PROCEDURE CodiereK_Real(Wert: Double; Reg : Word);
BEGIN
   TestPush;
   KS_CodiereS_Real(Wert,Reg);
END;

PROCEDURE CodiereK_Str(s : String);
BEGIN
   TestPush;
   KS_CodiereS_Str(s);
END;

PROCEDURE CodWord(W: word);
BEGIN
  TestPush;
  CodiereCodeWord(W);
END;

PROCEDURE CodLong(l: LongInt);
VAR High: LongInt;
BEGIN
  TestPush;
  High := (l shr 8) shr 8;
  CodiereCodeWord(High AND $FFFF);
  CodiereCodeWord(l AND $FFFF);
END;

PROCEDURE CodRuntime(Nr: T_Trap);    (* Runtimeaufrufe fr 0..127 *)
BEGIN
  IF Nr > R_Last
     THEN Fehler('Runtimeraufruf nicht implementiert');
  TestPush;
  CodiereCodeWord($E100+Ord(Nr));  (* mov #0..127,R1   *)
  CodiereCodeWord($C320);          (* Trapa #T_Runtime *)
END;

PROCEDURE CodNop;
BEGIN CodWord($0009) END;

PROCEDURE CodPulInt;
BEGIN
  IF Lastopcode <> PushInt
     THEN CodiereCodeWord(Pull_R0);
  LastOpcode:=Other
END;

PROCEDURE CodStoreInt(Adr: LongInt; DimL: Word);
BEGIN
  IF (DimL=4) AND (((Adr shr 2) AND $7FFFFFFC) < 16)
     THEN CodWord($1000+$100*AddReg+(Adr shr 2)) (* mov.l R0,@(Adr/4,AddReg) *)
     ELSE BEGIN Codiere_Adr(Adr,1);   (* mov.l Adr,R1  *)
                CASE DimL OF
                 1: CodWord($2100);  (* Mov.b R0,@R1 *)
                 2: CodWord($2101);  (* Mov.w R0,@R1 *)
                 4: CodWord($2102);  (* Mov.l R0,@R1 *)
                END;
          END;
END;

PROCEDURE CodStoreReal(Adr: LongInt);
BEGIN
 IF ((Adr shr 2) AND $7FFFFFFC) < 15
   THEN BEGIN
         CodWord($1020+$100*AddReg+(Adr shr 2));  (* mov.l R2,@(Adr/4,AddReg) *)
         CodWord($1030+$100*AddReg+(Adr shr 2)+1) (* mov.l R3,@(Adr/4+4,AddReg) *)
        END
   ELSE BEGIN
         Codiere_Adr(Adr,1);   (* mov.l Adr,R1     *)
         CodWord($2122);            (* mov.l R2,@R1     *)
         CodWord($1121);            (* mov.l R3,@(4,R1) *)
        END;
END;

PROCEDURE CodPulPR;
BEGIN
  IF Lastopcode <> PushPR
     THEN CodiereCodeWord(Pull_PR);
  LastOpcode:=Other
END;

PROCEDURE CodPulReal;
BEGIN
  IF Lastopcode <> PushReal
     THEN BEGIN CodiereCodeWord(Pull_R2);
                CodiereCodeWord(Pull_R3);
          END;
  LastOpcode:=Other
END;

PROCEDURE CodPushInt;
BEGIN
  TestPush; LastOpcode:=PushInt;
END;

PROCEDURE CodPushPR;
BEGIN
  TestPush; LastOpcode:=PushPR;
END;

PROCEDURE CodPushReal;
BEGIN
  TestPush; LastOpcode:=PushReal;
END;

(* nach CodLoadIntVar steht die Adresse der Variablen in R1 *)
PROCEDURE CodLoadIntVar(Adr: Longint; Zielreg: Word);
BEGIN
  TestPush;
  IF (((Adr shr 2) AND $7FFFFFFC) < 16)
     THEN CodiereCodeWord($5000+$100*ZielReg+$10*AddReg+(Adr shr 2))
                                        (* mov.l @(Adr/4,AddReg),ZielReg *)
     ELSE BEGIN
            Codiere_Adr(Adr,1);    (* mov.l Adr,R1      *)
            CodWord($6012+$100*ZielReg);(* mov.l @R1,ZielReg *)
          END;
END;

PROCEDURE CodLoadRegVar(Adr: Longint);
BEGIN
  TestPush;
  CodWord($6003+$10*Adr);              (* mov Rx,R0 *)
END;

PROCEDURE CodLoadPushRealVar(Adr: Longint);
BEGIN
  TestPush;
  IF (((Adr shr 2) AND $7FFFFFFC) < 15)
     THEN BEGIN CodiereCodeWord($5200+$10*AddReg+(Adr shr 2));
                               (* mov.l @(Adr/4,AddReg),R2   *)
                CodiereCodeWord($5301+$10*AddReg+(Adr shr 2));
                               (* mov.l @(Adr/4+4,AddReg),R3 *)
          END
     ELSE BEGIN
            Codiere_Adr(Adr,1);    (* mov.l Adr,R1  *)
            CodWord($6216);             (* mov.l @R1+,R2 *)
            CodWord($6312);             (* mov.l @R1,R3  *)
          END;
  LastOpcode:=PushReal;
END;

PROCEDURE CodLoadDataZeiger;   (* Adresse von Datazeiger nach R1 *)
                               (* Datazeiger in R0               *)
BEGIN
  CodWord($6103+$10*AddReg);   (* mov AddReg,R1 *)
  CodWord($71FC);              (* add #-4,R1    *)
  CodWord($6012);              (* mov.l @R1,R0  *)
END;

PROCEDURE HolAdr(Name: T_Ident; VAR Symbol: T_BasicSymbol;
                     VAR Adr: LongInt; VAR Dim_Var: Boolean;
                     VAR Dimension,DimL,Dim1,Dim2,Dim3: LongInt);
VAR Dummysymbol: T_BasicSymbol;
BEGIN
  while varzeiger AND 3 <> 0 do inc(Varzeiger);
  DimL:=4;   (* Voreinstellung fuer Byte/Word/Integer-Feld *)
  IF NOT L_vorhanden(Baum,Name,symbol,Adr)
     THEN BEGIN Adr:=Varzeiger;
                IF Symbol=R_Ident_BS
                 THEN Inc(Varzeiger,8)
                 ELSE IF Symbol=S_Ident_BS THEN Varzeiger:=Varzeiger+StrLaenge+1
                                           ELSE Inc(Varzeiger,4);
                Labelrein(Baum,Name,Symbol,Adr)
          END;
  Dim_Var:=DimHeapVorhanden(DimHeap,Name,Dimension,DimL,Dim1,Dim2,Dim3)
END;

PROCEDURE Var_P;

 PROCEDURE One_Var;
 VAR Adr: Longint;
 BEGIN
  IF Symbol IN [I_Ident_BS,R_Ident_BS,S_Ident_BS]
     THEN IF L_vorhanden(Baum,Scanresult.Name,Symbol,Adr)
             THEN Error('Variable <'+Scanresult.name+'> schon deklariert')
             ELSE BEGIN Adr:=Varzeiger;
                        IF Symbol=R_Ident_BS
                           THEN Inc(Varzeiger,8)
                                ELSE IF Symbol=S_Ident_BS
                                        THEN Varzeiger:=Varzeiger+StrLaenge+1
                                        ELSE Inc(Varzeiger,4);
                        Labelrein(Baum,Scanresult.Name,Symbol,Adr)
                  END
  ELSE Error('VAR <Variablenbezeichner> erwartet');
  Scanner;
 END;

BEGIN
 Scanner; One_Var;
 WHILE Symbol=Komma_BS DO BEGIN Scanner; One_Var END
END;


PROCEDURE Push_Dim_Adr(PName: T_Ident; PSymbol:T_BasicSymbol;
                       VAR DimLaenge: LongInt);
VAR Adr : LongInt;
    Dimension,Dim1,Dim2,Dim3: LongInt;
    DimVar: Boolean;

    PROCEDURE OneDim(Offset: Word);
    BEGIN
       CodiereK_Long(Offset,0);
       CodPushInt;
       I_Expression;
       CodRuntime(R_IntMult)
    END;

    PROCEDURE DimShiftLinks(Laenge: Word);
    BEGIN
      CodPulInt;                 (* Offset lesen     *)
      CASE Laenge OF
        1: (* ok *);
        2: CodWord($4000); (* shll  R0 *)
        4: CodWord($4008); (* shll2 R0 *)
        8: BEGIN CodWord($4008); CodWord($4000) END; (* shll R0  shll2 R0*)
      END
    END;

    PROCEDURE Dimension1_P;
    BEGIN I_Ausdruck;                              (* Offset berechnen *)
          IF Dimlaenge IN [1,2,4,8]
             THEN DimShiftLinks(Dimlaenge)
             ELSE BEGIN CodiereK_Long(Dimlaenge,0); (* fuer Strings *)
                        CodPushInt;
                        CodRuntime(R_IntMult);
                        CodPulInt;
                  END;
                                          (* Offset steht in R0 *)
          Codiere_Adr(Adr,1);        (* Grundadr.  in R1   *)
          CodWord($301C);                 (* add R1,R0          *)
          CodPushInt;
    END;

    PROCEDURE Dimension2_P;
    BEGIN
      OneDim(DimLaenge*(Dim2+1));
      IF Symbol <> Komma_BS THEN Error('Komma erwartet') ELSE Scanner;
      I_Ausdruck;
      IF Dimlaenge IN [1,2,4,8]
         THEN DimShiftLinks(Dimlaenge)
         ELSE BEGIN CodiereK_Long(Dimlaenge,0); (* fuer Strings *)
                    CodPushInt;
                    CodRuntime(R_IntMult);
                    CodPulInt;
               END;
                                    (* Offset 2. Dim in R0 *)
         CodWord(Pull_R1);          (* Offset aus 1. Dim   *)
         CodWord($301C);            (* add R1,R0           *)
         Codiere_Adr(Adr,1);   (* Grundadr.  in R1    *)
         CodWord($301C);            (* add R1,R0           *)
         CodPushInt;
    END;

    PROCEDURE Dimension3_P;
    BEGIN
      OneDim(DimLaenge*(Dim2+1)*(Dim3+1));
      IF Symbol <> Komma_BS THEN Error('Komma erwartet') ELSE Scanner;
      OneDim(DimLaenge*(Dim2+1));
      IF Symbol <> Komma_BS THEN Error('Komma erwartet') ELSE Scanner;
      I_Ausdruck;
      IF Dimlaenge IN [1,2,4,8]
         THEN DimShiftLinks(Dimlaenge)
         ELSE BEGIN CodiereK_Long(Dimlaenge,0); (* fuer Strings *)
                    CodPushInt;
                    CodRuntime(R_IntMult);
                    CodPulInt;
               END;
                                    (* Offset 3. Dim in R0 *)
         CodWord(Pull_R1);          (* Offset aus 2. Dim   *)
         CodWord($301C);            (* add R1,R0           *)
         CodWord(Pull_R1);          (* Offset aus 1. Dim   *)
         CodWord($301C);            (* add R1,R0           *)
         Codiere_Adr(Adr,1);   (* Grundadr.  in R1    *)
         CodWord($301C);            (* add R1,R0           *)
         CodPushInt;
    END;

BEGIN
  HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimLaenge,Dim1,Dim2,Dim3);
  IF NOT DimVar
     THEN Error('"(" verboten')
     ELSE BEGIN
            Scanner;
            IF Dimension=3
               THEN Dimension3_P
               ELSE IF Dimension=2 THEN Dimension2_P ELSE Dimension1_P;
            IF Symbol <> Klammerzu_BS
               THEN Error('")" erwartet') ELSE Scanner
          END
END;

PROCEDURE Push_Dim_Variable(PName: T_Ident;PSymbol:T_BasicSymbol);
VAR PDimL: LongInt;
BEGIN
  Push_Dim_Adr(PName,PSymbol,PDimL);
  CASE PSymbol OF
    I_Ident_BS: BEGIN CodPulInt;       (* Adr nach R0  *)
                      CASE PDimL OF
                       1: BEGIN CodWord($6000);  (* mov.b @R0,R0 *)
                                CodWord($600C)   (* extu.b R0,R0 *)
                          END;
                       2: BEGIN CodWord($6001);  (* mov.w @R0,R0 *)
                                CodWord($600D);  (* extu.w R0,R0 *)
                          END;
                       4: CodWord($6002);  (* mov.l @R0,R0 *)
                      END;
                      CodPushInt
                END;
    R_Ident_BS: BEGIN CodPulInt;      (* Adr nach R0   *)
                      CodWord($6216); (* mov.l @R0+,R2 *)
                      CodWord($6312); (* mov.l @R0,R3  *)
                      CodPushReal;
                END;
    S_Ident_BS: CodRuntime(R_StrPush)
  END
END;

PROCEDURE Push_Adr(VAR DimL: LongInt);
VAR Adr: Longint;
    PSymbol: T_BasicSymbol;
    PName: T_Ident;
    DimVar: Boolean;
    Dim1,Dim2,Dim3,Dimension: LongInt;
BEGIN
  PSymbol:=Symbol; PName:=Scanresult.Name;
  Scanner;
  IF Symbol = Klammerauf_BS
     THEN Push_Dim_Adr(PName,PSymbol,DimL)
     ELSE BEGIN HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                IF DimVar THEN Error('( erwartet');
                Codiere_Adr(Adr,0);    (* mov.l Adr,R0   *)
                CodPushInt;
          END
END;

PROCEDURE Push_Variable;
VAR Adr: LongInt;
    PSymbol: T_BasicSymbol;
    PName: T_Ident;
    DimVar,L_da: Boolean;
    DimL,Dim1,Dim2,Dim3,Dimension: LongInt;

  PROCEDURE Push_Funktion(F_Adr: LongInt);
  VAR Distanz: LongInt;
  BEGIN Scanner; Klammerauf_P;
        IF InputRec.C_ok THEN R_Expression;   (* Argument auf Stack *)
        CodWord(Push_PR);                         (* PR retten *)
        Distanz:=F_Adr-Code.PC;
        IF Distanz > -4090
           THEN BEGIN CodWord($B000+(Distanz shr 1) AND $FFF); (* BSR F_Adr *)
                      CodNop
                END
           ELSE BEGIN IF Code.PC AND 2 = 0 THEN CodNop;
                      CodWord($C32A);      (* .BSRL *)
                      CodLong(F_Adr-Code.PC);
                END;
        Klammerzu_P;
        CodPulPR                           (* PR wiederherstellen *)
  END;

BEGIN   (* PushVariable *)
  IF DefAktiv AND (Scanresult.Name=DefParameterName)
     THEN BEGIN CodLoadPushRealVar(DefParAdr); Scanner END
     ELSE BEGIN
            L_da :=L_vorhanden(Baum,Scanresult.Name,PSymbol,Adr);
            IF L_da AND (PSymbol=F_Ident_BS)
               THEN Push_Funktion(Adr)
               ELSE BEGIN
                      PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
                      HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                      IF Symbol = Klammerauf_BS
                         THEN Push_Dim_Variable(PName,PSymbol)
                         ELSE BEGIN
                               HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                               IF DimVar THEN Error('( erwartet');
                               CASE PSymbol OF
                                I_Reg_BS  : BEGIN CodLoadRegVar(Adr);
                                                  CodPushInt;
                                            END;
                                I_Ident_BS: BEGIN CodLoadIntVar(Adr,0);
                                                  CodPushInt
                                            END;
                                R_Ident_BS: CodLoadPushRealVar(Adr);
                                ELSE BEGIN Codiere_Adr(Adr,0); (* mov.l Adr,R0 *)
                                           CodWord(push_R0);
                                           CodRuntime(R_StrPush);
                                     END
                               END
                              END
                    END
          END
END;

FUNCTION I_Wert(VAR Wert: Double): LongInt;
BEGIN
  IF (Wert>=2147483647.0) OR (Wert < -2147483648.0)
     THEN Error('Integerzahl zu gross: '+Hexlong(trunc(Wert)))
     ELSE I_Wert:=Trunc(Wert)
END;

{ naechste Prozedur CodIntBool ist wahrsch. unnoetig }

PROCEDURE CodIntBool;
BEGIN
  CodPulInt;
  CodWord($2008);  (* TST R0,R0 *)
  CodWord($8900);  (* bt ->     *)
  CodWord($E001);  (* mov #1,R0 *)
  CodPushInt;
END;

PROCEDURE CodNotBool;
BEGIN
  CodPulInt;
  CodWord($2008);  (* TST R0,R0 *)
  CodWord($0029);  (* movt R0   *)
  CodPushInt;
END;

PROCEDURE CodAndBool;
BEGIN
  CodPulInt;        (* 2. Operand in R0 *)
  CodWord(Pull_R1); (* 1. Operand in R1 *)
  CodWord($2008);   (* tst R0,R0        *)
  CodWord($8902);   (* bt  Ende         *)
  CodWord($2118);   (* tst R1,R1        *)
  CodWord($0029);   (* movt R0          *)
  CodWord($CA01);   (* xor #1,R0        *)
  CodPushInt;
END;

PROCEDURE CodOrBool;
BEGIN
  CodPulInt;        (* 2. Operand in R0 *)
  CodWord(Pull_R1); (* 1. Operand in R1 *)
  CodWord($201B);   (* OR R1,R0         *)
  CodWord($2008);   (* tst R0,R0        *)
  CodWord($0029);   (* movt R0          *)
  CodWord($CA01);   (* xor #1,R0        *)
  CodPushInt;
END;

PROCEDURE CodPlusInt;
BEGIN
  CodPulInt;         (* 2. Summanden vom Stack nach R0 holen *)
  CodWord(Pull_R1);  (* mov.l @R15+,R1 ; 1. Summand nach R1  *)
  CodWord($301C);    (* add R1,R0 *)
  CodPushInt
END;

PROCEDURE CodMinusInt;
BEGIN
  CodPulInt;         (* 2. Operanden vom Stack nach R0 holen *)
  CodWord($600B);    (* neg R0,R0      ; Vorzeichen umdrehen *)
  CodWord(Pull_R1);  (* mov.l @R15+,R1 ; 1. Operand nach R1  *)
  CodWord($301C);    (* add R1,R0                            *)
  CodPushInt
END;

PROCEDURE CodNegInt;
BEGIN
  CodPulInt;             (* Integerwert vom Stack holen *)
  CodWord($600B);        (* NEG R0,R0 *)
  CodPushInt
END;

PROCEDURE CodReadInt;
VAR DimL: LongInt;
BEGIN
  Push_Adr(DimL);
  CodLoadDataZeiger;  (* Adr von Datazeiger in R1, Wert in R0 *)
  CodWord($6206);                      (* mov.l @R0+,R2       *)
  CodWord($6306);                      (* mov.l @R0+,R3       *)
  Codword($2102);                      (* mov.l R0,@R1        *)
  CodWord(Push_R3);                    (* Real auf Stack      *)
  CodWord(Push_R2);
  CodRuntime(R_FloatInt);              (* konvertieren        *)
  CodPulInt;                           (* Integerwert in R0   *)
  CodWord(Pull_R1);                    (* Zieladresse in R1   *)
  CASE DimL OF
    1: CodWord($2100);  (* Mov.b R0,@R1 *)
    2: CodWord($2101);  (* Mov.w R0,@R1 *)
    4: CodWord($2102);  (* Mov.l R0,@R1 *)
  END;
  codnop
END;

PROCEDURE CodReadReal;
VAR DimL: LongInt;
BEGIN
  Push_Adr(DimL); CodPulInt;           (* Zieladresse in R0   *)
  CodWord($6303);                      (* mov R0,R3           *)
  CodLoadDataZeiger;  (* Adr von Datazeiger in R1, Wert in R0 *)
  CodWord($6206);                      (* mov.l @R0+,R2       *)
  CodWord($2322);                      (* mov.l R2,@R3        *)
  CodWord($6206);                      (* mov.l @R0+,R2       *)
  CodWord($1321);                      (* mov.l R2,@(4,R3)    *)
  CodWord($2102);                      (* mov.l R0,@R1        *)
END;

PROCEDURE CodPushStrLaenge;
BEGIN
  IF StrLaenge=$100
     THEN BEGIN CodWord($E040);      (* mov #$40,R0 *)
                CodWord($4008);      (* shll2 R0    jetzt $100 in R0 *)
          END
     ELSE BEGIN
            CodWord($E000+StrLaenge);          (* Maxlaenge             *)
            IF StrLaenge>127 THEN CodWord($600C); (* EXTU.B R0,R0       *)
          END;
  CodPushInt;
END;

PROCEDURE CodReadString;
VAR DimL: LongInt;
BEGIN
  Push_Adr(DimL);                    (* Zieladresse auf Stack *)
  CodLoadDataZeiger;  (* Adr von Datazeiger in R1, Wert in R0 *)
  CodPushInt;                        (* Quelladresse auf Stack*)
  CodWord($6200);                    (* mov.b @R0,R2 = Laenge *)
  CodWord($622C);                    (* extu.b R2,R2 als Byte *)
  CodWord($4209);                    (* SHLR2 R2              *)
  CodWord($7201);                    (* add   #1,R2           *)
  CodWord($4208);                    (* shll2 R2              *)
  CodWord($302C);                    (* add   R2,R0           *)
  CodWord($2102);           (* neuer Datazeiger: mov.l R0,@R1 *)
  CodRuntime(R_StrPush);             (* Quellstring auf Stack *)
  CodPushStrLaenge;
  CodRuntime(R_StrPull);             (* String an Ziel legen  *)
END;

PROCEDURE CodSqrInt;
BEGIN CodPushInt; CodRuntime(R_IntMult) END;

PROCEDURE CodAbsInt;
BEGIN
  CodPulInt;
  CodWord($4011);    (* cmp/pz R0      *)
  CodWord($8900);    (* bt  hinter neg *)
  CodWord($600B);    (* neg R0,R0      *)
  CodPushInt
END;

PROCEDURE CodSgnReal;
BEGIN
{
  CodByteAdr($30,$EC00); (* TSX LDD 0,X *)
  CodAdr($2709);  	 (* BEQ +9 *)
  CodAdr($84C0);  	 (* ANDA #$C0 *)
  CodByteAdr($5F,$ED00); (* CLRB STD 0,X *)
  CodAdr($4F5C);  (* CLRA INCB = LDD #1*)
  CodAdr($ED02);  (* STD 2,X *)
}
END;

PROCEDURE CodKeypress;
BEGIN
  Scanner; CodRuntime(R_Keypress);
END;

PROCEDURE StoreIrqReg;
VAR i: Word;
BEGIN
  CodWord($4F02); (* sts.l mach,@-R15 *)
  CodWord($4F12); (* sts.l macl,@-R15 *)
  CodWord($4F22); (* sts.l pr,@-R15 *)
  FOR i:=0 TO 14 DO Codword($2F06+$10*i); (* mov.l ri,@-R15 *)
END;

PROCEDURE RestoreIrqReg;
VAR i: Word;
BEGIN
  FOR i:=14 DOWNTO 0 DO Codword($60F6+$100*i); (* mov.l @r15+, ri *)
  Codword($4F26); (* lds.l @R15+,pr *)
  Codword($4F16); (* lds.l @R15+,macl *)
  Codword($4F06); (* lds.l @R15+,mach *)
END;

PROCEDURE Codawaited(Tr: T_Trap);
BEGIN
  Scanner; I_Ausdruck;
  CodRuntime(Tr);
END;


PROCEDURE IntFunktion_P(FnSymbol: T_Basicsymbol); Forward;

PROCEDURE RealFunktion_P(FnSymbol: T_Basicsymbol);

  PROCEDURE Val_P;
  BEGIN
    Scanner;Klammerauf_P;S_Ausdruck;Klammerzu_P;
    CodRuntime(R_StrZuReal)
  END;

  PROCEDURE Fak_P;
  BEGIN
    Scanner;Klammerauf_P;I_Ausdruck;Klammerzu_P;
    CodRuntime(R_Fakultaet)
  END;

   PROCEDURE EEReadReal_P;
   BEGIN Scanner; Klammerauf_P;I_Ausdruck; Komma_P; I_Ausdruck;Klammerzu_P;
         CodRuntime(R_EEReadReal)
   END;

BEGIN
  IF FNSymbol IN [Peek_BS..WPeek_BS]
     THEN BEGIN IntFunktion_P(FnSymbol); CodRuntime(R_IntFloat) END
     ELSE IF Symbol=Val_BS THEN Val_P
     ELSE IF Symbol=Fakultaet_BS THEN Fak_P
     ELSE IF Symbol=EEReadReal_BS THEN EEReadReal_P
     ELSE BEGIN IF FNSymbol IN [Sin_BS..Sqr_BS]
                THEN BEGIN Scanner; Klammerauf_P; R_Ausdruck END;
                CASE FnSymbol OF
                  Sin_BS: CodRuntime(R_FloatSin);
                  Cos_BS: CodRuntime(R_FloatCos);
                  Tan_BS: CodRuntime(R_FloatTan);
                  Asn_BS: CodRuntime(R_Floatasin);
                  Acs_BS: CodRuntime(R_Floatacos);
                  Atn_BS: CodRuntime(R_Floatatan);
                  Exp_BS: CodRuntime(R_Floatexp);
                  Ln_BS : CodRuntime(R_Floatln);
                  Abs_BS: CodRuntime(R_AbsReal);
                  Sgn_BS: CodSgnReal;
                  SQR_BS: CodRuntime(R_FloatQuadrat);
                  Sqrt_BS : CodRuntime(R_Floatwurzel);
                  Trunc_BS: CodRuntime(R_FloatTrunc);
                  Frac_BS : CodRuntime(R_FloatFrac);
                  ELSE Error('Zahl/Funktion erwartet')
                 END;
                 Klammerzu_P
           END
END;

PROCEDURE IntFunktion_P(*FnSymbol: T_Basicsymbol*);  (* Forward *)

   PROCEDURE Len_P;
   BEGIN Scanner; Klammerauf_P; S_Ausdruck; Klammerzu_P;
         CodRuntime(R_StrLength)
   END;

   PROCEDURE Bit_P(Ziel: T_Trap);
   BEGIN Komma_P; I_Ausdruck; CodRuntime(Ziel) END;

   PROCEDURE Asc_P;
   BEGIN
     Scanner; Klammerauf_P; S_Ausdruck; Klammerzu_P;
     CodRuntime(R_Asc);
   END;

   PROCEDURE Pos_P;
   BEGIN Scanner; Klammerauf_P; S_Ausdruck; Komma_P; S_Ausdruck; Klammerzu_P;
         CodRuntime(R_StrPos)
   END;

   PROCEDURE Addr_P;
   VAR Addr_Symbol: T_Basicsymbol;
       Dummy,DimL : LongInt;
   BEGIN Scanner; Klammerauf_P;
         IF L_vorhanden(Baum,Scanresult.Name,Addr_Symbol,Dummy)
            THEN case Addr_Symbol OF
                  L_Ident_BS: BEGIN TestPush;
                                    IF (Code.PC AND 2 = 0) THEN Codnop;
                                    CodWord($C32B);  (* .moval *)
                                    Insertheaprein(Insertheap,Scanresult.Name,Code.PC,moval_T);
                                    CodLong(0); CodPushInt; Scanner
                              END;
                  S_Ident_BS,
                  R_Ident_BS,
                  I_Ident_BS: Push_Adr(DimL);
                  I_Reg_BS  : Error('Addr(Registervariable '+Scanresult.Name
                              +' verboten');
                  else        Error('Adresse von '+Scanresult.name+' verboten')
                 end
            ELSE Error('Bezeichner '+Scanresult.Name+' noch nicht benutzt');
         Klammerzu_P
   END;

   PROCEDURE EERead_P(Ziel: T_Trap);
   BEGIN Scanner; Klammerauf_P; I_Ausdruck; Komma_P; I_Ausdruck; Klammerzu_P;
         CodRuntime(Ziel)
   END;

BEGIN         (* IntFunktion *)
  IF FnSymbol IN [sin_BS..Trunc_BS]
     THEN BEGIN RealFunktion_P(FnSymbol); CodRuntime(R_FloatInt) END
     ELSE IF Symbol = Keypress_BS THEN CodKeypress
     ELSE IF Symbol = Awaited_BS THEN Codawaited(R_AWaited)
     ELSE IF Symbol = RSReady_BS THEN Codawaited(R_RSReady)
     ELSE IF Symbol = RSRead_BS THEN Codawaited(R_RSRead)
     ELSE IF Symbol = ADIN_BS
             THEN BEGIN CodRuntime(R_ADIn); Scanner END
     ELSE IF Symbol = ADIn16_BS
             THEN BEGIN CodRuntime(R_ADIn16); Scanner END
     ELSE IF Symbol = Readtimer_BS
             THEN BEGIN CodRuntime(R_Readtimer); Scanner END
     ELSE IF Symbol = GetIrqMask_BS
             THEN BEGIN CodRuntime(R_GetIrqMask); Scanner END
     ELSE IF Symbol = I2CReadA_BS
             THEN BEGIN CodRuntime(R_I2CReadA); Scanner END
     ELSE IF Symbol = I2CReadNA_BS
             THEN BEGIN CodRuntime(R_I2CReadNA); Scanner END
     ELSE IF Symbol = I2CAck_BS
             THEN BEGIN CodRuntime(R_I2CAck); Scanner END
     ELSE IF Symbol = EEReadByte_BS THEN EERead_P(R_EEReadByte)
     ELSE IF Symbol = EEReadWord_BS THEN EERead_P(R_EEReadWord)
     ELSE IF Symbol = EEReadLong_BS THEN EERead_P(R_EEReadLong)
     ELSE IF Symbol = Len_BS  THEN Len_P
     ELSE IF Symbol = Pos_BS  THEN Pos_P
     ELSE IF Symbol = Addr_BS THEN Addr_P
     ELSE IF Symbol = Asc_BS  THEN Asc_P
     ELSE IF Symbol = VBR_BS  THEN BEGIN CodWord($0022); CodPushInt;Scanner END
                                         (* stc VBR,R0 *)

     ELSE BEGIN IF FnSymbol IN[Abs_BS..WPeek_BS]
                  THEN BEGIN Scanner; Klammerauf_P; I_Ausdruck END;
                CASE FnSymbol OF
                  Abs_BS     : CodAbsInt;
                  SQR_BS     : CodSqrInt;
                  Peek_BS    : BEGIN CodPulInt;      (* Adresse in R0 *)
                                     CodWord($6000); (* mov.b @R0,R0  *)
                                     CodPushInt
                               END;
                  WPeek_BS   : BEGIN CodPulInt;      (* Adresse in R0 *)
                                     CodWord($6001); (* mov.w @R0,R0  *)
                                     CodPushInt
                               END;
                  LPeek_BS   : BEGIN CodPulInt;      (* Adresse in R0 *)
                                     CodWord($6002); (* mov.l @R0,R0  *)
                                     CodPushInt
                               END;
                  BitAnd_BS  : Bit_P(R_LongAnd);
                  BitOr_BS   : Bit_P(R_LongOr);
                  BitEor_BS  : Bit_P(R_LongEor);
                  BitNot_BS  : CodRuntime(R_LongNot);
                ELSE Error('Zahl/Funktion erwartet')
                END;
                Klammerzu_P
          END
END;

  PROCEDURE I_Ausdruck;
  VAR Rechenzeichen, Vorzeichen: T_Basicsymbol;

   PROCEDURE I_Term;
   VAR Rechenzeichen: T_Basicsymbol;

     PROCEDURE I_Faktor;

       PROCEDURE PushIdent;
       VAR Adr: LongInt;
           ISymbol: T_Basicsymbol;
       BEGIN
         ISymbol:=Symbol;
         Push_Variable;
         IF ISymbol=R_Ident_BS THEN CodRuntime(R_FloatInt)
       END;

       BEGIN (* I_Faktor *)
         CASE Symbol OF
            I_Zahl_BS : BEGIN IF Vorzeichen = Minus_BS
                                 THEN Scanresult.Wert:=- ScanResult.Wert;
                              CodiereK_Long(I_Wert(Scanresult.Wert),0);
                              CodPushInt;
                              Vorzeichen:=Plus_BS; Scanner
                        END;
            I_Ident_BS,
            I_Reg_BS,
            R_Ident_BS : PushIdent;
            S_Ident_BS : Error('Stringvariable verboten');
            Klammerauf_BS: BEGIN Scanner; I_Expression;
				 IF InputRec.C_Ok THEN Klammerzu_P
                           END;
            Not_BS     : BEGIN Scanner; I_Faktor;
                               CodNotBool
                         END;
            Minus_BS   : BEGIN Scanner; I_Faktor; CodNegInt END;
            ELSE         IntFunktion_P(Symbol);
         END;
       END;

  BEGIN  (* I_Term *)
    I_Faktor; Rechenzeichen:=Symbol;
    WHILE Symbol IN Mal_Menge DO
     BEGIN
       Rechenzeichen:=Symbol; Scanner; I_Faktor;
       CASE Rechenzeichen OF
         Mal_BS  : CodRuntime(R_IntMult);
         Durch_BS,
         Div_BS  : CodRuntime(R_IntDiv);
         Mod_BS  : CodRuntime(R_IntMod);
         AND_BS  : CodAndBool;
       END;
     END
   END;

  BEGIN (* I_Ausdruck *)
   IF InputRec.C_ok
     THEN BEGIN
           IF Symbol = MINUS_BS
            THEN BEGIN Vorzeichen:=Minus_BS; Scanner END
            ELSE BEGIN Vorzeichen:=Plus_BS; IF Symbol = Plus_BS THEN Scanner END;
           I_Term;
	   WHILE InputRec.C_ok AND (Symbol IN Plus_Menge) DO
            BEGIN Rechenzeichen:=Symbol; Scanner; I_Term;
                  CASE Rechenzeichen OF
                    Plus_BS  : CodPlusInt;
                    Minus_BS : CodMinusInt;
                    Or_BS    : CodOrBool;
                  END;
            END;
          IF Vorzeichen=Minus_BS THEN CodNegInt
         END
  END;

PROCEDURE I_Expression;
VAR Ex_Symbol: T_Basicsymbol;
BEGIN
  I_Ausdruck;
  IF InputRec.C_ok AND (Symbol IN [Gleich_BS,Ungleich_BS,Kleiner_BS,Kleinergleich_BS,Groesser_BS,Groessergleich_BS])
     THEN BEGIN
            Ex_Symbol:=Symbol; Scanner; I_Ausdruck;
            CodPulInt;                     (* 2. Operand in R0 *)
            CodWord(Pull_R1);              (* 1. Operand in R1 *)
            CASE Ex_Symbol OF
              Gleich_BS        :BEGIN CodWord($3100);  (* cmp/eq R0,R1 *)
                                      CodWord($0029);  (* movt   R0    *)
                                END;
              UnGleich_BS      :BEGIN CodWord($3100);  (* cmp/eq R0,R1 *)
                                      CodWord($0029);  (* movt   R0    *)
                                      CodWord($CA01);  (* xor    #1,R0 *)
                                END;
              Kleiner_BS       :BEGIN CodWord($3017);  (* cmp/gt R1,R0 *)
                                      CodWord($0029);  (* movt   R0    *)
                                END;
              KleinerGleich_BS :BEGIN CodWord($3013);  (* cmp/ge R1,R0 *)
                                      CodWord($0029);  (* movt   R0    *)
                                END;
              Groesser_BS      :BEGIN CodWord($3107);  (* cmp/gt R0,R1 *)
                                      CodWord($0029);  (* movt   R0    *)
                                END;
              GroesserGleich_BS:BEGIN CodWord($3103);  (* cmp/ge R0,R1 *)
                                      CodWord($0029);  (* movt   R0    *)
                                END;
            END;
            CodPushInt;
          END
END;

  PROCEDURE R_Ausdruck;
  VAR Rechenzeichen, Vorzeichen: T_Basicsymbol;
      Real_H,Real_L: Longint;

   PROCEDURE R_Term;
   VAR Rechenzeichen: T_Basicsymbol;

       PROCEDURE R_Faktor;
       VAR LuchsReal: T_LuchsReal;

         PROCEDURE PushIdent;
         VAR Adr: LongInt;
             RSymbol: T_Basicsymbol;
         BEGIN
           RSymbol:=Symbol;
           IF Symbol=S_Ident_BS THEN Error('Stringvariable verboten')
           ELSE BEGIN Push_Variable;
                      IF RSymbol IN [I_Ident_BS,I_Reg_BS]
                         THEN CodRuntime(R_IntFloat)
                END
         END;


       BEGIN (* R_Faktor *)
         CASE Symbol OF
            Klammerauf_BS: BEGIN Scanner; R_Ausdruck; Klammerzu_P END;

            Not_BS     : BEGIN Scanner; R_Faktor; CodRuntime(R_NotReal) END;
            I_Ident_BS,I_Reg_BS,R_Ident_BS,F_Ident_BS,S_Ident_BS   : PushIdent;
            I_Zahl_BS,
            R_Zahl_BS:     BEGIN IF Vorzeichen = Minus_BS
                                  THEN BEGIN ScanResult.Wert:=-Scanresult.Wert;
                                             Vorzeichen:=Plus_BS
                                       END;
                                 CodiereK_Real(ScanResult.Wert,2);
                                 CodPushReal;
                                 Scanner
                           END;
            ELSE RealFunktion_P(Symbol)
         END
       END;

  BEGIN   (* R_Term *)
     R_Faktor;
     WHILE Symbol IN [Mal_BS,Durch_BS,Div_BS,Mod_BS,AND_BS] DO
       BEGIN IF Symbol = Mod_BS THEN CodRuntime(R_FloatInt);
             Rechenzeichen:=Symbol; Scanner; R_Faktor;
             CASE Rechenzeichen OF
               Mal_BS : CodRuntime(R_FloatMult);
	       Durch_BS,
	       Div_BS : CodRuntime(R_FloatDiv);
               AND_BS : CodRuntime(R_AndReal);
               Mod_BS : BEGIN CodRuntime(R_FloatInt);
                              CodRuntime(R_IntMod);
                              CodRuntime(R_IntFloat);
                        END
             END
       END
   END;

  BEGIN        (* R_Ausdruck *)
   IF InputRec.C_ok
   THEN BEGIN
         IF Symbol = MINUS_BS
          THEN BEGIN Vorzeichen:=Minus_BS; Scanner END
          ELSE BEGIN Vorzeichen:=Plus_BS; IF Symbol = Plus_BS THEN Scanner END;
         R_Term;
         WHILE Symbol IN [Plus_BS, Minus_BS, OR_BS, Eor_BS] DO
           BEGIN Rechenzeichen:=Symbol; Scanner; R_Term;
                 CASE Rechenzeichen OF
                   Plus_BS  : CodRuntime(R_FloatAdd);
                   Minus_BS : CodRuntime(R_FloatSub);
                   OR_BS    : CodRuntime(R_OrReal);
                 END;
           END;
         IF Vorzeichen=Minus_BS THEN CodRuntime(R_NegReal)
        END
  END;

PROCEDURE R_Expression;
VAR Ex_Symbol: T_Basicsymbol;
BEGIN
  R_Ausdruck;
  IF Symbol IN [Gleich_BS,Ungleich_BS,Kleiner_BS,Kleinergleich_BS,Groesser_BS,Groessergleich_BS]
   THEN BEGIN
          Ex_Symbol:=Symbol; Scanner; R_Ausdruck;
          CodRuntime(R_FloatCmp);
          CodWord(Pull_R0);      (* Vorzeichen interessant *)
            CASE Ex_Symbol OF
              Gleich_BS        : CodWord($8800);       (* cmp/eq #0,R0 *)
              UnGleich_BS      : BEGIN CodWord($6007); (* not R0,R0    *)
                                       CodWord($2228); (* cmp/eq #0,R0 *)
                                 END;
              Kleiner_BS       : BEGIN CodWord($600B); (* neg R0,R0    *)
                                       CodWord($4015); (* cmp/pl R0    *)
                                 END;
              KleinerGleich_BS : BEGIN CodWord($600B); (* neg R0,R0    *)
                                       CodWord($4011); (* cmp/pz R0    *)
                                 END;
              Groesser_BS      : Codword($4015);       (* cmp/pl R0    *)
              GroesserGleich_BS: CodWord($4011);       (* cmp/pz R0    *)
            END;
            CodWord($E000);                            (* mov #0,R0    *)
            CodPushInt; CodPushInt;    (* falsch: Ergebnis 0 auf Stack *)
            CodWord($8B00);                            (* BF falsch    *)
            CodiereK_Long($3FF00000,0);           (* Eins -> R0   *)
            CodWord($2F02);                            (* mov.l R0,@R15*)
          END
END;

PROCEDURE S_Ausdruck;

  PROCEDURE Stringsummand;

    PROCEDURE PushKonst;
    VAR KonstStr: String[255];
        JmpAdr  : T_AdrInfo;
        i       : Integer;
    BEGIN
      KonstStr:='';
      WHILE (ord(InputRec.z) >= ord (' ')) AND (InputRec.z<>'"') DO
        BEGIN KonstStr:=KonstStr+InputRec.z; LiesZ END;
      Scanner;
      IF Symbol <> Str_BS THEN Error('" erwartet');
      CodiereK_Str(KonstStr);          (* mova  Konststr,R0   *)
      CodWord(Push_R0);                (* mov.l R0,@-R15      *)
      CodRuntime(R_StrPush);
      Scanner
    END;

{
    PROCEDURE Print_R;
      BEGIN
       R_Expression;
       IF Symbol = Back_BS
         THEN BEGIN Scanner;
                    I_Ausdruck;
                    IF Symbol=Back_BS
                       THEN BEGIN Scanner; I_Ausdruck;
                                  IF Symbol=Back_BS
                                     THEN BEGIN Scanner; I_Ausdruck END
                                     ELSE BEGIN CodWord($E001);   (* Auto *)
                                                CodWord(Push_R0)
                                          END;
                            END
                       ELSE BEGIN CodWord($E00C);   (* 12 Nachkomma *)
                                  CodWord(Push_R0);
                                  CodWord($E001);   (* Auto *)
                                  CodWord(Push_R0);
                            END;
             END
        ELSE BEGIN
               CodWord($E001);    (* Minlaenge *)
               CodWord(Push_R0);
               CodWord($E00C);    (* 12 Nachkommastellen *)
               CodWord(Push_R0);
               CodWord($E001);    (* Automatikflag *)
               CodWord(Push_R0);
             END;
     CodRuntime(R_RealZuStr);
     CodWord($E000);              (* mov #0,R0 *)
     CodWord(Push_R0);            (* keine weiteren Spaces voranstellen *)
     CodRuntime(R_WriteStr);
    END;
}
    PROCEDURE StrD_P;
    BEGIN
       Scanner;Klammerauf_P;R_Ausdruck;
       IF Symbol = Back_BS
         THEN BEGIN Scanner;
                    I_Ausdruck;
                    IF Symbol=Back_BS
                       THEN BEGIN Scanner; I_Ausdruck;
                                  IF Symbol=Back_BS
                                     THEN BEGIN Scanner; I_Ausdruck END
                                     ELSE BEGIN CodWord($E001);   (* Auto *)
                                                CodWord(Push_R0)
                                          END;
                            END
                       ELSE BEGIN CodWord($E00C);   (* 12 Nachkomma *)
                                  CodWord(Push_R0);
                                  CodWord($E001);   (* Auto *)
                                  CodWord(Push_R0);
                            END;
             END
        ELSE BEGIN
               CodWord($E001);    (* Minlaenge *)
               CodWord(Push_R0);
               CodWord($E00C);    (* 12 Nachkommastellen *)
               CodWord(Push_R0);
               CodWord($E001);    (* Automatikflag *)
               CodWord(Push_R0);
             END;
      Klammerzu_P;
      CodRuntime(R_RealZuStr)
    END;

    PROCEDURE MidD_P;
    BEGIN
      Scanner;Klammerauf_P;S_Ausdruck;Komma_P;I_Ausdruck;
      Komma_P;I_Ausdruck;Klammerzu_P;
      CodRuntime(R_StrCopy)
    END;

    PROCEDURE LeftRightStr_P(Ziel: T_Trap);
    BEGIN
      Scanner;Klammerauf_P;S_Ausdruck; Komma_P;I_Ausdruck;Klammerzu_P;
      CodRuntime(Ziel)
    END;

    PROCEDURE EEReadStr_P;
    BEGIN
      Scanner;Klammerauf_P;I_Ausdruck; Komma_P;I_Ausdruck;Klammerzu_P;
      CodRuntime(R_EEReadStr)
    END;

  BEGIN
    CASE Symbol OF
      Klammerauf_BS: BEGIN Scanner; S_Ausdruck; Klammerzu_P END;
      Str_BS       : PushKonst;
      S_Ident_BS   : Push_Variable;
      MidD_BS      : MidD_P;
      LeftD_BS     : LeftRightStr_P(R_StrLeft);
      RightD_BS    : LeftRightStr_P(R_StrRight);
      EEReadStr_BS : EEReadStr_P;
      StrD_BS      : StrD_P;
      ChrD_BS      : BEGIN Scanner; Klammerauf_P; I_Ausdruck; Klammerzu_P;
                           CodRuntime(R_StrChr);
                     END;
      ELSE Error('String erwartet')
    END
  END;

BEGIN
  IF InputRec.C_Ok
  THEN BEGIN
         StringSummand;
         WHILE Symbol=Plus_BS DO
           BEGIN Scanner; StringSummand; CodRuntime(R_StrConcat) END
       END
END;

PROCEDURE S_Expression;
VAR Ex_Symbol: T_Basicsymbol;
BEGIN
  S_Ausdruck;
  IF Symbol IN [Gleich_BS,Ungleich_BS,Kleiner_BS,Kleinergleich_BS,Groesser_BS,Groessergleich_BS]
     THEN BEGIN
           Ex_Symbol:=Symbol;
           Scanner; S_Ausdruck;
           CodRuntime(R_StrCmp);
           CodPulInt;            (* in R0 steht nun -1/0/+1 *)
           CASE Ex_Symbol OF
             Gleich_BS        :BEGIN CodWord($8800);  (* cmp/eq #0,R0 *)
                                     CodWord($0029);  (* movt R0      *)
                               END;
             UnGleich_BS      :BEGIN CodWord($8800);  (* cmp/eq #0,R0 *)
                                     CodWord($0029);  (* movt R0      *)
                                     CodWord($CA01);  (* xor #1,R0    *)
                               END;
             Kleiner_BS       :BEGIN CodWord($4011);  (* cmp/pz R0    *)
                                     CodWord($0029);  (* movt R0      *)
                                     CodWord($CA01);  (* xor #1,R0    *)
                               END;
             KleinerGleich_BS :BEGIN CodWord($4015);  (* cmp/pl R0    *)
                                     CodWord($0029);  (* movt R0      *)
                                     CodWord($CA01);  (* xor #1,R0    *)
                               END;
             Groesser_BS      :BEGIN CodWord($4015);  (* cmp/pl R0    *)
                                     CodWord($0029);  (* movt R0      *)
                               END;
             GroesserGleich_BS:BEGIN CodWord($4011);  (* cmp/pz R0    *)
                                     CodWord($0029);  (* movt R0      *)
                               END;
           END;
          CodPushInt;
          END
     ELSE Error('Vergleichsoperator erwartet')
END;

PROCEDURE I_Zuweisung;
VAR Adr:  LongInt;
    PSymbol: T_Basicsymbol;
    PName: T_Ident;
    DimVar: Boolean;
    DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
BEGIN
  PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
  IF Symbol = Klammerauf_BS
     THEN BEGIN DimVar:=True; Push_Dim_Adr(PName,PSymbol,DimL) END
     ELSE BEGIN HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                IF DimVar THEN Error('( erwartet')
          END;
  Gleich_P;
  IF InputRec.C_ok
    THEN BEGIN
           I_Expression;
           IF DimVar
              THEN BEGIN CodPulInt;
                         CodWord(Pull_R1);  (* Zieladresse  *)
                         CASE DimL OF
                           1: CodWord($2100);    (* mov.b R0,@R1 *)
                           2: CodWord($2101);    (* mov.w R0,@R1 *)
                           4: CodWord($2102);    (* mov.l R0,@R1 *)
                         END
                   END
	      ELSE IF PSymbol=I_Reg_BS
                      THEN IF Lastopcode=Pushint
                              THEN BEGIN Lastopcode:=Other;  (* mov R0,Rx *)
                                         CodWord($6003+$100*adr);
                                   END
                              ELSE CodWord($60F6+$100*Adr)       (* mov.l R15+,Rx *)
                      ELSE BEGIN CodPulInt;
                                 CodStoreInt(Adr,4);
                           END
         END
END;

PROCEDURE R_Zuweisung;
VAR Adr:  LongInt;
    PSymbol: T_Basicsymbol;
    PName: T_Ident;
    DimVar: Boolean;
    DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
BEGIN
  PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
  IF Symbol = Klammerauf_BS
     THEN BEGIN DimVar:=True; Push_Dim_Adr(PName,PSymbol,DimL) END
     ELSE BEGIN HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                IF DimVar THEN Error('( erwartet')
          END;
  Gleich_P;
  IF InputRec.C_ok
    THEN BEGIN
           R_Expression;
           CodPulReal;
           IF DimVar
              THEN BEGIN CodWord(Pull_R1); (* Zieladresse      *)
                         CodWord($2122);   (* mov.l R2,@R1     *)
                         CodWord($1131);   (* mov.l R3,(@4,R1) *)
                   END
              ELSE CodStoreReal(Adr);
         END
END;

PROCEDURE S_Zuweisung;
VAR DimL: LongInt;
BEGIN
  Push_Adr(DimL);     (* Zieladresse auf Stack *)
  Gleich_P;
  IF InputRec.C_ok
     THEN BEGIN S_Ausdruck;
                CodPushStrLaenge;
                {
                CodWord($E000+StrLaenge);   (* Maxlaenge auf Stack    *)
                IF StrLaenge>127 THEN CodWord($600C); (* EXTU.B R0,R0 *)
                CodPushInt;
                }
                CodRuntime(R_StrPull);      (* String an Ziel legen   *)
          END
END;

PROCEDURE Rem_P;
BEGIN WHILE NOT (InputRec.z IN [#0,#10,#13])
            AND NOT Ende DO Lies;
      Scanner
END;

PROCEDURE Gosub_P;
VAR Ziel,Abstand: LongInt;
BEGIN
  CodWord(Push_PR);
  Scanner;
  IF Symbol = I_Zahl_BS
     THEN BEGIN Str(Scanresult.Wert:1:0,Scanresult.Name);
                Symbol:=R_Ident_BS
          END;
  IF Symbol <> R_Ident_BS THEN Error('Labelname erwartet');
  IF L_vorhanden(Baum,Scanresult.Name,Symbol,Ziel)
    THEN BEGIN Abstand:=Ziel-Code.PC-4;
               IF Abstand >= -4090          (* pos. Werte hier unmoeglich *)
                  THEN BEGIN CodWord($B000 + ((Abstand shr 1) AND $FFF));
                             CodNop;         (* normaler Bsr rueckwaerts *)
                             CodPulPR;
                       END
                  ELSE BEGIN
                         IF Code.PC MOD 4 <> 0 THEN Codword(9);
                         Codword($C704);    (* MOVA Zielptr,R0 *)
                         CodWord($6102);    (* MOV.L @R0,R1 *)
                         CodWord($310C);    (* ADD R0,R1 *)
                         CodWord($410B);    (* JSR @R1 *)
                         CodWord($0009);    (* NOP *)
                         CodPulPR;
                         IF Code.PC MOD 4 <> 0 THEN Codword(9);
                         CodWord($A002);    (* Bra hinter Zielkonstante *)
                         CodNop;
                         CodLong(Ziel-Code.PC);
                       END
         END
    ELSE BEGIN
            IF Code.PC MOD 4 <> 0 THEN Codword(9);
            Codword($C703);    (* MOVA Zielptr,R0 *)
            CodWord($6102);    (* MOV.L @R0,R1 *)
            CodWord($310C);    (* ADD R0,R1 *)
            CodWord($410B);    (* JSR @R1 *)
            CodWord($0009);    (* NOP *)
            CodPulPR;
            CodWord($A002);    (* Bra hinter Zielkonstante *)
            CodWord($0009);    (* NOP *)
            Insertheaprein(Insertheap,Scanresult.Name,Code.PC,BasBsrl_T);
            CodLong(0);
         END;
  Scanner
END;

PROCEDURE Goto_P;
VAR Ziel,Abstand: LongInt;
BEGIN
  Scanner;
  IF Symbol = I_Zahl_BS
     THEN BEGIN Str(Scanresult.Wert:1:0,Scanresult.Name);
                Symbol:=R_Ident_BS
          END;
  IF Symbol <> R_Ident_BS THEN Error('Labelname erwartet');
  IF L_vorhanden(Baum,Scanresult.Name,Symbol,Ziel)
    THEN BEGIN Abstand:=Ziel-Code.PC-4;
               IF Abstand >= -4090          (* pos. Werte hier unmoeglich *)
                  THEN BEGIN CodWord($A000 + ((Abstand shr 1) AND $FFF));
                             CodNop         (* normaler Bra rueckwaerts *)
                       END
                  ELSE BEGIN
                         Codword($C702);    (* MOVA Zielptr,R0 *)
                         CodWord($6102);    (* MOV.L @R0,R1 *)
                         CodWord($310C);    (* ADD R0,R1 *)
                         CodWord($412B);    (* JMP @R1 *)
                         CodWord($0009);    (* NOP *)
                         IF Code.PC MOD 4 <> 0 THEN Codword(9);
                         CodLong(Ziel-Code.PC);
                       END
         END
    ELSE BEGIN
            IF Code.PC AND 2 = 0 THEN Codword(9);
            Codword($C702);    (* MOVA Zielptr,R0 *)
            CodWord($6102);    (* MOV.L @R0,R1 *)
            CodWord($310C);    (* ADD R0,R1 *)
            CodWord($412B);    (* JMP @R1 *)
            CodWord($0009);    (* NOP *)
            Insertheaprein(Insertheap,Scanresult.Name,Code.PC,BasBral_T);
            CodLong(0);
         END;
 Scanner; Ersetze_KS_Daten(Ohne_Branch)
END;

PROCEDURE ON_P;
VAR OSymbol: T_Basicsymbol;

   PROCEDURE ON_Liste;

     PROCEDURE On_Ziel;
     BEGIN
       Scanner;
       IF Symbol <> R_Ident_BS
          THEN Error('Zielname erwartet')
          ELSE Insertheaprein(Insertheap,Scanresult.Name,Code.PC,OnGoto_T);
       CodLong(0);
       Scanner
     END;

   BEGIN
     ON_Ziel;
     WHILE Symbol=Komma_BS DO ON_Ziel
   END;

  PROCEDURE Gotosub_P;
  VAR btPC,braPC,ListePC: LongInt;
      Anz : Word;
      Adr1,Adr2,Adr3: T_AdrInfo;
  BEGIN
    CodPulInt;          (* Nummer in R0 *)
    CodWord($70FF);     (* add  #-1,R0  *)
    CodWord($6103);     (* mov  R0,R1   *)
    LiesAdresse(Adr1); CodWord(0); (* spaeter: mov #Anz,R0 *)
    CodWord($3102);     (* cmp/hs R1,R0 *)
    BTPC:=Code.PC;
    LiesAdresse(Adr2); CodWord(0); (* spaeter: bt nachhinten *)
    CodWord($4108);     (* shll2 R1     *)
    CodWord($C702);     (* mova Liste,R0*)
    CodWord($310C);     (* add  R0,R1   R1 zeigt auf Listenwort *)
    CodWord($6012);     (* mov.l @R1,R0 *)
    BraPC:=Code.PC;
    LiesAdresse(Adr3); Codword(0); (* spaeter bra nachliste *)
    CodWord($301C);     (* add  R1,R0   *)
    IF Code.PC and 2=2 then CodNop;
    ListePC:=Code.PC;
    On_Liste;
    Anz:=(Code.PC-ListePC) shr 2;
    Ersetzeword($E000+anz,Adr1);          (* mov #Anz,R0     *)
    Ersetzeword($A000+((Code.PC-BraPC-4) shr 1),Adr3);  (* bra hinterliste *)
    IF OSymbol=Goto_BS
       THEN BEGIN Codword($402B); CodNop; (* jmp @R0 *) END
       ELSE BEGIN CodWord(Push_PR);
                  CodWord($400B); CodNop; (* jsr @R0 *)
                  CodWord(Pull_PR);
            END;
    Ersetzeword($8900+(((Code.PC-btPC-4) shr 1) AND $FF),Adr2);
  END;

BEGIN  (* ON_P *)
 Scanner; OSymbol:=Symbol;
 IF NOT (Symbol IN [I_Ident_BS,I_Reg_BS,R_Ident_BS])
   THEN Error('Variable erwartet')
   ELSE BEGIN
         Push_Variable;
         IF OSymbol = R_Ident_BS THEN CodRuntime(R_FloatInt);
         OSymbol:=Symbol;
         IF Symbol IN [goto_BS,gosub_BS]
            THEN gotosub_P
            ELSE Error('GOTO/GOSUB erwartet')
        END
END;

PROCEDURE Poke_P(W_B_speichern: Word);
VAR Ziel: Word;
BEGIN
 Scanner; I_Expression; Komma_P; I_Expression;
 CodPulInt;               (* Inhalt der Speicherstelle nach R0 *)
 CodWord(Pull_R1);        (* mov.l @R15+,R1   ;Adresse         *)
 CodWord(W_B_Speichern)   (* mov.b R0,@R1   bzw   mov.w R0,@R1 *)
END;


PROCEDURE LCDInit_P;
VAR Ziel: Word;
BEGIN
 Scanner; I_Expression; Komma_P; I_Expression; Komma_P; I_Expression;
 CodRuntime(R_LCDInit);
END;

PROCEDURE Bedingung_P;
VAR BSymbol: T_Basicsymbol;

  PROCEDURE BoolWert;
  BEGIN
    CASE Symbol OF
      Klammerauf_BS     : BEGIN Scanner; Bedingung_P; Klammerzu_P END;

      Peek_BS..WPeek_BS,
      I_Zahl_BS,
      I_Ident_BS,
      I_Reg_BS          : I_Expression;

      Sin_BS..Sqr_BS,
      R_Zahl_BS,
      R_Ident_BS        : BEGIN R_Expression; CodRuntime(R_FloatBool) END;

      ChrD_BS..MidD_BS,
      Str_BS,
      S_Ident_BS        : S_Expression;

      Not_BS            : BEGIN Scanner; BoolWert; CodNotBool END;

      ELSE Error('Bedingung erwartet')
    END;
  END;

  PROCEDURE BoolProdukt;
  BEGIN
    BoolWert;
    WHILE Symbol = And_BS DO BEGIN Scanner; BoolWert; CodAndBool; END
  END;

BEGIN (* Bedingung_P *)
  Plus_Menge:=[Plus_BS,Minus_BS];
  Mal_Menge:=[Mal_BS,Durch_BS,DIV_BS,MOD_BS];
  BoolProdukt;
  WHILE Symbol = Or_BS DO
    BEGIN Scanner; BoolProdukt; CodOrBool END;
  Plus_Menge:=[Plus_BS,Minus_BS,OR_BS];
  Mal_Menge:=[Mal_BS,Durch_BS,AND_BS,DIV_BS,MOD_BS];
END;

PROCEDURE SetzeBralBedingung(Opcode: Word;
                    VAR Adr1,Adr2: T_AdrInfo;
                    VAR BraLPC: LongInt);
BEGIN
  IF Code.PC AND 2 = 2 THEN CodNop;
  CodWord(Opcode+6);    (* bf/bt -> *)
  BraLPC:=Code.PC;
  LiesAdresse(Adr1);
  CodLong($C7026102);     (* MOVA Ziel,R0  MOV.L @R0,R1 *)
  CodLong($310C412B);     (* ADD R0,R1     JMP @R1      *)
  CodNop;
  LiesAdresse(Adr2); (* hier spaeter Offset einsetzen *)
  CodLong($00090009);     (* 2 NOP *)
END;

PROCEDURE SetzeBral(VAR Adr1,Adr2: T_AdrInfo;
                    VAR BraLPC: LongInt);
BEGIN
  IF Code.PC and 2 = 0 THEN Codnop;
  BraLPC:=Code.PC;
  LiesAdresse(Adr1); (* evtl. spaeter normalen Branch einbauen *)
  CodLong($C7026102);     (* MOVA Ziel,R0  MOV.L @R0,R1 *)
  CodLong($310C412B);     (* ADD R0,R1     JMP @R1      *)
  CodNop;
  IF Code.PC and 2 = 2 THEN Codnop;
  LiesAdresse(Adr2); (* hier spaeter Offset einsetzen *)
  CodLong($00090009);     (* 2 NOP *)
END;

PROCEDURE ErsetzeBraL(BraLPC: LongInt; VAR Adr1,Adr2: T_AdrInfo);
VAR Distanz: LongInt;
BEGIN
  Distanz:=Code.PC-BraLPC-4;
  IF Distanz<= 4090
     THEN Ersetzelong((($A000+(Distanz shr 1))shl 8)shl 8+$0009,Adr1)
     ELSE ersetzeLong(Code.PC-BraLPC-10,Adr2);
END;

PROCEDURE CodBraBack(Ziel: Longint);
VAR Distanz: LongInt;
BEGIN
  Distanz:=Ziel-Code.PC-4;
  IF Distanz >= -4090
     THEN BEGIN CodWord($A000+((Distanz shr 1) AND $FFF));
                CodNop;
          END
     ELSE BEGIN CodLong($C7026102);     (* MOVA Ziel,R0  MOV.L @R0,R1 *)
                CodLong($310C412B);     (* ADD R0,R1     JMP @R1      *)
                CodNop;
                IF Code.PC and 2 = 2 THEN Codnop;
                CodLong(Ziel-Code.PC)
          END;
END;

PROCEDURE CodBraBackBed(Ziel: Longint);
VAR Distanz: Longint;
BEGIN
  CodWord($2008);    (* TST R0,R0 *)
  Distanz:=Ziel-Code.PC-4;
  IF Distanz > -128
     THEN CodWord($8900 + ((Distanz shr 1) AND $FF)) (* BT zurueck *)
     ELSE IF Distanz > -4090
             THEN BEGIN CodWord($8B01);   (* BF hinter BRA *)
                        CodWord($A000+(((Distanz-2) shr 1) AND $FFF));
                        CodNOP
                  END
             ELSE BEGIN IF Code.PC AND 2 = 2 THEN CodNOP;
                        CodWord($8B06);         (* BF -> *)
                        CodLong($C7026102);     (* MOVA Ziel,R0  MOV.L @R0,R1 *)
                        CodLong($310C412B);     (* ADD R0,R1     JMP @R1      *)
                        CodNop;
                        CodLong(Ziel-Code.PC)
                  END
END;


PROCEDURE IFAnweisung_P;
VAR ThenPC,ElsePC: LongInt;
    Thenadr1,ThenAdr2,Elseadr1,ElseAdr2: T_Adrinfo;
    Lastsymbol,IfSymbol: T_Basicsymbol;
BEGIN
  IfSymbol:=Symbol;
  IF Symbol=If_BS THEN Lastsymbol:=Nolist_BS ELSE Lastsymbol:=Zeilenende_BS;
  Scanner; Bedingung_P;
  IF IfSymbol=Ifl_BS THEN WHILE Symbol=Zeilenende_BS DO Scanner;
  IF Symbol <> Then_BS
    THEN Error ( 'THEN erwartet')
    ELSE BEGIN
          CodPulInt;
          CodWord($2008);    (* tst R0,R0 *)
          SetzeBraLBedingung($8B00,ThenAdr1,ThenAdr2,ThenPC);
          scanner;
          WHILE Symbol IN [ListP_BS..LastSymbol] DO Anweisung_P;
          IF Symbol = Else_BS
            THEN BEGIN
                  TestPush;
                  SetzeBraL(ElseAdr1,ElseAdr2,ElsePC);
                  ErsetzeBraL(ThenPC,ThenAdr1,ThenAdr2);
                  Scanner;
                  WHILE Symbol IN [ListP_BS..Lastsymbol] DO Anweisung_P;
                  ErsetzeBraL(ElsePC,Elseadr1,ElseAdr2);
                 END
            ELSE ErsetzeBraL(ThenPC,ThenAdr1,ThenAdr2);
          IF (Lastsymbol=Zeilenende_BS) AND (Symbol <> Endif_BS)
            THEN Error('ENDIF erwartet') ELSE Scanner
         END
END;

PROCEDURE WhileAnweisung_P;
VAR Whileadr,BralPC: LongInt;
    Adr1,Adr2      : T_Adrinfo;
BEGIN
  TestPush;
  Whileadr:=Code.PC;
  Scanner; Bedingung_P;
  CodPulInt;
  CodWord($2008);    (* tst R0,R0 *)
  SetzeBralBedingung($8B00,Adr1,Adr2,BraLPC);
  WHILE Symbol IN [ListP_BS..Zeilenende_BS] DO Anweisung_P;
  TestPush;
  CodBraBack(WhileAdr);
  ErsetzeBraL(BraLPC,Adr1,Adr2);
  IF (Symbol <> Wend_BS) THEN Error('WEND erwartet');
  scanner
END;

PROCEDURE RepeatAnweisung_P;
VAR Repeatadr: Longint;
BEGIN
 Repeatadr:=Code.PC;
 Scanner;
 WHILE Symbol IN [ListP_BS..Zeilenende_BS] DO anweisung_P;
 IF Symbol <> Until_BS
  THEN Error('UNTIL erwartet')
  ELSE BEGIN Scanner; Bedingung_P;
             CodPULInt;
             CodBraBackBed(Repeatadr);
       END
END;

PROCEDURE FOR_Real;
VAR EndVar,StepVar,Laenge,ForPC,BraLPC,z_Adr: LongInt;
    Adr1,Adr2: T_AdrInfo;
    VarName: T_Ident;
    DimVar,Step: Boolean;
    Dummy : LongInt;
    Z_Symbol: T_Basicsymbol;

  PROCEDURE For_TO_Step;
  BEGIN
   scanner; R_Expression;
   EndVar:=Varzeiger; Inc(Varzeiger,8);
   CodPulReal;
   CodStoreReal(EndVar);
   IF Symbol = Step_BS
     THEN BEGIN StepVar:=VarZeiger; Inc(Varzeiger,8);
                scanner; R_Expression; Step:=True;
                CodPulReal; CodStoreReal(StepVar);
          END
     ELSE Step:=False;
  END;

BEGIN
    VarName:=Scanresult.Name; z_Symbol:=R_Ident_BS;
    HolAdr(VarName,Z_Symbol,z_Adr,DimVar,Dummy,Dummy,Dummy,Dummy,Dummy);
    scanner; Gleich_P; R_Expression;
    CodPulReal; CodStoreReal(z_Adr);
    IF Symbol <> TO_BS
      THEN Error('TO erwartet')
      ELSE BEGIN
            For_To_Step;
            ForPC:=Code.PC;
            CodLoadPushRealVar(z_Adr);
            CodLoadPushRealVar(EndVar);
            CodRuntime(R_FloatSub);             (* Zaehl-End             *)
            CodPulReal;                         (* Vorzeichen/Exp. in R2 *)
            (* moegliche Resultate: R2=0, R2 Negativ, R2 positiv         *)
            IF Step
             THEN
              BEGIN CodLoadIntVar(StepVar,3);   (* Schrittweite in R3    *)
                                                (* hier: nur Vorzeichen  *)
                    CodWord($4311);             (* cmp/pz R3             *)
                    CodWord($8900);             (* wenn positiv          *)
                    CodWord($622B);             (* neg R2,R2             *)
                    CodWord($4215);             (* cmp/pl R2             *)
              END
             ELSE CodWord($4215);               (* cmp/pl R2             *)
            SetzeBralBedingung($8B00,Adr1,Adr2,BraLPC);
            WHILE Symbol IN [ListP_BS..Zeilenende_BS] DO Anweisung_P;
            IF Step THEN CodLoadPushRealVar(StepVar)
                    ELSE BEGIN CodiereK_Real(1,2); CodPushReal END;
            CodLoadPushRealVar(Z_Adr);   (* Zaehlvar.     *)
            CodRuntime(R_FloatAdd);
            CodPulReal;
            CodStoreReal(Z_Adr);         (* neue Zaehlv.  *)
            CodBraBack(ForPC);
            ErsetzeBraL(BraLPC,Adr1,Adr2);
            IF Symbol <> Next_BS
             THEN Error('NEXT erwartet')
             ELSE BEGIN Scanner;   (* Next wegscannen *)
                        IF Symbol = R_Ident_BS
                         THEN IF Scanresult.Name <> VarName
                               THEN Error('NEXT '+Varname+' erwartet')
                               ELSE scanner
                  END
           END
END;

PROCEDURE For_Integer;
VAR EndVar,StepVar,Laenge,ForPC,BraLPC,z_Adr: LongInt;
    Adr1,Adr2: T_AdrInfo;
    VarName: T_Ident;
    DimVar,Step: Boolean;
    Dummy : LongInt;
    Z_Symbol: T_Basicsymbol;

  PROCEDURE For_TO_Step;
  BEGIN
   scanner; I_Expression;
   EndVar:=Varzeiger; Inc(Varzeiger,4);
   CodPulInt;
   CodStoreInt(EndVar,4);
   IF Symbol = Step_BS
     THEN BEGIN StepVar:=VarZeiger; Inc(Varzeiger,4);
                scanner; I_Expression; Step:=True;
                CodPulInt; CodStoreInt(StepVar,4);
          END
     ELSE Step:=False;
  END;

  PROCEDURE LoadZ_Var(ZielReg: Word);
  BEGIN
    IF Z_Symbol=I_Ident_BS
           THEN CodLoadIntVar(z_Adr,ZielReg)  (* Zaehlvariable *)
           ELSE CodWord($6003+$10*Z_adr);     (* RegisterVar.  *)
  END;

BEGIN
    VarName:=Scanresult.Name; z_Symbol:=I_Ident_BS;
    HolAdr(VarName,Z_Symbol,z_Adr,DimVar,Dummy,Dummy,Dummy,Dummy,Dummy);
    scanner; Gleich_P; I_Expression;
    IF Z_Symbol=I_Reg_BS
       THEN BEGIN CodPulInt; CodWord($6003+$100*z_adr) end
       ELSE BEGIN CodPulInt; CodStoreInt(z_Adr,4) end;
    IF Symbol <> TO_BS
      THEN Error('TO erwartet')
      ELSE BEGIN
            For_To_Step;
            ForPC:=Code.PC;
            LoadZ_Var(0);                      (* ZaehlVar. in R0    *)
            CodLoadIntVar(EndVar,2);           (* Endwert in R2      *)
            IF Step
             THEN
              BEGIN CodLoadIntVar(StepVar,3);   (* Schrittweite in R3 *)
                    CodWord($4315);             (* cmp/pl R3          *)
                    CodWord($8901);             (* wenn positiv       *)
                    CodWord($A001);             (* Bra Auswertung     *)
                    CodWord($3023);     (* vorher: cmp/ge R2,R0       *)
                    CodWord($3203);             (* cmp/ge R0,R2       *)
              END
             ELSE CodWord($3203);               (* cmp/ge R0,R2       *)
            SetzeBralBedingung($8900,Adr1,Adr2,BraLPC);
            WHILE Symbol IN [ListP_BS..Zeilenende_BS] DO Anweisung_P;
            IF Step
             THEN IF Z_Symbol=I_Ident_BS
                    THEN BEGIN
                               CodLoadIntVar(StepVar,2); (* Schrittweite in R2 *)
                               LoadZ_Var(0);             (* Zaehlvar. in R0  *)
                               CodWord($302C);           (* add r2,r0        *)
                               CodStoreInt(Z_Adr,4);
                         END
                    ELSE BEGIN CodLoadIntVar(StepVar,2); (* Schrittweite *)
                               CodWord($302C+$100*Z_Adr);(* add r2,rx    *)
                         END
             ELSE IF Z_Symbol=I_Ident_BS
                     THEN BEGIN LoadZ_Var(0);
                                CodWord($7001);       (* add #1,R0       *)
                                CodStoreInt(Z_Adr,4);
                          END
                     ELSE CodWord($7001+$100*Z_adr);
            CodBraBack(ForPC);
            ErsetzeBraL(BraLPC,Adr1,Adr2);
            IF Symbol <> Next_BS
             THEN Error('NEXT erwartet')
             ELSE BEGIN Scanner;   (* Next wegscannen *)
                        IF (Symbol IN [I_Ident_BS,I_Reg_BS])
                         THEN IF Scanresult.Name <> VarName
                               THEN Error('NEXT '+Varname+' erwartet')
                               ELSE scanner
                  END
           END
END;

PROCEDURE FOR_P;
BEGIN
 Scanner;
 IF (Symbol IN[I_Reg_BS,I_Ident_BS]) THEN For_Integer
 ELSE IF Symbol=R_Ident_BS THEN For_Real
 ELSE Error('Zahlvariable erwartet')
END;

PROCEDURE StoreLabel(VAR Baum  : T_Baum;   Name : T_Ident;
                         Symbol: T_Basicsymbol; LWert:LongInt);
VAR Dummy: LongInt;
    Dummysymbol: T_Basicsymbol;
BEGIN
  IF L_vorhanden(Baum,Name,Dummysymbol,Dummy)
    THEN CASE Symbol OF
          Data_BS     : Error('Data-Label '+Name+' bereits belegt');
          L_Ident_BS  : Error('Label '+Name+' bereits belegt');
          ZNR_Ident_BS: Error('Zeilennummer '+Name+' doppelt');
         END
    ELSE Labelrein(Baum,Name,Symbol,LWert)
END;

PROCEDURE Interrupt_P;
VAR Dummysymbol: T_Basicsymbol; Dummy: Longint;
BEGIN
  Scanner;
  IF Symbol <> R_Ident_BS
   THEN Error('Labelname erwartet')
   ELSE IF L_vorhanden(Baum,Scanresult.Name,Dummysymbol,dummy)
         THEN Error('Label <'+Scanresult.Name+'> bereits vorhanden')
         ELSE IF InputRec.z <> ':'
               THEN Error('Doppelpunkt erwartet')
               ELSE BEGIN Labelrein(Baum,Scanresult.Name,L_Ident_BS,Code.PC);
                          StoreIrqReg;
                          Scanner
                    END
END;

PROCEDURE LR_Zuweisung;
VAR Wert: Word;
    LName: T_Ident;
BEGIN
  LName:=Scanresult.Name;
  IF InputRec.z <> ':'
     THEN R_Zuweisung
     ELSE BEGIN LiesZ; Scanner;
                IF Symbol=Data_BS
                   THEN Storelabel(baum,LName,Data_BS,DataSchlange.Laenge)
                   ELSE Storelabel(Baum,LName,L_Ident_BS,Code.PC)
          END
END;

PROCEDURE Zeilenanfang_P;
VAR ZNr: T_Ident;
BEGIN
  Scanner;
  IF Symbol = I_Zahl_BS
   THEN BEGIN Str(Scanresult.Wert:1:0,ZNr);
              Storelabel(Baum,ZNr,Znr_Ident_BS,Code.PC); Scanner
        END
END;

PROCEDURE Print_Str;
BEGIN
  S_Ausdruck;
  IF Symbol=Back_BS
    THEN BEGIN Scanner; I_Ausdruck END
    ELSE BEGIN CodWord($E000);   (* mov #0,R0 *)
               CodWord(Push_R0);
         END;
  CodRuntime(R_WriteStr)
END;

PROCEDURE Print_P;
VAR Wrln: Boolean;

  PROCEDURE Print;

    PROCEDURE Print_I;
      BEGIN
       I_Expression;
       IF Symbol = Back_BS
         THEN BEGIN Scanner;     (* evtl. Spaces voranstellen *)
                    I_Ausdruck;
             END
        ELSE BEGIN  CodWord($E000);   (* mov #0,R0 *)
                    CodWord(Push_R0)  (* sonst keine Spaces voranstellen *)
             END;
     CodRuntime(R_IntZuStr);
     CodWord($E000);                  (* mov #0,R0 *)
     CodWord(Push_R0);                (* keine weiteren Spaces voranstellen *)
     CodRuntime(R_WriteStr);
    END;


    (* Print_I kann entfallen, wenn Print_R fertiggestellt ist *)

    PROCEDURE Print_R;
      BEGIN
       R_Expression;
       IF Symbol = Back_BS
         THEN BEGIN Scanner;
                    I_Ausdruck;
                    IF Symbol=Back_BS
                       THEN BEGIN Scanner; I_Ausdruck;
                                  IF Symbol=Back_BS
                                     THEN BEGIN Scanner; I_Ausdruck END
                                     ELSE BEGIN CodWord($E001);   (* Auto *)
                                                CodWord(Push_R0)
                                          END;
                            END
                       ELSE BEGIN CodWord($E00C);   (* 12 Nachkomma *)
                                  CodWord(Push_R0);
                                  CodWord($E001);   (* Auto *)
                                  CodWord(Push_R0);
                            END;
             END
        ELSE BEGIN
               CodWord($E001);    (* Minlaenge *)
               CodWord(Push_R0);
               CodWord($E00C);    (* 12 Nachkommastellen *)
               CodWord(Push_R0);
               CodWord($E001);    (* Automatikflag *)
               CodWord(Push_R0);
             END;
     CodRuntime(R_RealZuStr);
     CodWord($E000);              (* mov #0,R0 *)
     CodWord(Push_R0);            (* keine weiteren Spaces voranstellen *)
     CodRuntime(R_WriteStr);
    END;

    PROCEDURE Print_SPC;
    BEGIN
      Scanner; Klammerauf_P; I_Ausdruck; Klammerzu_P;
      CodPulInt;      (* Anzahl in R0 *)
      CodWord($6303); (* mov R0,R3 *)
      CodWord($2338); (* TST R3,R3 *)
      CodWord($8903); (* BT  dahinter *)
      CodWord($E220); (* mov #' ',R2 *)
      CodWord($C322); (* Trapa #$22 ; direkte Ausgabe *)
      CodWord($AFFA); (* Bra zu tst R3,R3 *)
      CodWord($73FF); (* vorher: add #-1,R3 *)
    END;

  BEGIN  (* Print *)
   CASE Symbol OF
     Peek_BS..WPeek_BS,I_Zahl_BS,I_Ident_BS,I_Reg_BS : Print_I;
     Sin_BS..Sqr_BS,R_Ident_BS,R_Zahl_BS             : Print_R;
     ChrD_BS..MidD_BS,S_Ident_BS,Str_BS              : Print_Str;
     Spc_BS                                          : Print_Spc;
     ELSE Error('Symbol kann nicht gedruckt werden')
    END
   END;

BEGIN
  Scanner;
  WHILE Symbol IN [R_Ident_BS,I_Reg_BS,I_Ident_BS,I_Zahl_BS,R_Zahl_BS,
                   S_Ident_BS,Str_BS,Semikolon_BS,
                   Spc_BS,sin_BS..MidD_BS] DO
    IF Symbol = Semikolon_BS
       THEN BEGIN WrLN:= False; Scanner END
       ELSE BEGIN WrLn:= True ; Print END;
  IF WrLn THEN CodRuntime(R_Writeline)
END;

PROCEDURE Input_P;
VAR Adr: LongInt;

  PROCEDURE Input_Proc;

   PROCEDURE I_Input;
   VAR Adr:  LongInt;
       PSymbol: T_Basicsymbol;
       PName: T_Ident;
       DimVar: Boolean;
       DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
   BEGIN
    PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
    IF Symbol = Klammerauf_BS
     THEN BEGIN DimVar:=True; Push_Dim_Adr(PName,PSymbol,DimL) END
     ELSE BEGIN HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                IF DimVar THEN Error('( erwartet')
          END;
    CodRuntime(R_ReadString);
    CodRuntime(R_StrZuReal);
    CodRuntime(R_FloatInt);
    IF DimVar
       THEN BEGIN CodWord(Pull_R0);
                  CodWord(Pull_R1);  (* Zieladresse  *)
                  CASE DimL OF
                       1: CodWord($2100);    (* mov.b R0,@R1 *)
                       2: CodWord($2101);    (* mov.w R0,@R1 *)
                       4: CodWord($2102);    (* mov.l R0,@R1 *)
                  END
            END
       ELSE IF PSymbol=I_Reg_BS
               THEN IF Lastopcode=Pushint
                       THEN BEGIN Lastopcode:=Other;  (* mov R0,Rx *)
                                  CodWord($6003+$100*adr);
                            END
                       ELSE CodWord($60F6+$100*Adr)       (* mov.l R15+,Rx *)
               ELSE BEGIN CodWord(Pull_R0); CodStoreInt(Adr,4) END
   END;


   PROCEDURE R_Input;
   VAR Adr:  LongInt;
       PSymbol: T_Basicsymbol;
       PName: T_Ident;
       DimVar: Boolean;
       DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
   BEGIN
     PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
     IF Symbol = Klammerauf_BS
        THEN BEGIN DimVar:=True; Push_Dim_Adr(PName,PSymbol,DimL) END
        ELSE BEGIN HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                   IF DimVar THEN Error('( erwartet')
             END;
     CodRuntime(R_ReadString);
     CodRuntime(R_StrZuReal);
     CodPulReal;
     IF DimVar
        THEN BEGIN CodWord(Pull_R1); (* Zieladresse      *)
                   CodWord($2122);   (* mov.l R2,@R1     *)
                   CodWord($1131);   (* mov.l R3,(@4,R1) *)
             END
        ELSE CodStoreReal(Adr);
    END;

    PROCEDURE S_Input;
    VAR DimL: Longint;
    BEGIN
      Push_Adr(DimL);
      CodRuntime(R_ReadString);
      CodPushStrLaenge;
      {
      CodWord($E000+StrLaenge);
      IF StrLaenge>127 THEN CodWord($600C); (* EXTU.B R0,R0 *)
      CodPushInt;
      }
      CodRuntime(R_StrPull)
    END;

  BEGIN
        IF Symbol = S_Ident_BS THEN S_Input
   ELSE IF Symbol = R_Ident_BS THEN R_Input
   ELSE IF Symbol = I_Ident_BS THEN I_Input
   ELSE IF Symbol = I_Reg_BS THEN I_Input
   ELSE Error('Variablenname erwartet')
  END;

BEGIN (* Input_P *)
  Scanner;
  IF Symbol = Str_BS THEN Print_Str;
  IF Symbol = Semikolon_BS THEN Scanner;
  Input_Proc; WHILE Symbol = Komma_BS DO BEGIN Scanner; Input_proc END
END;

PROCEDURE Get_P;
VAR DimL: LongInt;
BEGIN
  Scanner;
  IF Symbol <> S_Ident_BS
     THEN Error('Stringvariable erwartet')
     ELSE BEGIN Push_Adr(DimL);
                CodRuntime(R_ReadChr);
                CodPulInt;                          (* Zeichen in R0 *)
                CodWord(Pull_R1);                   (* Stringadresse *)
                CodWord($2101);                     (* mov.w R0,@R1  *)
                CodWord($E001);                     (* mov #1,R0     *)
                CodWord($2100);                     (* mov.b R0,@R1  *)
          END
END;

PROCEDURE Let_P;
BEGIN
  Scanner;
       IF (Symbol = I_Ident_BS) OR (Symbol=I_Reg_BS) THEN I_Zuweisung
  ELSE IF Symbol = R_Ident_BS THEN R_Zuweisung
  ELSE IF Symbol = S_Ident_BS THEN S_Zuweisung
  ELSE    Error('Zuweisung erwartet')
END;

PROCEDURE Data_P;
VAR AdrInfo: T_AdrInfo;

  PROCEDURE Data;
  VAR Datastring: String[255];
      i: Integer;
      Negativ: Boolean;
  BEGIN
   Negativ:=Symbol=Minus_BS; IF Negativ THEN Scanner;
   IF (Symbol = I_Zahl_BS) OR (SymboL = R_Zahl_BS)
     THEN BEGIN IF negativ THEN Scanresult.Wert:=-Scanresult.Wert;
		CodiereDataReal(Scanresult.Wert,DataSchlange)
          END
     ELSE IF (Symbol = Str_BS) AND NOT Negativ
           THEN BEGIN
                 DataString:='';
                 WHILE (ord(InputRec.z) >= ord (' ')) AND (InputRec.z<>'"') DO
                   BEGIN DataString:=DataString+InputRec.z; LiesZ END;
                 Scanner;
                 IF Symbol <> Str_BS THEN Error('" erwartet');
		 CodiereDataString(DataString,dataSchlange)
                END
           ELSE Error('Konstante erwartet');
   Scanner
  END;

BEGIN (* Data_P *)
  Scanner; Data;
  WHILE Symbol = Komma_BS DO BEGIN Scanner; Data END
END;

PROCEDURE Read_P;

 PROCEDURE Read;
 BEGIN
  IF (Symbol IN [I_Reg_BS, I_Ident_BS])
   THEN CodReadInt
   ELSE IF Symbol = R_Ident_BS
         THEN CodReadReal
         ELSE IF Symbol = S_Ident_BS
               THEN CodReadString
               ELSE Error('read: Variablenname erwartet')
 END;

BEGIN (* Read_P *)
  Scanner; Read; WHILE Symbol = Komma_BS DO BEGIN Scanner; Read END;
END;

PROCEDURE Register_P(VAR RegNr: Word);


 PROCEDURE Register;
 VAR Dummysymbol: T_Basicsymbol;
     Adr: Longint;
 BEGIN
  IF Symbol = I_Ident_BS
   THEN BEGIN IF RegNr>Endreg THEN Error('Zu viele Registervariable');
              IF L_vorhanden(Baum,Scanresult.Name,Dummysymbol,Adr)
                 THEN Error('Name <'+Scanresult.name+'> schon vorhanden')
                 ELSE Labelrein(Baum,Scanresult.Name,I_Reg_BS,RegNr);
              Inc(RegNr);
        END
      ELSE Error('Integername erwartet');
  Scanner
 END;

BEGIN
  Scanner; Register; WHILE Symbol=Komma_BS DO BEGIN Scanner;Register END
END;

PROCEDURE Restore_P;
VAR Ziel: Word;
BEGIN
  IF Code.PC AND 2 = 0 THEN Codnop;
  CodWord($C32B);     (* .moval Ziel,R0 *)
  Scanner;
  IF Symbol = R_Ident_BS
    THEN Insertheaprein(Insertheap,Scanresult.Name,Code.PC,moval_T)
    ELSE Error('Labelname erwartet');
  CodLong(0);
  CodStoreInt(Datazeiger,4);  (* AddReg=Datazeiger *)
  Scanner
END;

PROCEDURE Dim_P;
VAR Dimname: T_Ident;
    DimSymbol: T_Basicsymbol;
    Dimlaenge,Dimension,Dim1,Dim2,Dim3,Adr: LongInt;

  PROCEDURE TestDimWert;
  BEGIN
   IF (Symbol <> I_Zahl_BS) OR (Scanresult.Wert < 0)
     THEN Error('positive Integer-Zahl erwartet');
  END;

BEGIN   (* Dim_P *)
  Scanner; DimName:=Scanresult.Name; DimSymbol:=Symbol; Dim2:=0; Dim3:=0; Dimension:=1;
  IF (Symbol <> I_Ident_BS) AND (Symbol <> R_Ident_BS) AND (Symbol <> S_Ident_BS)
    THEN Error('Variablenname erwartet')
    ELSE BEGIN
          IF Symbol=I_Ident_BS THEN Dimlaenge:=4;
          IF Symbol=R_Ident_BS THEN Dimlaenge:=8;
          IF Symbol=S_Ident_BS THEN Dimlaenge:=Strlaenge (* AND $FC +4 *);
          IF L_vorhanden(Baum,DimName,Symbol,Adr)
            THEN Error('Variablenname '+Scanresult.Name+' bereits verwendet');
          Scanner; IF Symbol <> Klammerauf_BS THEN Error('( erwartet')
         END;
  IF InputRec.C_ok
     THEN BEGIN
           Scanner;
           TestDimWert;
           Dim1:=Trunc(Scanresult.Wert);
           Scanner;
           IF Symbol=Komma_BS
            THEN BEGIN
                  Scanner;
                  TestDimWert;
                  Dimension:=2; Dim2:=Trunc(Scanresult.Wert); Scanner;
                  IF Symbol = Komma_BS
                   THEN BEGIN Scanner; TestDimWert;
                              Dimension:=3; Dim3:=Trunc(Scanresult.Wert); Scanner
                        END
                 END;
           Klammerzu_P
          END;
  IF Dimlaenge = 4          (* evtl. Byte oder Word Feld *)
     THEN IF Symbol = Word_BS
             THEN BEGIN Dimlaenge:=2; Scanner END
             ELSE IF Symbol = Byte_BS THEN BEGIN Dimlaenge:=1; Scanner END;
  IF InputRec.C_ok
     THEN BEGIN
            DimHeapRein(Dimheap,Dimname,Dimlaenge,Dimension,Dim1,Dim2,Dim3);
            Adr:=Varzeiger;
            Varzeiger:=Varzeiger+DimLaenge*(Dim1+1)*(Dim2+1)*(Dim3+1);
            Labelrein(Baum,DimName,DimSymbol,Adr)
          END;
  WHILE VarZeiger AND 3 <> 0 DO Inc(Varzeiger);
END;

PROCEDURE Call_P;
BEGIN
   CodPushPR;
   Scanner; I_Ausdruck;
   CodPulInt;       (* Unterprogrammadresse in R0 *)
   CodWord($400B);  (* JSR @R0      *)
   CodNOP;
   CodPulPR
END;

PROCEDURE Gotoxy_P(Ziel: T_Trap);
BEGIN
  Scanner; I_Ausdruck; Komma_P; I_Ausdruck;
  CodRuntime(Ziel)
END;

PROCEDURE Delay_P(R_Ziel: T_Trap);
BEGIN
  Scanner; I_Ausdruck; CodRuntime(R_Ziel);
END;

PROCEDURE Org_P;
BEGIN
  Scanner;
  IF Symbol = I_Zahl_BS
     THEN Code.Startadresse:=(I_Wert(Scanresult.wert)+3) AND $FFFFFFFC
     ELSE Error('ORG Integerzahl erwartet');
  Scanner
END;

PROCEDURE Assembler_P;
VAR AssBezBaum: T_AssBezBaum;
BEGIN
  Ersetze_KS_Daten(Mit_Branch);
  WHILE NOT (InputRec.z IN [#0,#13]) DO LiesZ;
  IF InputRec.z <> #13
     THEN Error('neue Zeile erwartet')
     ELSE asmSH7000(Basicass,Ende,List,Baum,AssBezBaum, Insertheap,
                    VarZeiger);
  Scanner;
END;

PROCEDURE Read_Set_Clock_P(T_Ziel: T_Trap);
VAR Adr: LongInt;
BEGIN
  Scanner;
  IF Symbol <> I_Ident_BS
    THEN Error('Integer-Feld erwartet')
    ELSE IF NOT L_Vorhanden(Baum,Scanresult.Name,Symbol,Adr)
          THEN Error('ARRAY '+Scanresult.Name+' unbekannt')
          ELSE BEGIN Codiere_Adr(Adr,0);
                     CodPushInt;
                     CodRuntime(T_Ziel)
               END;
  Scanner
END;

PROCEDURE Inc_Dec_P(incr: Boolean);
VAR Adr,IncWert: LongInt;
    PSymbol    : T_Basicsymbol;
    PName      : T_Ident;
    DimVar     : Boolean;
    DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
BEGIN
  IncWert:=1; Scanner;
  IF NOT (Symbol IN [I_Reg_BS,I_Ident_BS])
    THEN Error('Integer-Variable erwartet')
    ELSE BEGIN
          PSymbol:=Symbol; PName:=Scanresult.Name; Scanner;
          IF Symbol = Klammerauf_BS THEN Error('Keine Dim-Variable erlaubt')
          ELSE
           BEGIN
            HolAdr(PName,PSymbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
            IF DimVar THEN Error('keine DIM-Variable erlaubt')
             ELSE
              BEGIN IF Symbol = Komma_BS
                     THEN BEGIN
                            Scanner; IncWert:=Trunc(Scanresult.Wert);
                            IF Symbol <> I_Zahl_BS
                               THEN Error('Integerkonstante erwartet')
                               ELSE IF IncWert >= $80
                                       THEN Error('Inc/Dec-Wert zu gross');
                            Scanner
                          END;
                    IF PSymbol=I_Ident_BS
                       THEN BEGIN
                             Codiere_Adr(Adr,1);     (* mov.l Adr,R1   *)
                             CodWord($6012);              (* mov.l @R1,R0   *)
                             IF NOT incr THEN IncWert:=256-IncWert;  (* Dec *)
                             CodWord($7000+IncWert);      (* add   #Wert,R0 *)
                             CodWord($2102);              (* mov.l R0,@R1   *)
                            END
                       ELSE IF Incr THEN CodWord($7000+$100*Adr+IncWert)
                                    ELSE CodWord($7000+$100*Adr+256-Incwert)

              END
           END
         END;
END;

PROCEDURE DAOut_P;
BEGIN
  Scanner; I_Ausdruck;
  CodRuntime(R_DAOut);
END;

PROCEDURE Def_P;
VAR JmpAdr: T_AdrInfo;
    Jmp_PC,Adr: LongInt;
BEGIN
 LiesAdresse(JmpAdr);CodWord(0);CodNop;Jmp_PC:=Code.PC;
 Scanner;
 IF Symbol <> R_Ident_BS
  THEN Error('Funktionsname erwartet')
  ELSE IF L_vorhanden(Baum,Scanresult.Name,Symbol,Adr)
        THEN Error('Funktionsname bereits vergeben')
        ELSE BEGIN
              Labelrein(Baum,Scanresult.Name,F_Ident_BS,Code.PC-4);
              Scanner; Klammerauf_P;
              IF Symbol <> R_Ident_BS
               THEN Error('Parametername erwartet')
               ELSE BEGIN
		     DefParAdr:=VarZeiger;
                     Inc(Varzeiger,8);
                     CodWord($52F1);   (* mov.l @(4,R15),R2 *)
                     CodWord($53F2);   (* mov.l @(8,R15),R3 *)
                     CodStoreReal(DefParAdr);
                     DefParametername:=Scanresult.Name; DefAktiv:=True;
                     Scanner; Klammerzu_P; Gleich_P;
		     IF InputRec.C_ok THEN R_Ausdruck;
                     CodPulReal;
                     CodWord($1F21);  (* mov.l R2,@(4,R15) *)
                     CodWord($1F32);  (* mov.l R3,@(8,R15) *)
                     CodWord($000B);  (* rts               *)
                     CodNop;
                    END
             END;
 ersetzeWord($A000+(Code.PC-Jmp_PC) shr 1, JmpAdr);
 DefAktiv:=False
END;


PROCEDURE Include_P;



BEGIN
  IF InputRec.Include
   THEN Error('Keine geschachtelten Includes erlaubt')
   ELSE BEGIN
          LiesNoSpace;
          IF InputRec.z <> '"' THEN Error(' " erwartet');
          IncFName:=''; LiesZ;
          WHILE NOT (InputRec.z IN [#0,#13,'"']) DO
           BEGIN IncFName:=IncFName+InputRec.z; LiesZ END;
          IF InputRec.z <> '"'
             THEN Error(' " erwartet')
             ELSE BEGIN OpenInclude(IncFName); Scanner END;
        END
END;

PROCEDURE StrLength_P;
BEGIN
  Scanner;
  IF (Symbol <> I_Zahl_BS) OR (Scanresult.Wert < 1) OR (Scanresult.Wert > 255)
   THEN Error('Zahl zwischen 1 und 255 erwartet')
   ELSE StrLaenge:=Trunc(Scanresult.Wert) AND $FC + 4;  (* modulo 4 *)
  scanner
END;

PROCEDURE I2CSende_P(RT: T_Trap);
BEGIN
 Scanner; I_Ausdruck;
 CodRuntime(RT)
END;

PROCEDURE EEProg_P(Ziel: T_Trap);
BEGIN
  Scanner; I_Ausdruck; Komma_P; I_Ausdruck; Komma_P; I_Ausdruck;
  CodRuntime(Ziel)
END;

PROCEDURE EEProgReal_P(Ziel: T_Trap);
BEGIN
  Scanner; I_Ausdruck; Komma_P; I_Ausdruck; Komma_P; R_Ausdruck;
  CodRuntime(Ziel)
END;

PROCEDURE EEProgStr_P;
BEGIN
  Scanner; I_Ausdruck; Komma_P; I_Ausdruck; Komma_P; S_Ausdruck;
  CodRuntime(R_EEProgStr)
END;

PROCEDURE InitTask_P;
VAR Ziel: LongInt;
BEGIN
  Scanner;
  IF L_vorhanden(Baum,Scanresult.Name,Symbol,Ziel)
     THEN BEGIN
            Scanner;
            Komma_P;
            I_Ausdruck;
            CodWord($E000);    (* mov #0,R0      keine lokalen Var. *)
            CodWord($2F06);    (* mov.l R0,@-R15                    *)
            CodWord($2F06);    (* mov.l R0,@-R15                    *)
            Komma_P;
            I_Ausdruck;
            Komma_P;
            I_Ausdruck;
            CodiereK_Long(Ziel,0); (* mov.l Ziel,R0   *)
            CodPushInt;
            CodRuntime(R_InitTask);
          END
     ELSE Error('unbekannter Task-Bezeichner')
END;

PROCEDURE RSInit_P;
VAR Adr:  LongInt;
    DimVar: Boolean;
    DimL,Dim1,Dim2,Dim3,Dimension: LongInt;
BEGIN
  Scanner; I_Ausdruck;   (* Schnittstellennummer *)
  Komma_P; I_Ausdruck;   (* Modus *)
  Komma_P; I_Ausdruck;   (* Baudrate *)
  Komma_P;
  IF Symbol=I_Ident_BS
     THEN BEGIN HolAdr(Scanresult.Name,Symbol,Adr,DimVar,Dimension,DimL,Dim1,Dim2,Dim3);
                IF NOT DimVar THEN Error('DIM-Variable erwartet');
                CodiereK_Long(Adr,0); (* mov.l Adresse,R0   *)
                CodiereCodeWord($300C+$00+$10*Addreg); (* add Addreg,R0 *)
                CodPushInt;
          END
     ELSE Error('DIM-Variable erwartet');
  Scanner;
  Komma_P; I_Ausdruck;   (* Lesepufferlaenge *)
  Komma_P; I_Ausdruck;   (* Sendepufferlaenge *)
  CodRuntime(R_RSInit);
END;


PROCEDURE RSStat_P;

  PROCEDURE I_Adresse;
  VAR DimL: LongInt;
  BEGIN
    IF Symbol = I_Ident_BS
       THEN Push_Adr(DimL)
       ELSE Error('Integervariable erwartet');
    Scanner;
  END;

BEGIN
  Scanner; I_Ausdruck;   (* Schnittstellennummer *)
  Komma_P; I_Adresse;    (* Anzahl im Lesepuffer *)
  Komma_P; I_Adresse;    (* freie Zahl im Lesepuffer *)
  Komma_P; I_Adresse;    (* Anzahl im Schreibpuffer *)
  Komma_P; I_Adresse;    (* freie Zahl im Schreibpuffer *)
END;


PROCEDURE Anweisung_P;

BEGIN (* Anweisung *)
  Plus_Menge:=[Plus_BS,Minus_BS,OR_BS];
  Mal_Menge:=[Mal_BS,Durch_BS,AND_BS,DIV_BS,MOD_BS];
  Test_KS_Voll;
  CASE Symbol OF
    Zeilenende_BS  : ZeilenAnfang_P;
    Doppelpunkt_BS : Scanner;
    Tron_BS        : BEGIN CodWord($0001); Scanner END;
    Troff_BS       : BEGIN CodWord($0011); Scanner END;
    REM_BS         : Rem_P;
    I_Ident_BS,
    I_Reg_BS       : I_Zuweisung;
    Poke_BS	   : Poke_P($2100);   (* mov.b R0,@R1 *)
    WPoke_BS       : Poke_P($2101);   (* mov.w R0,@R1 *)
    LPoke_BS       : Poke_P($2102);   (* mov.l R0,@R1 *)
    Inc_BS         : Inc_Dec_P(True);
    Dec_BS         : Inc_Dec_P(False);
    DAOut_BS       : DAOut_P;
    End_BS         : BEGIN
                       CodWord($C300);(* Trapa #0     *)
                       Scanner
                     END;
    ListP_BS       : Begin List:=True;  Scanner END;
    NoList_BS      : Begin List:=False; Scanner END;
    Call_BS        : Call_P;
    StrLength_BS   : StrLength_P;
    Gotoxy_BS      : Gotoxy_P(R_Gotoxy);
    Let_BS         : Let_P;
    S_Ident_BS     : S_Zuweisung;
    Print_BS       : Print_P;
    Dim_BS         : Dim_P;
    SetClock_BS    : Read_Set_Clock_P(R_SetClock);
    ReadClock_BS   : Read_Set_Clock_P(R_ReadClock);
    R_Ident_BS     : LR_Zuweisung;
    Input_BS       : Input_P;
    Return_BS      : BEGIN CodWord($000B); CodNOP; Scanner;
                           Ersetze_KS_Daten(Ohne_Branch) END;
    ReturnI_BS     : BEGIN RestoreIrqReg;CodWord($002B);CodNOP;Scanner;
                           Ersetze_KS_Daten(Ohne_Branch) END;
    Interrupt_BS   : Interrupt_P;
    To_BS          : Error('TO ohne FOR');
    Step_BS        : Error('STEP ohne FOR');
    Next_BS        : Error('NEXT ohne FOR');
    Wend_BS        : Error('WEND ohne WHILE');
    Until_BS       : Error('UNTIL ohne REPEAT');
    Assembler_BS   : Assembler_P;
    Goto_BS        : Goto_P;
    Gosub_BS       : Gosub_P;
    While_BS       : Whileanweisung_P;
    Repeat_BS      : Repeatanweisung_P;
    If_BS,IfL_BS   : Ifanweisung_P;
    For_BS         : For_P;
    On_BS          : On_P;
    Read_BS        : Read_P;
    Data_BS        : Data_P;
    Restore_BS     : Restore_P;
    Register_BS    : Register_P(RegNr);
    Get_BS         : Get_P;
    Delay_BS       : Delay_P(R_Delay);
    Include_BS     : Include_P;
    Org_BS         : Org_P;
    Var_BS         : Var_P;
    Def_BS         : Def_P;
    LCDInit_BS     : LCDInit_P;
    TastInit_BS    : BEGIN CodRuntime(R_TastInit); Scanner END;
    GoHost_BS      : BEGIN CodRuntime(R_GoHost); Scanner END;
    I2CInit_BS     : BEGIN CodRuntime(R_I2CInit); Scanner END;
    I2CStop_BS     : BEGIN CodRuntime(R_I2CStop); Scanner END;
    I2CStart_BS    : I2Csende_P(R_I2CStart);
    I2CReStart_BS  : I2Csende_P(R_I2CReStart);
    I2CSend_BS     : I2Csende_P(R_I2CSend);
    EEProgByte_BS  : EEProg_P(R_EEProgByte);
    EEProgWord_BS  : EEProg_P(R_EEProgWord);
    EEProgLong_BS  : EEProg_P(R_EEProgLong);
    EEProgReal_BS  : EEProgReal_P(R_EEProgReal);
    EEProgStr_BS   : EEProgStr_P;
    SCI1Init_BS    : BEGIN CodRuntime(R_SCI1Init); Scanner END;
    InitTask_BS    : InitTask_P;
    ExitTask_BS    : BEGIN CodRuntime(R_TermTask); Scanner END;
    Sleep_BS       : Delay_P(R_Sleep);
    Wait_BS        : Delay_P(R_Wait);
    Send_BS        : Delay_P(R_Send);
    TaskStart_BS   : Delay_P(R_TaskStart);
    TaskStop_BS    : BEGIN CodRuntime(R_TaskStop); Scanner END;
    SetIrqMask_BS  : Delay_P(R_SetIrqMask);
    RSSend_BS      : Gotoxy_P(R_RSSend);
    RSInit_BS      : RSInit_P;
    RSStat_BS      : RSStat_P;
    EndOfText_BS   : (* nix *);
{
    Stop_BS        : BEGIN CodByteAdr($06,$847F); (* TAP  ANDA #$7F *)
                           CodAdr($07CF);         (* TPA  STOP      *)
                           Scanner
                     END;
    COPReset_BS    : BEGIN CodRuntime(R_CopReset); Scanner END;
}
    ELSE            Error('unbekannte BASIC-Anweisung <'+Scanresult.name+'>')
  END;
  TestPush;
END;

VAR datadr,VarLAdr: T_Adrinfo; DataPC,VarLPC:Longint;
BEGIN (* von Parser *)
  Lastopcode:=Other;
  CodNop;
  CodWord($D001);             (* mov.l   Varlaenge,R0 *)
  CodWord($A002);             (* bra hinter Varlaenge *)
  CodNop;
  VarLPC:=Code.PC; LiesAdresse(VarLAdr); CodLong(0);
  CodWord($3F08);             (* sub   R0,R15                *)
  CodWord($60F3+$100*AddReg); (* Start der Var. in AddReg    *)
  CodWord($7004+$100*AddReg); (* add #4,AddReg               *)
  IF Code.PC AND 2 = 0 THEN CodNop;
  CodWord($C32B);
  Liesadresse(Datadr); DataPC:=Code.PC;
  CodLong(0);                 (* spaeter: moval Datastart,R0 *)
  Codiere_Adr(Datazeiger,1); (* mov.l #Datastart,R1     *)
  CodWord($2102);             (* mov.l R0,@R1                *)
  {
  CodWord($2002+$100*AddReg); (* mov.l R0,@Addreg=Datazeiger *)
     }
  KS_CodiereS_Long(LastTask,0);
  KS_CodiereS_Long(maxTask,1);
  CodiereCodeWord($2010);              { MOV.B R1,@R0 }
  RegNr:=StartReg;
  LiesZ; Scanner;
  WHILE (Symbol <> Endoftext_BS) AND InputRec.C_ok DO Anweisung_P;

  CodWord($C300);             (* Trapa #0  ;Abbruch          *)
  Ersetze_Ks_Daten(Ohne_Branch);
  IF Code.PC AND 2 = 2 THEN CodNop;
  ErsetzeLong(Code.PC-DataPC-4,Datadr);
  DataSpeichern(Dataschlange,Baum);
  ErsetzeLong((Varzeiger+260) AND $FFFFFFFC,VarLAdr);
                       (* Variablenanzahl nachtragen *)
                       (* -256 = Puffer fur Operationen beim Systemstart *)
                       (* Variable sollen trotz RESET erhalten bleiben   *)
END;

BEGIN     (* Hauptprogramm des Luchs-Basic-Parser-Tests *)
  Create_DataSchlange(Dataschlange);
  Code.PC:=0; Code.StartAdresse := Sysinfo.Codestart;
  StrLaenge:=(StartStrLaenge and $FC) +4;
  baum:=NIL; Insertheap:=NIL; DimHeap:=NIL;
  List:=false; Ende:=False; DefAktiv:=False;
  Datazeiger:=-4; VarZeiger:=Datazeiger+4;
  OpenInput(WorkFile.TName,'BASIC');
  IF Ioresult <> 0
   THEN Error('Das File '+ WorkFile.Tname + ' existiert nicht')
   ELSE BEGIN
         CCreate(Sysinfo.CodeStart);
         Erzeuge(StdBezBaum);
         Parser;
         CloseInput;
         Insertersetzen_Dispose(Baum,Insertheap,InputRec.Meldung[1],InputRec.C_ok);
         CClose;
         IF InputRec.C_ok
            THEN BEGIN (* IF List THEN Labelausgabe(Baum, Work.LName);*)
                    speichern(WorkFile);
                    Str(Code.BlockNr*(MaxB+1)+Code.Position,InputRec.Meldung[2]);
                    InputRec.Meldung[2] := InputRec.Meldung[2]+' Bytes Code erzeugt';
                    InputRec.Meldung[5] := '0 Fehler   Codedatei erzeugt';
                    InputRec.OkMeldung:=Workfile.CName+' '+InputRec.Meldung[2];
                 END
          ELSE BEGIN WorkFile.WCode := false;
                     WorkFile.TFehler:=InputRec.Last.Znr
               END
        END;
   Dispose_Dimheap(Dimheap);
   Dispose_Baum(Baum);
   Dispose_Baum(stdbezbaum);
   Dispose_DataSchlange(DataSchlange);
 END;

END.
