UNIT  EditDOS;  { Der Standard-Editor unter DOS }

INTERFACE

USES LuchsTyp;

PROCEDURE Edit(VAR Work: T_WorkFile);

IMPLEMENTATION
USES Crt, DOS, Printer;

CONST Maxy   = 25;  Maxy_1 = 24;  Maxx   = 79;
      CTRL_A = #01; CTRL_B = #02; CTRL_C = #03; CTRL_D = #04; CTRL_E = #05;
      CTRL_F = #06; CTRL_G = #07; CTRL_H = #08; CTRL_I = #09; CTRL_J = #10;
      CTRL_K = #11; CTRL_L = #12; CTRL_N = #14; CTRL_O = #15; CTRL_P = #16;
      CTRL_Q = #17; CTRL_R = #18; CTRL_S = #19; CTRL_T = #20; CTRL_U = #21;
      CTRL_V = #22; CTRL_W = #23; CTRL_X = #24; CTRL_Y = #25; CTRL_Z = #26;
      ESC    = #27; CR     = #13; SPC    = #32;


TYPE  T_Zeile      = String[79];
      Stringk      = String[15];
      Stringm      = String[29];

      T_Zkurz      = ^Stringk;
      T_Zmittel    = ^Stringm;
      T_Zlang      = ^T_Zeile;

      PT_Knoten    = ^RT_Knoten;
      T_ZLaenge    = (leer, kurz, mittel, lang);
      RT_Knoten    = RECORD next, prae : PT_Knoten;
                            CASE Zlaenge : T_Zlaenge OF
                              kurz   : (KIP : T_Zkurz);
                              mittel : (MIP : T_Zmittel);
                              lang   : (LIP : T_Zlang)
                        END;

      T_Text       = RECORD Anfang, Ende, Schreib, Bild : PT_Knoten;
                            x_P, y_P,ry,ba,be : Integer;
                            bs : Boolean;
                        END;

VAR TrennZeichen : Set OF Char ;

PROCEDURE Edit(VAR Work : T_WorkFile);

VAR  T                : T_Text;
     Taste, Secnd     : Char;
     Ins, Double, Ende: Boolean;
     Find, Repl       : T_Zeile;

FUNCTION min(a,b: Integer): Integer;
BEGIN
  IF a<b THEN min := a ELSE min := b
END;

FUNCTION max(a,b: Integer): Integer;
BEGIN
  IF a>b THEN max := a ELSE max := b
END;

FUNCTION getZeile(P : PT_Knoten) : T_Zeile;
BEGIN
  CASE P^.Zlaenge OF
    leer  : getZeile := '';
    kurz  : getZeile := P^.KIP^;
    mittel: getZeile := P^.MIP^;
    lang  : getZeile := P^.LIP^
  END
END;

PROCEDURE DisposeZeile(P : PT_Knoten);
BEGIN
   CASE P^.Zlaenge OF
     leer   :;
     kurz   : dispose(P^.Kip);
     mittel : dispose(P^.Mip);
     lang   : dispose(P^.Lip)
   END;
END;

PROCEDURE DisposeBlock(von,bis : PT_Knoten);
VAR laufzeiger : PT_Knoten;
BEGIN
  laufzeiger := von;
  WHILE laufzeiger <> bis DO
  BEGIN
    laufzeiger := laufzeiger^.next;
    DisposeZeile(von);
    Dispose(von);
    von := laufzeiger;
  END;
  DisposeZeile(bis);
  Dispose(bis);
END;

PROCEDURE setZeile(VAR P: PT_Knoten; s : T_Zeile);

 PROCEDURE findelaenge(i: Integer; VAR L: T_ZLaenge);
 BEGIN
   IF i = 0
      THEN L := leer
      ELSE IF i < 16
              THEN L := kurz
              ELSE IF i < 30
                      THEN L := mittel
                      ELSE L := lang
 END;

VAR newl : T_ZLaenge;
BEGIN
   findelaenge(Length(s), newL);
   IF ord(newL) > ord(P^.ZLaenge)
      THEN BEGIN
             DisposeZeile(P);
             CASE newL OF
                kurz     : new(P^.KIP);
                mittel   : new(P^.MIP);
                lang     : new(P^.LIP)
             END;
             P^.ZLaenge := newL;
             P^.LIP^ := S
           END
      ELSE IF P^.ZLaenge <> leer THEN P^.LIP^ := S
END;

PROCEDURE Lies(VAR Taste,secnd: Char; VAR Double : Boolean);
BEGIN
  Double := false;
  Taste := readKey;
  IF Taste = #127
     THEN Taste := ^H
     ELSE IF (Taste = #0) AND keypressed
             THEN  BEGIN      (* Tastatursteuercodes IBM PC *)
                     Taste := ReadKey;
                        CASE Taste OF
                          '<': BEGIN Taste:= CTRL_K; Secnd := CTRL_S;
                                     Double := True  (* F2            *)
                               END;
                          'A': BEGIN Taste:= CTRL_K; Secnd := CTRL_B;
                                     Double := True  (* F7            *)
                               END;
                          'B': BEGIN Taste:= CTRL_K; Secnd := CTRL_K;
                                     Double := True  (* F8            *)
                               END;
                          'D': BEGIN Taste:= CTRL_K; Secnd := CTRL_D;
                                     Double := True  (* F10           *)
                               END;
                          'G': BEGIN Taste:= CTRL_Q; Secnd := CTRL_S;
                                     Double := True  (* HOME          *)
                               END;
                          'H': Taste := ^E;          (* Hochpfeil     *)
                          'I': Taste := ^R;          (* Pg Up         *)
                          'K': Taste := ^S;          (* Linkspfeil    *)
                          'M': Taste := ^D;          (* Rechtspfeil   *)
                          'P': Taste := ^X;          (* Runterpfeil   *)
                          'Q': Taste := ^C;          (* Pg Dn         *)
                          'R': Taste := ^V;          (* Ins           *)
                          'S': Taste := ^G;          (* Del           *)
                          'O': BEGIN Taste:= CTRL_Q; Secnd := CTRL_D;
                                     Double := True  (* END           *)
                               END;
                          's': Taste := Ctrl_A;
                          't': Taste := Ctrl_F;
                          'v': BEGIN Taste:= CTRL_Q; Secnd := CTRL_C;
                                     Double := True  (* CTRL PGDN     *)
                               END;
                         #132: BEGIN Taste:= CTRL_Q; Secnd := CTRL_R;
                                     Double := True  (* CTRL PGUP     *)
                               END
                        END
                   END
END;

PROCEDURE First_Line(VAR T: T_Text);
BEGIN
  new(T.Anfang);
  T.Anfang^.ZLaenge := leer;
  T.Anfang^.prae := nil; T.Anfang^.next := nil;
  T.Ende := T.Anfang; T.Schreib := T.Anfang; T.Bild := T.Anfang;
  T.x_p := 1; T.y_p := 1; T.ry := 2;
  T.Ba := 0; T.Be := 0; T.Bs := false
END;

PROCEDURE Warnung_Speicher;
BEGIN
  Gotoxy(60,1);
  Write('Speichermangel !!',#7);
END;

PROCEDURE Warnung_Abbruch;
BEGIN
  Gotoxy(60,1);
  Write('Speicher voll !!',#7);
  Ende := true
END;

PROCEDURE new_Line(VAR T: T_Text);
VAR Hilf :PT_Knoten;
BEGIN
  if System.memavail < 1024 THEN Warnung_speicher;
  if System.memavail < 512
    THEN Warnung_abbruch
    ELSE BEGIN
          Hilf := T.Ende;
          new(T.Ende);
          T.Ende^.ZLaenge := leer;
          T.Ende^.prae := Hilf;
          T.Ende^.next := nil;
          Hilf^.next   := T.Ende
         END
END;

PROCEDURE Insert_Line(VAR T: T_Text);  (* fgt eine Zeile hinter T.Schreib an *)
VAR Hilf :PT_Knoten;
BEGIN
  if System.memavail < 1024 THEN Warnung_speicher;
  if System.memavail < 512
    THEN Warnung_abbruch
    ELSE BEGIN
           new(Hilf);
           Hilf^.ZLaenge := leer;
           Hilf^.prae := T.Schreib;
           Hilf^.next := T.Schreib^.next;
           IF T.Schreib = T.Ende THEN T.Ende := Hilf
                                 ELSE Hilf^.next^.prae := Hilf;
           T.Schreib^.next  := Hilf
         END
END;

PROCEDURE Fill_Line(VAR T: T_Text);  (* fgt eine Zeile vor T.Schreib an *)
VAR Hilf :PT_Knoten;
BEGIN
  if System.memavail < 1024 THEN Warnung_speicher;
  if System.memavail < 512
    THEN Warnung_abbruch
    ELSE BEGIN
           new(Hilf);
           Hilf^.ZLaenge := leer;
           Hilf^.prae := T.Schreib^.prae;
           Hilf^.next := T.Schreib;
           IF T.Schreib = T.Anfang THEN T.Anfang := Hilf
                                   ELSE Hilf^.prae^.next := Hilf;
           T.Schreib^.prae  := Hilf;
        END
END;

PROCEDURE Delete_Line(VAR T: T_Text; Zeile :PT_Knoten);
VAR Hilf :PT_Knoten;
BEGIN
  IF Zeile = T.Anfang
     THEN T.Anfang := Zeile^.next
     ELSE Zeile^.prae^.next := Zeile^.next;
  IF Zeile = T.Ende
     THEN BEGIN
            T.Ende := Zeile^.Prae;
            T.Ende^.next := NIL;
          END
     ELSE Zeile^.next^.prae := Zeile^.prae;
  DisposeZeile(Zeile);
  Dispose(Zeile);
END;

PROCEDURE Text_Laden(VAR T        : T_Text;
                     Name     : T_FileName);
VAR f       : Text;
    Anf     : Integer;
    IoErr   : Boolean;
    Zeile   : String[255];
BEGIN
  writeln('Lade  '+Name+' ...');
  assign(f,Name); Anf := 0;
  reset(f); IoErr:=Ioresult<>0;
  IF NOT IoErr
    THEN BEGIN
           WHILE NOT eof(f) AND (System.memavail> 512) DO
             BEGIN
               readln(f,Zeile); inc(Anf);
               WHILE length(Zeile) > Maxx DO
                     BEGIN SetZeile(T.Ende,Copy(Zeile,1,Maxx));
                           Delete(Zeile,1,Maxx);
                           new_Line(T);
                     END;
               setZeile(T.Ende, Zeile);
               IF not eof(F) THEN new_Line(T)
             END;
           Close(f)
         END
END;

PROCEDURE Text_Speichern(VAR T    : T_Text;
                         Name: T_FileNAme;
                         VAR ok : Boolean);
VAR f       : Text;
    Hilf : PT_Knoten;
    S    : T_Zeile;
    i : Integer;
BEGIN
    clrscr; writeln('Speichere '+Name);
    assign(f,Name); i := 0;
    rewrite(f); ok := ioresult = 0;
   IF ok THEN
     BEGIN
       Hilf := T.Anfang;
       REPEAT
          inc(i);
          S := getZeile(Hilf);
          WHILE S[Length(S)]= SPC
             DO Delete(S,Length(S),1);
          writeln(f,S);
          ok := Ioresult = 0;
          Hilf := Hilf^.next;
       UNTIL (Hilf = nil) OR not ok;
       Close(f);
       ok := ok AND (ioresult = 0)
     END
     ELSE BEGIN Writeln('Textdatei konnte nicht gespeichert werden');
                Crt.delay(1000) END
END;

PROCEDURE Kommando(Ins: Boolean);
BEGIN
   LowVideo;
   GotoXY(1,1); clreol;
   Write('MOPS-Editor:  <F2> save+exit   <F10> exit ');
   IF Ins THEN Write('Insert') ELSE Write('Overwrite');
   HighVideo
END;

PROCEDURE Koord(x,y: Integer);
BEGIN
   LowVideo;
   GotoXY(60,1);
   clreol;
   Write(x:4,y:5);
   HighVideo
END;

PROCEDURE SetVideo(VAR T: T_Text; zeile: Integer);
BEGIN
   IF T.bs AND (Zeile >= T.ba) AND (Zeile <= T.Be)
      THEN lowVideo
      ELSE HighVideo
END;

FUNCTION imBlock(VAR T: T_Text): Boolean;
BEGIN
  imBlock := (T.y_p >= T.ba) AND (T.y_p <= T.Be)
END;

PROCEDURE BlockKorrektur(VAR T: T_Text; ZuWachs: Boolean);
BEGIN
  IF (T.y_p >= T.ba) AND (T.y_p < T.Be)   (* letzte Zeile herausgenommen *)
     THEN IF Zuwachs THEN Inc(T.Be)
                     ELSE Dec(T.Be)
     ELSE IF T.y_P < T.Ba
             THEN IF Zuwachs THEN BEGIN Inc(T.Ba); Inc(T.Be) END
                             ELSE BEGIN Dec(T.Ba); Dec(T.Be) END
END;


PROCEDURE Bild( VAR T        : T_Text;
                    Ins      : Boolean);
VAR Hilf : PT_Knoten;
    i,Z  : Integer;
BEGIN
   i := 2; Z := T.y_p - T.ry + 2;
   Hilf := T.Bild;
   WHILE (Hilf <> nil) AND (I<=Maxy) DO
        BEGIN SetVideo(T,Z);
              Gotoxy(1,i); 
              Write(getZeile(Hilf));
              ClrEol;
              Hilf := Hilf^.next;
              Inc(i); Inc(Z)
        END;
   WHILE i <= Maxy DO
        BEGIN GotoXY(1,i);
              clreol;
              Inc(i)
        END;
   Kommando(Ins);
END;

PROCEDURE zurueck(VAR K: PT_Knoten);
BEGIN
   IF K^.Prae <> nil THEN  K := K^.Prae
END;

PROCEDURE Vorwaerts(VAR K: PT_Knoten);
BEGIN
   IF K^.next <> nil THEN K := K^.next
END;

PROCEDURE rauf(VAR T    : T_Text;
                   Ins  : Boolean);
BEGIN
   IF (T.ry <= 3) AND (T.Anfang<>T.Bild)
      THEN BEGIN Zurueck(T.Schreib);
                 Zurueck(T.Bild);
                 Dec(T.y_P);
                 Bild(T, ins)
           END
      ELSE IF T.ry >= 3
              THEN BEGIN Dec(T.y_p);
                         Dec(T.ry);
                         Zurueck(T.Schreib)
                   END
END;

PROCEDURE runter(VAR T   : T_Text;
                     Ins : Boolean);
BEGIN
   IF T.schreib <> T.Ende
      THEN IF (T.ry = Maxy_1)
              THEN BEGIN Vorwaerts(T.Schreib);
                         Vorwaerts(T.Bild);
                         Inc(T.y_P);
                         Gotoxy(1,Maxy);
                         writeln;
                         IF T.Schreib <> T.Ende
                            THEN BEGIN SetVideo(T, T.y_P+1);
                                       write(getZeile(T.Schreib^.next))
                                 END;
                          Kommando(Ins);
                   END
              ELSE IF (T.ry < Maxy_1)
                      THEN BEGIN Inc(T.y_p);
                                 Inc(T.ry);
                                 Vorwaerts(T.Schreib)
                           END
END;

PROCEDURE Scroll_auf(VAR T: T_Text; ins : Boolean);
BEGIN
  IF T.Bild <> T.Anfang
     THEN  BEGIN Zurueck(T.Bild);
                 Inc(T.ry);
                 IF (T.ry = Maxy)
                    THEN BEGIN Dec(T.ry); Dec(T.y_P);
                               Zurueck(T.Schreib)
                         END;
                 Bild(T,Ins)
           END
END;

PROCEDURE Scroll_ab(VAR T: T_Text; ins : Boolean);
BEGIN
 IF T.Schreib <> T.Ende
     THEN  BEGIN Vorwaerts(T.Bild);
                 Dec(T.ry);
                 IF (T.ry = 2)
                    THEN BEGIN Inc(T.ry); Inc(T.y_P);
                               Vorwaerts(T.Schreib)
                         END;
                 Bild(T,Ins)
           END
END;

PROCEDURE Kopiere_Zeilenrest(VAR T: T_Text);
VAR Rest, Zeile : T_Zeile;
BEGIN
   Zeile := getZeile(T.Schreib);
   Rest := Copy (Zeile,T.x_p,Length(Zeile)-T.x_P+1);
   setZeile(T.Schreib, Copy(Zeile,1,T.x_P - 1));
   setZeile(T.Schreib^.next, Rest)
END;

PROCEDURE Neue_Zeile(VAR T: T_Text; ins : Boolean);
BEGIN
   IF ins
      THEN BEGIN IF T.Schreib = T.Ende
                    THEN new_line(T)
                    ELSE Insert_line(T);
                 Kopiere_ZeilenRest(T);
                 BlockKorrektur(T,True);
                 Bild(T,Ins)
           END;
   runter(T,Ins);
   T.x_P := 1
END;

PROCEDURE Erzeuge_Zeile(VAR T: T_Text; ins : Boolean);
BEGIN
   IF T.Schreib = T.Ende
      THEN new_line(T)
      ELSE Insert_line(T);
   Kopiere_ZeilenRest(T);
   BlockKorrektur(T,True);
   Bild(T,Ins)
END;


PROCEDURE  Seiterauf(VAR T : T_Text);
VAR i : Integer;
BEGIN
   i := 0;
   WHILE (i<Maxy_1) AND (T.Schreib<>T.Anfang) DO
        BEGIN Zurueck(T.Schreib);
              IF T.Bild <> T.Anfang THEN Zurueck(T.Bild);
              Dec(T.y_P); Inc(i)
        END;
   IF (T.y_p <= Maxy_1) AND (T.Bild = T.Anfang)
      THEN T.ry := T.y_p +1;
   Bild(T, Ins)
END;

PROCEDURE Seiterunter(VAR T : T_Text);
VAR i : Integer;
    Hilf : PT_Knoten;
BEGIN
   i := 0;
   WHILE (i<Maxy_1) AND (T.Schreib<>T.Ende) DO
         BEGIN Vorwaerts(T.Schreib); Vorwaerts(T.Bild);
               Inc(T.y_P); Inc(i)
         END;
   IF (T.Schreib = T.Ende) AND (i <Maxy_1)
      THEN BEGIN T.ry := 2; Hilf := T.Bild;
                 WHILE Hilf <> T.Ende DO
                       BEGIN Vorwaerts(Hilf); Inc(T.ry)
                       END
           END;
   Bild(T, Ins)
END;

PROCEDURE Setze_Buchstaben(VAR x     : Integer;
                               Taste : Char;
                           VAR P     : PT_Knoten;
                               Ins   : Boolean);
VAR i: Integer;
    Zeile : T_Zeile;
BEGIN
   Zeile := getZeile(P);
   IF Length(Zeile) < x
      THEN FOR i:=Length(Zeile) TO x DO Zeile:=Zeile+ SPC
      ELSE WHILE (Zeile[Length(Zeile)] = SPC) AND (length(Zeile) >x) DO
                 Delete(Zeile, Length(Zeile),1);
   IF Ins THEN IF (length(Zeile)< Maxx) OR (x=Maxx)
                  THEN BEGIN Insert(Taste,Zeile,x);
                             SetVideo(T,T.y_p);
                             Write(Taste);
                             write(copy(zeile,x+1,length(zeile)-x));
                             IF x < Maxx THEN Inc(x)
                       END
                  ELSE Write(#7)
          ELSE IF x <= Maxx
                  THEN BEGIN Zeile[x]:=Taste;
                             Write(Taste);
                             IF x < Maxx THEN Inc(x)
                       END
                  ELSE Write(#7);
   setZeile(P, Zeile)
END;

PROCEDURE Entferne_Zeichen(    x     : Integer;
                           VAR P     : PT_Knoten);
VAR Zeile : T_Zeile;
BEGIN
   Zeile := getZeile(P);
   IF x <= Length(Zeile)
      THEN BEGIN Delete(Zeile,x,1);
                 clreol;
                 SetVideo(T, T.Y_P);
                 write(Copy(Zeile,x,Length(Zeile)-x+1))
           END;
   setZeile(P,Zeile)
END;

PROCEDURE Delete_Zeichen(VAR  T: T_Text; ins : Boolean);
VAR Z : T_Zeile;
BEGIN
   Z := getZeile(T.Schreib);
   IF T.x_P > 1
      THEN BEGIN Dec(T.x_p);
                 Delete(Z,T.x_p,1);
                 setZeile(T.Schreib, Z);
                 Gotoxy(1,T.ry); clreol;
                 SetVideo(T,T.y_p);
                 write(Z)
           END
      ELSE IF (T.Schreib <> T.Anfang)
           THEN BEGIN
                  IF (Length(Z)+Length(GetZeile(T.Schreib^.prae))<=Maxx)
                  THEN BEGIN BlockKorrektur(T,false);
                           rauf(T,ins);
                           T.x_P := Length(getZeile(T.Schreib))+1;
                           setZeile(T.Schreib, getZeile(T.Schreib) + Z);
                           Delete_Line(T, T.Schreib^.next);
                           Bild(T,ins)
                       END
                  ELSE Write(#7)
                END
            ELSE Write(#7)
END;

PROCEDURE Entferne_Zeile(VAR T : T_Text; ins : Boolean);
VAR Hilf : PT_Knoten;
BEGIN
  IF T.Schreib <> T.Ende
     THEN BEGIN
             BlockKorrektur(T, False);
             Hilf := T.Schreib;
             IF T.Bild = T.Schreib THEN T.Bild := T.Bild^.next;
             Vorwaerts(T.Schreib);
             delete_Line(T, Hilf);
             Bild(T,Ins);
             T.x_P := 1
          END
END;

FUNCTION Wort_Anfang_R(S: T_Zeile; start : Integer): Integer;
VAR max, p : Integer;
BEGIN
  max := length(S);
  p := Start;
  WHILE (p<=max) AND not (S[p] IN TrennZeichen) DO inc(p);
  WHILE (p<=max) AND     (S[p] IN TrennZeichen) DO inc(p);
  Wort_Anfang_R := p
END;

FUNCTION Wort_Anfang_L(S: T_Zeile; start : Integer): Integer;
VAR max, p : Integer;
BEGIN
   max := length(S);
   p := Start;
   IF p>max THEN p := max;
   IF (S <> SPC ) AND (p>1) THEN Dec(p);
   WHILE (p>1) AND     (S[p] IN TrennZeichen) DO Dec(p);
   WHILE (p>1) AND not (S[p] IN TrennZeichen) DO Dec(p);
   IF (p>1) THEN inc(p);
   IF  p < 1 THEN P := 1;                (* !!!!!!!!! neu in A4   *)
   Wort_Anfang_L := p
END;

PROCEDURE Tab_rechts(VAR T: T_Text; ins: Boolean);
VAR p, Spaces,i : Integer;
BEGIN
  IF T.Schreib <> T.Anfang
     THEN BEGIN p := Wort_Anfang_R(getZeile(T.Schreib^.Prae),T.x_P);
                Spaces := p - T.x_p
          END
     ELSE BEGIN Spaces := 8;
                p := T.x_p + Spaces
          END;
  IF ins
      THEN For i:= 1 TO Spaces DO
               BEGIN Setze_Buchstaben(T.x_P,SPC,T.Schreib,ins);
                     Gotoxy(T.x_P, T.ry)
               END
      ELSE T.x_P := min(Maxx,p)
END;

PROCEDURE Tab_links(VAR T: T_Text; ins: Boolean);
VAR p, Spaces, i : Integer;
BEGIN
  IF T.Schreib <> T.Anfang
     THEN BEGIN p := Wort_Anfang_L(getZeile(T.Schreib^.prae), T.x_P);
                Spaces := T.x_p - p;
                T.x_P := p
          END
     ELSE BEGIN Spaces := min(8,T.x_p-1);
                IF Spaces >1 THEN Dec(T.x_p,Spaces)
          END;
  IF ins
     THEN For i:= 1 TO Spaces DO
              BEGIN Entferne_Zeichen(T.x_P,T.Schreib);
                    Gotoxy(T.x_P, T.ry)
              END
END;

PROCEDURE Wort_R_loeschen(VAR T: T_Text; ins: Boolean);
VAR p, Anz : Integer;
    Z  : T_Zeile;
BEGIN
  z := getZeile(T.Schreib);
  p := Wort_Anfang_R(Z, T.x_P);
  IF T.x_P < length(Z)
     THEN BEGIN Anz := p - t.x_P;
                Delete(Z,T.x_p,Anz);
                Gotoxy(1,T.ry); clreol;
                SetVideo(T,T.y_P);
                write(Z);
                setZeile(T.Schreib, Z)
          END
     ELSE IF not( T.Schreib = T.Ende) AND (T.x_p+length(getZeile(T.Schreib^.next))<=Maxx)
             THEN BEGIN setZeile(T.Schreib, Z + getZeile(T.Schreib^.next));
                        Delete_Line(T, T.Schreib^.next);
                        Bild(T,ins)
                  END
             ELSE Write(#7)
END;

PROCEDURE Print_Block(VAR T :T_Text);
VAR Hilf : PT_Knoten;
    i, Anz : Integer;
BEGIN
  IF T.Bs THEN
    BEGIN
       Hilf := T.Anfang;
       FOR i := 2 TO T.Ba DO Hilf := Hilf^.next;
       Anz := T.Be - T.Ba +1;
       FOR i := 1 TO Anz DO
          BEGIN Writeln(Lst, getZeile(Hilf));
                Hilf := Hilf^.next
          END
    END
END;

PROCEDURE Write_Block(VAR T :T_Text; ins : Boolean);
VAR Hilf : PT_Knoten;
    i, Anz : Integer;
    name   : T_FileName;
    F      : Text;
BEGIN
  IF T.Bs THEN
    BEGIN
       Gotoxy(1,1); Write('Filename : '); ClrEol; Readln(name);
       IF Pos('.',name)=0 THEN name := name+ '.MTX';
       Assign(F,name); ReWrite(F);
       IF Ioresult = 0
          THEN BEGIN
                 Gotoxy(1,1); Write('Schreibe ...'); ClrEol;
                 Hilf := T.Anfang;
                 FOR i := 2 TO T.Ba DO Hilf := Hilf^.next;
                 Anz := T.Be - T.Ba +1;
                 FOR i := 1 TO Anz DO
                 BEGIN Writeln(F, getZeile(Hilf));
                       Hilf := Hilf^.next
                 END;
                 Close(F)
               END
          ELSE BEGIN Gotoxy(1,1); Write('Datei konnte nicht geschrieben werden');
                     Crt.Delay(1000)
               END;
      Kommando(ins)
    END
END;


PROCEDURE Read_Block(VAR T :T_Text; ins : Boolean);
VAR Hilf : PT_Knoten;
    Anf    : Boolean;
    i, Anz : Integer;
    name   : T_FileName;
    F      : Text;
    Z      : T_Zeile;
BEGIN
   Gotoxy(1,1); Write('Filename : '); ClrEol; Readln(name);
   IF Pos('.',name)=0 THEN name := name+ '.MTX';
   Assign(F,name); ReSet(F);
   IF Ioresult = 0
      THEN BEGIN
              Anf := false;
              Gotoxy(1,1); Write('Lese ...'); ClrEol;
              IF T.Schreib = T.Anfang
                 THEN Anf := True
                 ELSE Hilf := T.Schreib^.Prae;
              Anz := 0;
              WHILE not Eof(F) and (System.memavail > 512) DO
                BEGIN Fill_Line(T);
                      Readln(F, Z);
                      setZeile(T.Schreib^.prae, Z);
                      Inc(Anz)
                END;
              IF Anf
                 THEN BEGIN T.Schreib := T.Anfang; T.Bild := T.Schreib END
                 ELSE T.Schreib := Hilf^.next;
              T.Ba := T.y_P; T.Be := T.Ba + Anz -1; T.Bs := True;
              Bild(T,ins);
              Close(F)
           END
      ELSE BEGIN Gotoxy(1,1); Write('Kann Datei nicht lesen ...');
                 Crt.Delay(1000)
           END;
  Kommando(ins)
END;

PROCEDURE Jmp_Block(VAR T: T_Text; Ziel: Integer; ins : Boolean);
BEGIN
  IF T.Bs THEN
     BEGIN
       IF T.y_P <> Ziel
          THEN IF T.y_p > Ziel
                  THEN WHILE (T.y_p<>Ziel) DO
                              BEGIN Zurueck(T.Schreib);
                                    Dec(T.y_P);
                                    IF T.ry <= 3 THEN Zurueck(T.Bild)
                                                 ELSE Dec(T.ry)
                              END
                  ELSE WHILE (T.y_p<>Ziel) AND (T.Schreib <> T.Ende) DO
                              BEGIN Vorwaerts(T.Schreib);
                                    Inc(T.y_P);
                                    IF T.ry >= Maxy_1  THEN Vorwaerts(T.Bild)
                                                       ELSE Inc(T.ry)
                              END;
       IF T.Schreib = T.Anfang THEN T.ry := 2;
       T.x_p :=1;
       Bild(T,Ins)
     END
END;

PROCEDURE Copy_Block(VAR T :T_Text; ins : Boolean);
VAR Hilf, HSchreib : PT_Knoten;
    i, Anz : Integer;
BEGIN
  IF not imBlock(T) AND T.Bs
     THEN BEGIN
             Hilf := T.Anfang;
             FOR i := 2 TO T.Be DO Hilf := Hilf^.next;
             Anz := T.Be - T.Ba +1;
             FOR i := 1 TO Anz DO
                 BEGIN Fill_Line(T);
                       IF T.Bild = T.Schreib THEN Zurueck(T.Bild);
                       Zurueck(T.Schreib);
                       setZeile(T.Schreib, getZeile(Hilf));
                       Hilf := Hilf^.prae
                 END;
             IF T.Ba > T.y_p
                THEN BEGIN Inc(T.Ba,Anz);
                           Inc(T.Be,Anz)
                     END;
             Bild(T,ins)
          END
END;

PROCEDURE Move_Block(VAR T :T_Text; ins : Boolean);
VAR HilfA, HilfE : PT_Knoten;
    i, Anz : Integer;
    inside, Samepage : Boolean;
BEGIN
  IF not imBlock(T) AND T.Bs
     THEN BEGIN
             samepage := T.y_p - T.ry +1 < T.Be;
             HilfA := T.Anfang;
             FOR i := 2 TO T.Ba DO HilfA := HilfA^.next;
             HilfE := HilfA;
             Anz   := T.Be - T.Ba +1;
             inside := HilfE = T.Bild;
             FOR i := 2 TO Anz
                DO BEGIN HilfE := HilfE^.next;
                         inside := inside OR (HilfE = T.Bild);
                   END;
             IF HilfA=T.Anfang THEN T.Anfang := HilfE^.next
                               ELSE HilfA^.prae^.next := HilfE^.next;
             IF HilfE=T.Ende   THEN T.Ende   := HilfA^.Prae
                               ELSE HilfE^.next^.prae := HilfA^.prae;
             HilfE^.next := T.Schreib;
             IF T.Schreib =T.Anfang  THEN T.Anfang  := HilfA
                                     ELSE T.Schreib^.prae^.next := HilfA;
             HilfA^.prae := T.Schreib^.prae;
             T.Schreib^.prae := HilfE;
             T.Schreib := HilfA;
             IF T.Ba < T.y_P
                THEN BEGIN Dec(T.y_P,Anz);
                           IF Inside
                              THEN BEGIN T.Bild := T.Schreib^.prae;
                                         T.ry := 3
                                   END
                              ELSE IF samepage THEN Dec(T.ry,Anz)
                     END
                ELSE IF T.Schreib=T.Anfang
                        THEN BEGIN T.Bild := T.Anfang;
                                   T.ry := 2;
                                   T.y_p:= 1
                             END;
             T.Ba := T.y_p; T.Be := T.Ba + Anz - 1;
             Bild(T,ins)
     END
 END;


PROCEDURE Loesche_Block(VAR T :T_Text; ins : Boolean);
VAR HilfA, HilfE : PT_Knoten;
    i, Anz : Integer;    nix :Char;
BEGIN
  IF T.Bs THEN
   BEGIN
      HilfA := T.Anfang;
      FOR i := 2 TO T.Ba DO HilfA := HilfA^.next;
      Anz := T.Be - T.Ba +1;
      HilfE := HilfA;
      FOR i := 2 TO Anz DO HilfE := HilfE^.next;
      IF (HilfA = T.Anfang) AND (HilfE = T.Ende)
         THEN First_Line(T)       (* gesamter Text gelscht *)
         ELSE IF HilfA = T.Anfang
                 THEN BEGIN T.Anfang := HilfE^.next;
                            T.Bild := T.Anfang;
                            T.Schreib := T.Anfang;
                            T.y_p   := 1; T.ry := 2;
                      END
                 ELSE BEGIN Jmp_Block(T, T.Ba-1,ins);
                            IF HilfE <> T.Ende               (* neu 1.5 *)
                               THEN HilfA^.Prae^.next := HilfE^.next
                               ELSE HilfA^.Prae^.next := nil;
                            IF HilfE = T.Ende
                               THEN T.Ende := HilfA^.prae
                               ELSE HilfE^.next^.Prae := HilfA^.prae;
                      END;
      T.Ba := 0; T.Be := 0; T.Bs := False;
      Bild(T,ins)
   END;
  DisposeBlock(HilfA,HilfE);
END;

PROCEDURE  To_Hide_or_not_to_Hide(VAR T: T_Text;  ins: Boolean);
BEGIN
  T.Bs := not T.Bs AND (T.Ba<>0)
                   AND (T.Be<>0)
                   AND (T.Ba <= T.Be);
  Bild(T,ins)
END;


PROCEDURE CTRL_K_Kommandos(VAR T: T_Text; ins : Boolean; Secnd : Char;
                          VAR Double, Ende: Boolean; Name :T_FileName);
BEGIN
  Gotoxy(78,1); Write('^K'); Gotoxy(T.x_p, T.ry);
  IF Double THEN BEGIN Taste := Secnd; Double := false END
            ELSE Lies(Taste,Secnd, Double);
  CASE Upcase(Taste) OF
    CTRL_B, 'B' : BEGIN T.Ba := T.y_p;
                        T.Bs := (T.Ba <= T.Be) AND (T.Be <>0);
                        Bild(T,ins)
                  END;
    CTRL_C, 'C' : Copy_Block(T,ins);
    CTRL_D, 'D' : BEGIN gotoxy(1,1); ClrEol;
                        Write('MOPS-Editor : Textfile wird nicht gespeichert ? (j/ )');
                        Lies(Taste,Secnd, Double);
                        IF Upcase(Taste) = 'J'
                           THEN BEGIN ClrScr; Writeln(Name,' nicht gespeichert');
                                      Ende := True
                                END
                           ELSE Kommando(Ins)
                  END;
    CTRL_H, 'H' : To_Hide_or_not_to_Hide(T, ins);
    CTRL_K, 'K' : BEGIN T.Be := T.y_p;
                        T.Bs := (T.Ba <= T.Be) AND (T.Ba <>0);
                        Bild(T, ins)
                  END;
    CTRL_P, 'P' : Print_Block(T);
    CTRL_R, 'R' : Read_Block(T,ins);
    CTRL_S, 'S' : BEGIN Text_Speichern(T,Name, Ende);
                        IF not Ende THEN Bild(T,ins) END;
    CTRL_V, 'V' : Move_Block(T,ins);
    CTRL_W, 'W' : Write_Block(T,ins);
    CTRL_Y, 'Y' : Loesche_Block(T,ins)
 END
END;

PROCEDURE Jmp_TextAnfang(VAR T: T_Text; ins : Boolean);
BEGIN
   T.Bild := T.Anfang; T.Schreib := T.Anfang;
   T.x_p := 1; T.y_p := 1; T.ry := 2;
   Bild(T,Ins)
END;

PROCEDURE Jmp_TextEnde(VAR T: T_Text; ins : Boolean);
BEGIN
   WHILE (T.Schreib<>T.Ende) DO
          BEGIN Vorwaerts(T.Schreib); Vorwaerts(T.Bild);
                Inc(T.y_P);
          END;
   T.x_p :=1;
   Bild(T,Ins)
END;

PROCEDURE Jmp_Bildoberkante(VAR T: T_Text);
VAR i : Integer;
BEGIN
   IF T.ry >3
     THEN BEGIN
             FOR i := T.ry DOWNTO 3 DO
                 BEGIN Zurueck(T.Schreib); Dec(T.y_p) END;
             T.ry := 3
          END
END;

PROCEDURE Jmp_Bildunterkante(VAR T: T_Text);
VAR I : Integer;
BEGIN
   IF T.ry < Maxy_1
     THEN WHILE (T.ry < Maxy_1) AND (T.Schreib<>T.Ende) DO
                BEGIN Vorwaerts(T.Schreib); Inc(T.y_p); Inc(T.ry) END;
END;

PROCEDURE Loesche_Zeilenende(VAR T: T_Text);
VAR Z : T_Zeile;
BEGIN
   ClrEol;
   Z := getZeile(T.Schreib);
   Delete(Z, T.x_P, Maxx - T.x_P);
   setZeile(T.Schreib, Z)
END;

FUNCTION Upper(Ul: T_Zeile):T_Zeile;
VAR i : Integer;
    UC : T_Zeile;
BEGIN
   UC := '';
   FOR i := 1 TO length(Ul) DO
       UC := UC + Upcase(Ul[i]);
   Upper := UC
END;

FUNCTION Found(VAR T: T_Text; Find : T_Zeile; VAR YPos : PT_Knoten;
               VAR XPos : Integer): Boolean;
VAR gefunden : Boolean;
    Xh       : Integer;
    ZRest, UpCFind    : T_Zeile;

BEGIN
   UpCFind := Upper(Find);
   IF T.X_p = 1  (* length(Ypos^.inh) *)
      THEN gefunden := false
      ELSE BEGIN ZRest := copy(getZeile(Ypos),T.x_p,Maxx-T.x_p);
                 xh := Pos(UpCFind,Upper(ZRest));
                 gefunden := xh > 0;
                 IF gefunden THEN Xpos := xh+ T.x_P -1
                             ELSE VorWaerts(YPos)
           END;
   WHILE not gefunden AND (Ypos <> nil)
     DO BEGIN gefunden := Pos(UpCFind,Upper(getZeile(YPos))) > 0;
              IF not gefunden THEN Ypos := YPos^.next
                              ELSE XPos := Pos(UpCFind,Upper(getZeile(YPos)))
        END;
   Found := gefunden
END;

PROCEDURE Suche(VAR T: T_Text; ins: Boolean; VAR Find, Repl : T_Zeile);
VAR Hilf : PT_Knoten;
    x_Pos : Integer;
BEGIN
  Hilf := T.Schreib; x_Pos := T.x_p;
  Gotoxy(1,1); Write('Suche : '); ClrEol;
  Readln(Find); Repl :='';
  IF Found(T, Find, Hilf, x_Pos)
     THEN BEGIN WHILE Hilf <> T.Schreib
                   DO BEGIN Vorwaerts(T.Bild); Vorwaerts(T.Schreib);
                           Inc(T.y_P)
                      END;
                Bild(T,Ins);
                T.x_P := x_Pos + Length(Find);
          END
     ELSE BEGIN Gotoxy(1,1);
                Write(Find, ' nicht gefunden ....'); ClrEol;
                crt.Delay(1000)
          END;
  Kommando(ins)
END;

PROCEDURE Tausche(VAR T: T_Text; Find, Repl : T_Zeile; X_pos : Integer; ins: Boolean);
VAR C : Char;
    Z : T_Zeile;
BEGIN
  Gotoxy(1,1); Write('Ersetzen j/n :');ClrEol;
  WHILE not keypressed
    DO BEGIN gotoxy(x_pos, T.ry); crt.Delay(100); Gotoxy(16,1); crt.Delay(100)
       END;
  c := readkey;
  IF (Upcase(C) = 'Y') OR (upcase(C) = 'J')
     THEN BEGIN Z := getZeile(T.Schreib);
                Delete(Z, x_Pos, length(Find));
                Insert(Repl, Z,x_Pos);
                Gotoxy(1,T.ry); SetVideo(T,T.y_P);
                Write(Z); ClrEol;
                inc(T.x_p,length(Repl));
                setZeile(T.Schreib, Z)
          END;
  Kommando(ins)
END;

PROCEDURE Suche_ersetze(VAR T: T_Text; ins: Boolean;
                        VAR Find, Repl : T_Zeile);
VAR Hilf  : PT_Knoten;
    x_Pos : Integer;
BEGIN
  Hilf := T.Schreib; x_Pos := T.x_p;
  Gotoxy(1,1); Write('Suche : '); ClrEol;
  Readln(Find);
  Gotoxy(1,1); Write('Ersetzen durch : '); ClrEol;
  Readln(Repl);
  IF Found(T, Find, Hilf, x_Pos)
     THEN BEGIN WHILE Hilf <> T.Schreib
                 DO BEGIN Vorwaerts(T.Bild); Vorwaerts(T.Schreib);
                          INC(T.y_p)
                    END;
                Bild(T,ins);
                T.x_P := x_Pos;
                Tausche(T, Find, Repl, X_Pos,ins)
          END
     ELSE BEGIN Gotoxy(1,1);
                Write(Find,' nicht gefunden .....'); ClrEol; crt.Delay(1000)
          END;
  Kommando(ins)
END;

PROCEDURE CTRL_Q_Kommandos(VAR T: T_Text; ins : Boolean; Secnd : Char;
                          VAR Double: Boolean;
                          VAR Find, Repl : T_Zeile);
VAR Taste : Char;
BEGIN
  Gotoxy(78,1); Write('^Q');Gotoxy(T.x_p, T.ry);
  IF Double THEN BEGIN Taste := Secnd; Double := false END
            ELSE Lies(Taste,Secnd, Double);
  CASE upcase(Taste) OF
     CTRL_A, 'A' : Suche_ersetze(T,ins, Find, Repl);
     CTRL_B, 'B' : Jmp_Block(T, T.ba,ins);
     CTRL_C, 'C' : Jmp_TextEnde(T,ins);
     CTRL_D, 'D' : T.x_P := min(Length(getZeile(T.Schreib))+1, Maxx);
     CTRL_E, 'E' : Jmp_Bildoberkante(T);
     CTRL_F, 'F' : Suche(T,ins,Find,Repl);
     CTRL_K, 'K' : Jmp_Block(T, T.Be, ins);
     CTRL_R, 'R' : Jmp_TextAnfang(T,Ins);
     CTRL_S, 'S' : T.x_p := 1;
     CTRL_X, 'X' : Jmp_Bildunterkante(T);
     CTRL_Y, 'Y' : Loesche_Zeilenende(T)
 END
END;

PROCEDURE Wiederhole(VAR T: T_Text; ins : Boolean; Find, Repl : T_Zeile);
VAR Hilf : PT_Knoten;
    X_Pos : Integer;
BEGIN
  Gotoxy(1,1); Write('Suche : ',Find); clreol;
  Hilf := T.Schreib; x_Pos := T.x_p;
  IF (Find<>'') AND Found(T, Find, Hilf, x_Pos)
     THEN BEGIN WHILE Hilf <> T.Schreib
                   DO BEGIN Vorwaerts(T.Bild); Vorwaerts(T.Schreib);
                            INC(T.y_p)
                      END;
                Bild(T,ins);
                T.x_P := x_Pos;
                IF Repl <> '' THEN Tausche(T, Find,Repl, x_pos,ins)
                              ELSE Inc(T.x_P,length(Find))
          END
     ELSE BEGIN Gotoxy(1,1);
                Write(Find, ' nicht gefunden ....'); ClrEol; crt.Delay(1000);
                Kommando(ins)
          END;
END;

BEGIN      (* Hauptprogramm *)
  clrscr;    HighVideo;
  First_Line(T);
  Text_Laden(T,Work.TName);
  Ins:=True; Ende := false; Find := ''; Repl := '';
  IF Work.TFehler <> 1 THEN BEGIN T.BS := True;
                                  Jmp_Block(T, Work.TFehler, Ins);
                                  T.BS := false;
                                  Work.TFehler := 1
                            END;
  Bild(T,Ins);
  REPEAT
    Koord(T.x_p,T.y_p);
    GotoXY(T.x_p,T.ry);
    Lies(Taste,Secnd,Double);
    CASE Taste OF
      CTRL_A     : T.x_P := Wort_Anfang_L(getZeile(T.Schreib),T.x_P);
      CTRL_C     : Seiterunter(T);
      CTRL_D     : IF T.x_p < Maxx THEN Inc(T.x_p);
      CTRL_E     : rauf(T,Ins);
      CTRL_F     : T.x_p := Wort_Anfang_R(getZeile(T.Schreib),T.x_P);
      CTRL_G     : Entferne_Zeichen(T.x_p,T.Schreib);
      CTRL_H     : Delete_Zeichen(T,ins);
      CTRL_I     : Tab_rechts(T,ins);
      CTRL_K     : CTRL_K_Kommandos(T,ins,Secnd,Double, Ende, Work.TName);
      CTRL_L     : Wiederhole(T,ins, Find, Repl);
      CR         : Neue_Zeile(T,Ins);
      CTRL_N     : Erzeuge_Zeile(T,ins);
      CTRL_O     : Tab_links(T,ins);
      CTRL_Q     : CTRL_Q_Kommandos(T,ins,Secnd, Double,Find,Repl);
      CTRL_R     : Seiterauf(T);
      CTRL_S     : IF T.x_p > 1  THEN Dec(T.x_p);
      CTRL_T     : Wort_r_loeschen(T,ins);
      CTRL_V     : BEGIN Ins:=NOT Ins ; Kommando(Ins) END;
      CTRL_W     : Scroll_auf(T,ins);
      CTRL_X     : runter(T,Ins);
      CTRL_Y     : Entferne_Zeile(T,ins);
      CTRL_Z     : Scroll_ab(T,ins);
      ELSE IF Taste >= SPC
              THEN BEGIN setVideo(T,T.y_P);
                         Setze_Buchstaben(T.x_P,Taste,T.Schreib,Ins)
                   END
    END;
  UNTIL Ende;
  DisposeBlock(T.Anfang,T.Ende);
END;

BEGIN
  Trennzeichen := [' ','$',''''..'/',';'..'>'];
END. (* Implementation *)
