unit Editun;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,ClipBrd, WPDefs, WpWinCtr, WPRich, WPRuler, ExtCtrls, WPTbar, WPStatus,
  Buttons, WPPanel, Menus, StdCtrls;

type
  TEditForm = class(TForm)
    WPToolBar: TWPToolBar;
    WPRuler: TWPRuler;
    WPRichText: TWPRichText;
    WPStatusBar: TWPStatusBar;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    neu: TMenuItem;
    Speichern: TMenuItem;
    Speichernals: TMenuItem;
    N1: TMenuItem;
    Druckereinrichten: TMenuItem;
    Drucken: TMenuItem;
    N2: TMenuItem;
    Beenden: TMenuItem;
    Bearbeiten: TMenuItem;
    Ausschneiden: TMenuItem;
    Kopieren: TMenuItem;
    Einfuegen: TMenuItem;
    Loeschen: TMenuItem;
    Allesauswaehlen: TMenuItem;
    SuchenMain: TMenuItem;
    Suchen: TMenuItem;
    Ersetzen: TMenuItem;
    SucheWiederholen: TMenuItem;
    GehezuZeile: TMenuItem;
    Ansicht: TMenuItem;
    Toolbar: TMenuItem;
    Lineal: TMenuItem;
    Schrift: TMenuItem;
    FontDialog: TFontDialog;
    ZSuch_Panel: TPanel;
    Panel1: TPanel;
    Label1: TLabel;
    Zsuch_Nummer: TEdit;
    Zsuch_abbruch: TButton;
    Zsuch_ok: TButton;
    procedure LadenClick(Sender: TObject);
  procedure WPToolBarIconSelection(Sender: TObject; var Typ: TWpSelNr;
  const str: string; const group, num, index: Integer);
    procedure ToolbarClick(Sender: TObject);
    procedure LinealClick(Sender: TObject);
    procedure SchriftClick(Sender: TObject);
    procedure SuchenClick(Sender: TObject);
    procedure ErsetzenClick(Sender: TObject);
    procedure AllesauswaehlenClick(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure AusschneidenClick(Sender: TObject);
    procedure KopierenClick(Sender: TObject);
    procedure neuClick(Sender: TObject);
    procedure EinfuegenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure WPStatusBarUpdate(Sender: TObject);
    procedure WPRichTextXPosChanged(Sender: TObject);
    procedure WPRichTextYPosChanged(Sender: TObject);
    procedure WPRichTextChange(Sender: TObject);
    procedure WPRichTextKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BearbeitenClick(Sender: TObject);
    procedure SpeichernalsClick(Sender: TObject);
    procedure GehezuZeileClick(Sender: TObject);
    procedure SucheWiederholenClick(Sender: TObject);
    procedure Zsuch_okClick(Sender: TObject);
    procedure Zsuch_abbruchClick(Sender: TObject);

 private
   last_Replace : Boolean;
    { Private-Deklarationen }
 public
    { Public-Deklarationen }
  end;

var
  EditForm: TEditForm;

implementation

{$R *.DFM}

 procedure TEditForm.WPToolBarIconSelection(Sender: TObject; var Typ: TWpSelNr;
  const str: string; const group, num, index: Integer);
begin
   if Typ<>wptNone then
   begin
     if typ=wptIconSel then
     begin
     if group=WPI_GR_DISK then
     case num of
       WPI_CO_New  : BEGIN
                        NeuClick(Self);
                        IF WPToolBar<>nil
                           THEN WPToolbar.DeselectIcon(0,WPI_GR_Disk,WPI_CO_New);
                        Typ := wptNone
                     END;
       WPI_CO_OPEN : begin LadenClick(Self);
                           if WPToolBar<>nil then
                              WPToolBar.DeselectIcon(0,WPI_GR_DISK,WPI_CO_OPEN);
                           Typ:=wptNone;
                     end;
       WPI_CO_SAVE : BEGIN SpeichernClick(Self);
                           if WPToolBar<>nil then
                              WPToolBar.DeselectIcon(0,WPI_GR_DISK,WPI_CO_Save);
                           Typ := wptNone
                     END;
       WPI_CO_ClOSE : begin
                            if WPToolBar<>nil then
                              WPToolBar.DeselectIcon(0,WPI_GR_DISK,WPI_CO_CLOSE);
                            Typ:=wptNone;

                     end;
       WPI_CO_EXIT : Close;
       end;  end;
   end;
end;


procedure TEditForm.LadenClick(Sender: TObject);
begin
 IF opendialog.execute
    THEN BEGIN WPRichText.LoadFromFile(OpenDialog.Filename);
               EditForm.Caption := OpenDialog.FileName
         END
end;

procedure TEditForm.ToolbarClick(Sender: TObject);
begin
  IF Toolbar.Checked
     THEN BEGIN Toolbar.Checked := false;
                WPToolbar.Visible := false
          END
     ELSE BEGIN ToolBar.Checked := true;
                WPToolbar.Visible := true
          END
end;

procedure TEditForm.LinealClick(Sender: TObject);
begin
     IF Lineal.Checked
     THEN BEGIN Lineal.Checked := false;
                WPRuler.Visible := false
          END
     ELSE BEGIN Lineal.Checked := true;
                WPRuler.Visible := true
          END
end;

procedure TEditForm.SchriftClick(Sender: TObject);
begin
  IF Fontdialog.Execute
     THEN BEGIN
             WPRichText.Font := FontDialog.Font;
             WPRichText.Invalidate
          END
end;

procedure TEditForm.SuchenClick(Sender: TObject);
begin
  Last_Replace := false; WPRichText.FindDialog
end;

procedure TEditForm.ErsetzenClick(Sender: TObject);
begin
  Last_Replace := true; WPRichText.Replacedialog
end;

procedure TEditForm.AllesauswaehlenClick(Sender: TObject);
begin
  WPRichText.SelectAll
end;

procedure TEditForm.LoeschenClick(Sender: TObject);
begin
  WPRichText.Clearselection
end;

procedure TEditForm.AusschneidenClick(Sender: TObject);
begin
 WPRichText.CuttoClipboard
end;

procedure TEditForm.KopierenClick(Sender: TObject);
begin
 WPRichText.CopytoClipboard
end;

procedure TEditForm.neuClick(Sender: TObject);
begin
   WPRichText.Clear;
   EditForm.Caption := 'leer.MTX'
end;

procedure TEditForm.EinfuegenClick(Sender: TObject);
begin
  WPRichText.PastefromClipboard
end;

procedure TEditForm.SpeichernalsClick(Sender: TObject);
begin
  IF SaveDialog.Execute
    THEN BEGIN WPRichText.SavetoFile(SaveDialog.FileName);
               WPRichText.modified := false;
               WPStatusbar.SetString(stChanged,'')
         END
end;

procedure TEditForm.SpeichernClick(Sender: TObject);
begin
  IF EditForm.Caption = 'leer.MTX'
     THEN SpeichernalsClick(Sender)
     ELSE BEGIN WPRichText.SavetoFile(EditForm.Caption);
                WPRichText.Modified := false;
                WPStatusbar.SetString(stChanged,'')
          END
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  IF WPRichText.isempty
     THEN CanClose := true
     ELSE IF WPRichText.modified
             THEN CASE MessageDlg('Datei sichern', mtConfirmation, mbyesnocancel,0) OF
                    mryes    : WPRichText.SavetoFile(EditForm.Caption);
                    mrno     : Canclose := true;
                    mrcancel : CanClose := false
                  END
             ELSE CanClose := true
end;

procedure TEditForm.FormActivate(Sender: TObject);
begin
 EditForm.Caption := 'leer.MTX'
end;

procedure TEditForm.WPStatusBarUpdate(Sender: TObject);
VAR Kapitel,Seite, x_pos, y_Pos : LongInt;
begin
   WPRichText.GetPosition(Kapitel, Seite, x_pos, y_pos);
   WPStatusBar.SetString(stHelp,IntTostr(x_pos))
end;

procedure TEditForm.WPRichTextXPosChanged(Sender: TObject);
VAR Kapitel,Seite, x_pos, y_Pos : LongInt;
begin
   WPRichText.GetPosition(Kapitel, Seite, y_pos, x_pos);
   WPStatusBar.SetString(stXpos,IntTostr(x_pos+1));
   end;

procedure TEditForm.WPRichTextYPosChanged(Sender: TObject);
begin
   WPStatusBar.SetString(styPos,IntTostr( WPRichText.cpLineNr+1));
   WPStatusBar.SetString(stPage,IntTostr(WPRichText.getPageNumber+1));
end;

procedure TEditForm.WPRichTextChange(Sender: TObject);
begin
  WPStatusbar.SetString(stChanged,'gendert')
end;

procedure TEditForm.WPRichTextKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   IF WPRichText.Inserting
             THEN WPStatusBar.SetString(stInsert,'Einfgen')
             ELSE WPStatusBar.SetString(stInsert,'berschreiben')

end;

procedure TEditForm.BearbeitenClick(Sender: TObject);
begin
   ClipBoard.Open;
   EinFuegen.enabled := ClipBoard.HasFormat(cf_Text);
   ClipBoard.Close;
   IF WPRichText.Sellength >0
      THEN BEGIN Ausschneiden.Enabled := true;
                 Kopieren.Enabled := true;
                 Loeschen.Enabled := true
           END
      ELSE BEGIN Ausschneiden.Enabled := false;
                 Kopieren.Enabled := false;
                 Loeschen.Enabled := false
           END
end;

procedure TEditForm.GehezuZeileClick(Sender: TObject);
begin
   Zsuch_Nummer.Text := InttoStr(WPRichText.CPLineNr+1);
   Zsuch_Panel.Visible := true;
   Zsuch_nummer.Setfocus
end;

procedure TEditForm.SucheWiederholenClick(Sender: TObject);
begin
  IF Last_Replace
     THEN ErsetzenClick(Sender)
     ELSE SuchenClick(Sender);
end;

procedure TEditForm.Zsuch_okClick(Sender: TObject);
VAR Zeile, err :Integer;
    ZStr  : String;
begin
 ZStr := ZSuch_Nummer.Text;
 TRY
   val(ZStr, Zeile, err);
 EXCEPT
   messagedlg('keine Zahl', mtError,[mbok],0)
 END;
 IF err = 0
    THEN IF (Zeile >0) AND (Zeile <= WPRichText.countLines)
            THEN WPRichText.SetPosition(0,Zeile-1,0,0);
   Zsuch_Panel.visible := false;
   WPRichText.setfocus
end;

procedure TEditForm.Zsuch_abbruchClick(Sender: TObject);
begin
  Zsuch_Panel.visible := false;
  WPRichText.setfocus
end;

end.
