UNIT EpromDos;

interface

USES Luchstyp;

PROCEDURE Erzeuge_Eprom(Workfile: T_Workfile);

implementation

uses crt, dos, filedos;
(* erzeugt ein Eprom - File *)
(*$I-*)

CONST MaxIndex=127;
      MaxBlockNr=$FFF;

TYPE String80  = String[80];
     T_Block   = ARRAY[0..Maxindex] OF Byte;
     T_Eprom   = File;
     T_Belegt  = packed ARRAY[0..MaxBlockNr] OF Boolean;

VAR Eprom : T_Eprom;
    Belegt: T_Belegt;
    Mainstart: Longint;
    ok: Boolean;
    Epromname: String80;
    Leerblock: T_Block;
    Zeile: Word;

PROCEDURE HexAdresse(i:Longint; VAR s:String80);

  FUNCTION Hexdigit(i: Word):Char;
  BEGIN i:=i AND $000F;
        IF i<=9 THEN Hexdigit:=chr(i+$30)
                ELSE Hexdigit:=Chr(i-10+$41);
  END;

BEGIN
  s:='$'+Hexdigit( i shr 24)
        +Hexdigit( i shr 20)
        +Hexdigit( i shr 16)
        +Hexdigit( i shr 12)
        +Hexdigit( i shr 8)
        +Hexdigit( i shr 4)
        +Hexdigit( i );
END;

PROCEDURE Fehler(s: String80);
BEGIN
  gotoxy(1,24); clreol;
  write(#7,s);
  Close(Eprom);
  write(' <RETURN>'); readln;
  ok:=False;
END;

PROCEDURE IOFehler(art,name: String80);
BEGIN
  Fehler('Fehler beim '+art+'von <'+name+'>')
END;

PROCEDURE Startadressfehler(Filename: String80; Adresse:Longint);
VAR s: String80;
BEGIN
  HexAdresse(adresse,s);
  Fehler('Startadresse '+s+' von <'+Filename+'> fehlerhaft');
END;

PROCEDURE Blockfehler(i: Word);
VAR s: String80;
BEGIN
  HexAdresse(i*$80,s);
  Fehler('Der Block ab '+s+' ist doppelt belegt')
END;

PROCEDURE Einlesen(FName: String80;
                   VAR Eprom : T_Eprom;
                   VAR Belegt: T_Belegt;
                   VAR Start : LongInt;
                   VAR Zeile : Word);

VAR Anfang,i: Longint;
    Block   : T_Block;
    f       : File;
BEGIN
  IF ok THEN Gotoxy(1,Zeile); write('Einlesen: '+FName);
  IF zeile<25 THEN inc(Zeile);
  Assign(f,FName); Reset(f);
  IF ioresult<>0 THEN IOFehler('ffnen',FName);
  IF ok THEN Blockread(f,Block,1);  (* Startadressblock *)
  IF Ioresult<>0 THEN IOFehler('Lesen',FName);
  Start:= Block[0] * $1000000 +
         (Block[1] * $10000) AND $00FF0000 +
         (Block[2] * $100) AND $0000FF00 +
          Block[3];
  IF ok AND ((Start > MaxBlockNr*(Maxindex+1))
              OR ((Start AND $7F) <> 0)
              OR (Start < 0))
     THEN StartadressFehler(FName,Start)
     ELSE BEGIN Anfang:=Start DIV (Maxindex+1);
                seek(Eprom,Anfang);
                i:=Start DIV (MaxIndex+1);
                WHILE NOT eof(f) DO
                    BEGIN Blockread(f,Block,1);
                          IF Ioresult<>0 THEN IOFehler('Einlesen',FName);
                          IF ok THEN blockwrite(Eprom,Block,1);
                          IF Ioresult<>0 THEN IOFehler('Schreiben',Epromname);
                          IF (i and 3) =0
                             THEN BEGIN gotoxy(((i DIV 4) mod (64))+10,
                                               ((i DIV 4) DIV (64))+3);
                                        write('X')
                                  END;
                          IF Belegt[i] THEN Blockfehler(i);
                          Belegt[i] := True;
                          inc(i)
                    END
          END;
          Close(f);
END;



PROCEDURE Zusatzfiles_Einlesen(VAR Eprom : T_Eprom;
                               VAR Belegt: T_Belegt;
                               VAR Zeile: Word);
VAR y,Start     : Longint;
    Filename    : String80;
    weitermachen: Boolean;

BEGIN
  y:=19; weitermachen:=True;
  WHILE ok and weitermachen DO
    BEGIN Gotoxy(1,Zeile); clreol;
          write('Name weiterer Files: '); Readln(Filename);
          weitermachen:=Filename <> '';
          IF weitermachen THEN einlesen(Filename,Eprom,Belegt,Start,Zeile);
    END
END;

PROCEDURE Startadresse_programmieren(VAR Eprom: T_Eprom;
                                         Mainstart: Longint);
VAR Block   : T_Block;
i:word;
BEGIN
  Seek(Eprom,0);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  Blockread(Eprom,Block,1);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  Block[$18]:=(Mainstart DIV $1000000) AND $FF;
  Block[$19]:=(Mainstart AND $00FF0000) DIV $10000;
  Block[$1A]:=(Mainstart AND $0000FF00) DIV $100;
  Block[$1B]:=Mainstart AND $FF;
  seek(eprom,0);
  BlockWrite(eprom,block,1);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  if ok then Close(Eprom);
  IF ioresult<>0 THEN IOFehler('Speichern',Epromname)
END;

PROCEDURE Erzeuge(VAR Leerblock: T_Block;
                  VAR Eprom:T_Eprom;
                  VAR Belegt: T_Belegt;
                  VAR Epromname: String80);
VAR s: String80;
    i: Longint;
BEGIN
  IF Epromname = ''
     THEN Fehler('Es wird keine Epromdatei erzeugt')
     ELSE BEGIN assign(Eprom,Epromname); Rewrite(Eprom);
                FOR i:=0 TO Maxindex DO Leerblock[i]:=$FF;
                FOR i:=0 TO MaxBlockNr DO
                  BEGIN Blockwrite(Eprom,Leerblock,1);
                        IF Ioresult<>0 THEN Fehler('Fehler beim Erzeugen der Datei '+Epromname);
                        belegt[i]:=False;
                        IF (i AND (MaxBlockNr div 16)) = 0
                           THEN BEGIN gotoxy(1,i DIV (MaxBlockNr div 16) +3);
                                      HexAdresse(i*(MaxIndex+1),s);
                                      writeln(s+': ')
                                END;
                  END;
          END
END;

procedure erzeuge_Eprom(Workfile: T_Workfile);
var i:Word;
BEGIN
  FOR i:=1 TO length(Workfile.CName)
      DO Workfile.CName[i]:=Upcase(Workfile.CName[i]);
  ok:=True;
  EpromName:=Copy(Workfile.CName,1,length(Workfile.CName)-3)+'EPR';
  clrscr;
  writeln('Eprom-Name=',Epromname,' erzeugen');
  Erzeuge(Leerblock,Eprom,belegt,Epromname);
  Zeile:=19;
  IF ok THEN Einlesen(Sysinfo.SysName,Eprom,Belegt,MainStart,Zeile);
  IF ok THEN IF Pos('SYSLUCHS.MCD',Workfile.CName)=0
                THEN Einlesen(Workfile.CName,Eprom,Belegt,MainStart,Zeile);
  IF ok THEN Zusatzfiles_einlesen(Eprom,Belegt,Zeile);
  IF ok THEN Startadresse_Programmieren(Eprom,Mainstart);
  clrscr; gotoxy(1,13);
  IF ok THEN writeln('Epromdatei '+Epromname+' fertiggestellt')
        ELSE writeln('Epromdatei '+Epromname+' nicht korrekt erzeugt');
END;

BEGIN
END.

