unit Epromwin;

interface

uses
  Luchstyp,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TEpromForm = class(TForm)
    Dateilabel: TLabel;
    fertigbutton: TButton;
    weiterButton: TButton;
    EpromOpenDialog: TOpenDialog;
    Memo: TMemo;
    EinleseLabel: TLabel;
    procedure fertigbuttonClick(Sender: TObject);
    procedure weiterButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  EpromForm: TEpromForm;

procedure erzeuge_Eprom;

implementation

{$R *.DFM}

CONST MaxIndex=127;
      MaxBlockNr=$FFF;

TYPE String80  = String[80];
     T_Block   = ARRAY[0..Maxindex] OF Byte;
     T_Belegt  = RECORD Feld: ARRAY[0..MaxBlockNr] OF Boolean
                 END;
     ptr_Belegt= ^T_Belegt;

VAR f,Eprom : File;
    f_open,Eprom_open: Boolean;
    Belegt: Ptr_Belegt;
    Main_start: Longint;
    ok,belegt_aktiv: Boolean;
    Epromname: T_Filename;

PROCEDURE HexAdresse(i:Longint; VAR s:String80);

  FUNCTION Hexdigit(i: Word):Char;
  BEGIN i:=i AND $000F;
        IF i<=9 THEN Hexdigit:=chr(i+$30)
                ELSE Hexdigit:=Chr(i-10+$41);
  END;

BEGIN
  s:='$'+Hexdigit( i shr 24)
        +Hexdigit( i shr 20)
        +Hexdigit( i shr 16)
        +Hexdigit( i shr 12)
        +Hexdigit( i shr 8)
        +Hexdigit( i shr 4)
        +Hexdigit( i );
END;

PROCEDURE Closefiles;
BEGIN
  IF Eprom_open THEN Close(Eprom);
  IF f_open THEN Close(f);
  Eprom_open:=False;
  f_open:=False;
  IF belegt_aktiv THEN BEGIN Dispose(belegt); Belegt_aktiv:=False END;
END;

PROCEDURE Fehler(s: String80);
BEGIN
  IF ok THEN BEGIN Luchs_Info(s);
                   Epromform.weiterbutton.enabled:=False;
                   EpromForm.Fertigbutton.Caption:='&Abbruch';
                   Luchs_Info('Epromdatei '+Epromname+' nicht korrekt erzeugt');
                   ok:=False;
             END;
END;

PROCEDURE IOFehler(art,name: String80);
BEGIN
  Fehler('Fehler beim '+art+'von <'+name+'>');
END;

PROCEDURE Startadressfehler(Filename: T_Filename; Adresse:Longint);
VAR s: String80;
BEGIN
  HexAdresse(adresse,s);
  Fehler('Startadresse '+s+' von <'+Filename+'> fehlerhaft');
END;

PROCEDURE Einlesen(FName: T_Filename; VAR Start: Longint);
VAR Anfang,i: Longint;
    Memozeile,Memospalte: Word;
    Block   : T_Block;
    Zeile,s : String;
BEGIN
  Epromform.weiterbutton.enabled:=False;
  EpromForm.Einleselabel.Caption:='Einlesen: '+FName;
  EpromForm.Update;
  Assign(f,FName); Reset(f);
  IF ioresult<>0 THEN IOFehler('ffnen',FName) ELSE f_open:=True;
  IF ok THEN Blockread(f,Block,1);  (* Startadressblock *)
  IF Ioresult<>0 THEN IOFehler('Lesen',FName);
  Start:= Block[0] * $1000000 +
             (Block[1] * $10000) AND $00FF0000 +
             (Block[2] * $100) AND $0000FF00 +
              Block[3];
  IF ok AND ((Start > MaxBlockNr*(Maxindex+1))
              OR ((Start AND $7F) <> 0)
              OR (Start < 0))
     THEN StartadressFehler(FName,Start)
     ELSE BEGIN Anfang:=Start DIV (Maxindex+1);
                seek(Eprom,Anfang);
                i:=Start DIV (MaxIndex+1);
                WHILE ok AND (NOT eof(f)) DO
                    BEGIN IF Belegt^.Feld[i]
                             THEN BEGIN HexAdresse(i*$80,s);
                                        Fehler('Der Block ab '+s+' ist doppelt belegt')
                                  END;
                          IF ok THEN Blockread(f,Block,1);
                          IF Ioresult<>0 THEN IOFehler('Einlesen',FName);
                          IF ok THEN blockwrite(Eprom,Block,1);
                          IF Ioresult<>0 THEN IOFehler('Schreiben',Epromname);
                          Memozeile:=(i DIV 4) DIV 64;
                          MemoSpalte:=((i DIV 4) mod (64))+10;
                          Zeile:=EpromForm.Memo.Lines[Memozeile];
                          IF Zeile[Memospalte]<>'X'
                             THEN BEGIN Zeile[Memospalte]:='X';
                                        EpromForm.Memo.Lines[Memozeile]:=Zeile;
                                  END;
                          belegt^.Feld[i] := True;
                          inc(i)
                    END
          END;
          Close(f);f_open:=False;
  IF ok THEN Epromform.weiterbutton.enabled:=True;
END;


PROCEDURE Startadresse_programmieren;
VAR Block   : T_Block;
BEGIN
  Seek(Eprom,0);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  Blockread(Eprom,Block,1);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  Block[$18]:=(Main_start DIV $1000000) AND $FF;
  Block[$19]:=(Main_start AND $00FF0000) DIV $10000;
  Block[$1A]:=(Main_start AND $0000FF00) DIV $100;
  Block[$1B]:=Main_start AND $FF;
  seek(eprom,0);
  BlockWrite(eprom,block,1);
  IF ioresult <> 0 THEN IOFehler('Speichern',Epromname);
  if ok then BEGIN Close(Eprom); eprom_open:=False END;
  IF ioresult<>0 THEN IOFehler('Speichern',Epromname)
END;

PROCEDURE Erzeuge_Epromdatei;
VAR s: String80;
    i: Longint;
    Leerblock: T_Block;
BEGIN
  assign(Eprom,Epromname); Rewrite(Eprom); Eprom_open:=False;
  FOR i:=0 TO Maxindex DO Leerblock[i]:=$FF;
  FOR i:=0 TO MaxBlockNr DO
      BEGIN Blockwrite(Eprom,Leerblock,1);
            IF Ioresult<>0 THEN Fehler('Fehler beim Erzeugen der Datei '+Epromname);
            belegt^.Feld[i]:=False;
            IF (i AND (MaxBlockNr div 16)) = 0
               THEN BEGIN HexAdresse(i*(MaxIndex+1),s);
                          Epromform.Memo.Lines.Add
                            (s+': ...............................................................');
                          EpromForm.Update;
                    END;
      END;
END;

FUNCTION Upcasestring(S: T_Bezeichner):T_Bezeichner;
var i:Integer;
BEGIN
  FOR i:=1 to Length(s) DO s[i]:=Upcase(s[i]);
  Upcasestring:=s
END;

procedure erzeuge_Eprom;
VAR Sysstart: Longint;
    Mainname: T_Filename;
BEGIN
  f_open:=False; Eprom_open:=False; Belegt_aktiv:=False;
  Epromform.Fertigbutton.Caption:='&Fertig';
  IF Workfile.CName <> ''
     THEN MainName:=Workfile.CName
     ELSE IF Epromform.Epromopendialog.execute
             THEN MainName:=Epromform.Epromopendialog.Filename
             ELSE MainName:='';
  EpromForm.Show;
  ok:=True;
  IF Mainname <>'' THEN Epromname:=Mainname
                   ELSE Epromname:=Sysinfo.Sysname;
  EpromName:=Copy(EpromName,1,length(EpromName)-3)+'EPR';
  Epromform.memo.clear;
  Epromform.Dateilabel.Caption:='Eprom-Name='+Epromname+' erzeugen';
  new(Belegt); Belegt_aktiv:=True;
  Erzeuge_Epromdatei;
  IF ok THEN Einlesen(Sysinfo.SysName,Sysstart);
  IF ok AND (Mainname<> '') AND (Pos('SYSLUCHS.MCD',Mainname)=0)
     THEN Einlesen(MainName,Main_start)
     ELSE Main_Start:=$FFFFFFFF;
  IF ok THEN Epromform.weiterbutton.enabled:=True;
  EpromForm.Fertigbutton.Enabled:=True;
END;

procedure TEpromForm.fertigbuttonClick(Sender: TObject);
begin
  IF ok THEN Startadresse_Programmieren;
  Closefiles;
  IF ok THEN Luchs_Info('Epromdatei '+Epromname+' fertiggestellt')
        ELSE Luchs_Info('Epromdatei '+Epromname+' nicht korrekt erzeugt');
  Epromform.close
end;

procedure TEpromForm.weiterButtonClick(Sender: TObject);
VAR Filename    : String80;
    weitermachen: Boolean;
    weiterstart : Longint; 
BEGIN
  EpromForm.EpromOpenDialog.Filename:='';
  IF EpromForm.EpromOpendialog.execute
     THEN einlesen(EpromForm.EpromOpendialog.Filename,weiterstart);
END;

end.
