UNIT FlashDos;

INTERFACE

PROCEDURE ProgFlash;

IMPLEMENTATION

USES DOS, Crt, Luchstyp, CommDos, GaugeDOS;


TYPE T_Flash=(NoFlash,AMD29F010,AMD29F040,ST29F040);

VAR  ok                 : Boolean;
     Flash_Typ          : T_Flash;
     Flash_Breite       : Word;
     Flash_Str          : String;
     Flash_Sektorgroesse: LongInt;
     Taste              : Char;


FUNCTION Hex_Flashadr(Adresse: Longint): String;
BEGIN
   Hex_FlashAdr:='$'+Copy(HexLong(Adresse),4,5);
END;

FUNCTION Hex_FlashSektorAdr(Nr: Word): String;
BEGIN
   Hex_FlashSektorAdr:='$'+Copy(HexLong(Flash_sektorgroesse*Nr),4,5);
END;

PROCEDURE Flash_Return_Meldung;
BEGIN
  InputRec.Meldung[6]:='<Return>'; Show_Meldung;
  REPEAT Taste:=Readkey UNTIL Taste=#13
END;

{

    PROCEDURE Startmoeglichkeit(VAR MonStart: Boolean);
    VAR Taste: Char;
    BEGIN
      MonStart:=False;
      Meldung[1]:='  Daten korrekt bertragen';
      Meldung[3]:='  Starten?         S(tandalone';
      Meldung[4]:='                   H(ostrechner';
      Meldung[5]:='                   N(icht starten';
      Show_Meldung(Meldung); Taste:=Upcase(Readkey);
      CASE Taste OF
        'S': BEGIN Put_Byte($FF);
                   Meldung[3]:='  Programm als Standalone-Sytem gestartet....';
             END;
        'H': BEGIN MonStart:=True; clrscr; Put_Byte($F0) END
        ELSE BEGIN Put_Byte(0);
                   Meldung[3]:='MOPS kurz ausschalten oder RESET geben'
             END
      END;
    END;

 }

 PROCEDURE Sektor_Loeschen(Sektornummer: Word; VAR ok: Boolean);
 VAR Sektoradresse: Longint;
     Antwort: Byte;
     Adressstring: String;
     Abbruch: Boolean;
 BEGIN
    Sektoradresse:=Flash_Sektorgroesse*Sektornummer;
    Adressstring:=Hex_FlashSektorAdr(Sektornummer);
    InputRec.Meldung[3]:='Loesche Sektor '+AdressString;
    Show_Meldung;
    Put_Byte(Bef_Sektorloeschen); Put_Long(Sektoradresse);
    Read_Byte_HS(Antwort,Abbruch);
    IF (Antwort <> $A5) OR Abbruch
       THEN BEGIN InputRec.Meldung[3]:='Sektor '+AdressString+' konnte nicht geloescht werden';
                  Flash_Return_Meldung;
                  ok:=False
            END
 END;

 PROCEDURE Suche_Flash;
 VAR Flashcode: Longint;
     b: Byte;
     abbruch: Boolean;
 BEGIN
   Flash_Typ:=NoFlash;
   Start_Kommunikation(ok);
   IF ok THEN BEGIN Put_Byte(Bef_MonInsRam);
                    delay(200);
                    Start_Kommunikation(ok)
              END;
   IF ok THEN
      BEGIN Put_Byte(Bef_Liesflash);
            Read_Long_HS(FlashCode,ok);
            InputRec.Meldung[1]:='Flash_Code='+Hexlong(Flashcode);
                 IF FlashCode=$01012020
                    THEN BEGIN Flash_Typ:=AMD29F010;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$08000;
                               Flash_str:='AMD29F010 16 Bit breit' END
            ELSE IF FlashCode=$0101A4A4
                    THEN BEGIN Flash_Typ:=AMD29F040;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$20000;
                               Flash_str:='AMD29F040 16 Bit breit' END
            ELSE IF FlashCode=$2020E2E2
                    THEN BEGIN Flash_Typ:=ST29F040;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$20000;
                               Flash_str:='ST29F040 16 Bit breit'  END
            ELSE IF FlashCode=$0120
                    THEN BEGIN Flash_Typ:=AMD29F010;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$04000;
                               Flash_str:='AMD29F010 8 Bit breit'  END
            ELSE IF FlashCode=$01A4
                    THEN BEGIN Flash_Typ:=AMD29F040;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$10000;
                               Flash_str:='AMD29F040 8 Bit breit'  END
            ELSE IF FlashCode=$20E2
                    THEN BEGIN Flash_Typ:=ST29F040;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$10000;
                               Flash_str:='ST29F040 8 Bit breit'  END
            ELSE BEGIN Flash_Typ:=NoFlash;
                       InputRec.Meldung[2]:='Kein Flash-Eprom gefunden';
                 END
      END;
   ok:=ok AND (Flash_Typ <> NoFlash)
 END;

 PROCEDURE Programmspeichern(Dateiname: T_Filename; SysProg: Boolean);
 VAR ok: Boolean;
     Code : T_Code;
     i,size : Word;

     (* TestClear prueft, ob die Datei zu gross ist   *)
     (* bzw, ob das Flasheprom geloescht ist          *)

     PROCEDURE TestClear;
     VAR Ergebnis: Byte;
         Abbruch: Boolean;
         Max: Longint;
     BEGIN
        Max:=8*Flash_Sektorgroesse;
        IF Code.Startadresse>=Max
           THEN BEGIN ok:=False;
                      InputRec.Meldung[2]:='Die Startadresse $'+
                                           HexLong(Code.Startadresse)+' von';
                      InputRec.Meldung[3]:=Workfile.CName;
                      InputRec.Meldung[4]:='liegt nicht im Flash-Eprom';
                      Flash_Return_Meldung;
                END
           ELSE IF Code.Startadresse+Code.Laenge >= Max
           THEN BEGIN ok:=False;
                      InputRec.Meldung[2]:='Die Datei '+Workfile.CName;
                      InputRec.Meldung[3]:=' ist zu gross fuer das Flash-Eprom';
                      Flash_Return_Meldung;
                END;
        IF ok
           THEN BEGIN Put_Byte(Bef_TestClear);
                      Put_Long(Code.Startadresse);
                      Put_Long(Code.Laenge);
                      Read_Byte_HS(Ergebnis,Abbruch);
                      ok:=NOT Abbruch AND (Ergebnis=$FF);
                      IF NOT ok THEN
                         BEGIN inputRec.Meldung[3]:='Flash-Eprom ist nicht geloescht';
                               Flash_Return_Meldung;
                         END
                END
     END;

     PROCEDURE ProgDatei;
     VAR Rest,Adresse: LongInt;
         Ergebnis,i: Byte;
         Abbruch: Boolean;
     BEGIN
       InitMainGauge('FLASH-Programmierung','');
       Adresse:=Code.Startadresse; Rest:=Code.Laenge;
       WHILE ok AND (Rest>0) DO
         BEGIN Blockread(Code.f, Code.Block, 1);  (* 128 Byte lesen *)
               ok:=Ioresult=0;
               i:=0;
               Put_Byte(Bef_Prog);
               Put_Long(Adresse);
               IF Rest<128 THEN Put_Byte(Rest) ELSE Put_Byte(128);
               WHILE (Rest>0) AND (i<128) DO     (* Block senden *)
                 BEGIN Put_Byte(Code.Block[i]);
                       i:=i+1; Rest:=Rest-1;
                 END;
               Read_Byte_HS(Ergebnis,Abbruch);
               ok:=(Ergebnis=$A5) AND NOT Abbruch;
               Adresse:=Adresse+128;
               Showgauge(((Code.Laenge-Rest) * 100 ) DIV Code.Laenge);
         END;
         ExitMainGauge;
         IF Abbruch OR NOT ok
            THEN Inputrec.Meldung[3]:='Programmier-Fehler'
            ELSE InputRec.Meldung[1]:='Datei '+Dateiname+' ist programmiert';
         Flash_Return_Meldung;
     END;

     PROCEDURE ProgStart;
     VAR Taste: Char;
         Ergebnis: Byte;
         Abbruch: Boolean;
     BEGIN
       InputRec.Meldung[1]:='Datei '+WorkFile.CName;
       InputRec.Meldung[2]:='Startadresse $'+HexLong(SysInfo.Epromstart)+' fuer Autostart aktivieren?';
       InputRec.Meldung[3]:='Das Anwenderprogramm wird anschlieend selbstaendig laufen';
       InputRec.Meldung[5]:='S(tartadresse programmieren         <ESC>';
       Show_Meldung;
       REPEAT Taste:=Upcase(Readkey) UNTIL Taste IN [#27,'S'];
       IF Taste ='S' THEN
         BEGIN Put_Byte(Bef_TestClear);
               Put_Long(Adr_Standalone);
               Put_Long(4);
               Read_Byte_HS(Ergebnis,Abbruch);
               ok:=NOT Abbruch AND (Ergebnis=$FF);
               IF ok THEN
                BEGIN
                 Put_Byte(Bef_Prog);
                 Put_Long($18);        (* Adresse des Standalonezeigers *)
                 Put_Byte(4);          (* ein Langwort programmieren    *)
                 Put_Byte((Code.StartAdresse shr 24) AND $FF);
                 Put_Byte((Code.StartAdresse shr 16) AND $FF);
                 Put_Byte((Code.StartAdresse shr  8) AND $FF);
                 Put_Byte(Code.StartAdresse AND $FF);
                 Read_Byte_HS(Ergebnis,Abbruch);
                 ok:=(Ergebnis=$A5) AND NOT Abbruch;
                 IF NOT ok OR Abbruch
                  THEN InputRec.Meldung[3]:='fehlerhafte Programmierung der Startadresse'
                  ELSE BEGIN InputRec.Meldung[1]:='Standalone-Betrieb ist ab dem naechsten Reset aktiviert';
                             InputRec.Meldung[3]:='Eine erneute Kommunikation mit dem Hostrechner';
                             InputRec.Meldung[4]:='ist danach nur mit dem Manual-Reset-Verfahren moeglich.';
                       END
                END
                ELSE BEGIN InputRec.Meldung[1]:='Eine Startadresse ist bereits eingetragen';
                           InputRec.Meldung[3]:='Programmieren Sie zunaechst SYSLUCHS neu';
                     END;
              Flash_Return_meldung
         END;
     END;

 BEGIN        (* Programmspeichern *)
    IF Dateiname <> ''
       THEN BEGIN Assign(Code.f,Dateiname);
                  Reset(Code.f); ok:=Ioresult = 0
            END
       ELSE ok:=False;
    IF NOT ok
     THEN BEGIN InputRec.Meldung[3]:='Datei '+Dateiname+' nicht vorhanden';
                Flash_Return_Meldung;
          END
     ELSE
       BEGIN
        size := Filesize(Code.F)- 1;
        Blockread(Code.f, Code.Block, 1);
        Code.Startadresse := Code.Block[0] * $1000000 +
                             (Code.Block[1] * $10000) AND $00FF0000+
                             (Code.Block[2] * $100) AND $0000FF00 +
                             Code.Block[3];
        Code.Laenge :=       Code.Block[4] * $1000000 +
                             (Code.Block[5] * $10000) AND $00FF0000 +
                             (Code.Block[6] * $100) AND $0000FF00 +
                             Code.Block[7];
        IF SysProg AND (Code.Startadresse <> 0)
           THEN BEGIN InputRec.Meldung[3]:='Startadresse ist nicht $000000';
                      Flash_Return_Meldung
                END
           ELSE
            BEGIN
             IF SysProg THEN Sektor_Loeschen(0,ok);
             IF ok THEN
              BEGIN
               InputRec.Meldung[3]:='Programmiere die Datei '+Dateiname;
               InputRec.Meldung[4]:='Startadresse='+Hex_FlashAdr(Code.Startadresse);
               InputRec.Meldung[5]:='Codelaenge  ='+Hex_FlashAdr(Code.Laenge);
               Show_Meldung;
               TestClear;
               IF ok THEN ProgDatei;
               IF ok THEN ProgStart;
              END;
            END;
        Close(Code.f);
       END
  END;

  PROCEDURE Flash_Handling;
  VAR ch: Char;

     PROCEDURE Systemprog;
     VAR Taste: Char;
     BEGIN
       InputRec.Meldung[1]:='System neu programmieren, bitte bestaetigen';
       InputRec.Meldung[2]:='Es ist waehrend der Programmierung kein Reset erlaubt';
       InputRec.Meldung[3]:='Dateiname: '+Sysinfo.Sysname;
       InputRec.Meldung[5]:='S: System im Sektor 0 programmieren         <ESC>';
       Show_Meldung;
       REPEAT Taste:=Upcase(Readkey) UNTIL Taste IN [#27,'S'];
       IF Taste ='S' THEN Programmspeichern(Sysinfo.Sysname,True)
     END;

     PROCEDURE Sektorloeschen;
     VAR i: Byte;
     BEGIN
       InputRec.Meldung[1]:='Sektor loeschen, Startadresse waehlen';
       InputRec.Meldung[3]:=  '1: '+Hex_FlashSektorAdr(1)
                            +' 2: '+Hex_FlashSektorAdr(2)
                            +' 3: '+Hex_FlashSektorAdr(3)
                            +' 4: '+Hex_FlashSektorAdr(4)
                            +' 5: '+Hex_FlashSektorAdr(5)
                            +' 6: '+Hex_FlashSektorAdr(6)
                            +' 7: '+Hex_FlashSektorAdr(7);
       InputRec.Meldung[4]:='A: Sektor  1-7 '+Hex_FlashSektorAdr(1)
                            +' bis '+Hex_FlashSektorAdr(7);
       InputRec.Meldung[6]:='<ESC>';
       Show_Meldung;
       REPEAT ch:=Upcase(Readkey) UNTIL ch IN ['1'..'7',#27,'A'];
       CASE ch OF
         '1'..'7': Sektor_loeschen(ord(ch)-ord('0'),ok);
         'A'     : FOR i:=1 TO 7 DO Sektor_loeschen(i,ok);
       END;
     END;

  BEGIN        (* Flash_Handling *)
   REPEAT
    clrscr;
    writeln('Programmier-Routinen fuer das FLASH-Eprom '+Flash_Str);
    InputRec.Meldung[1]:='  L(oeschen eines Sektors';
    InputRec.Meldung[2]:='  S(ystem SYSLUCHS.MCD neu programmieren';
    IF Workfile.CName <> ''
       THEN InputRec.Meldung[3]:='  P(rogramm '+WorkFile.CName+' speichern';
    InputRec.Meldung[5]:='  <ESC>';
    Show_Meldung;
    REPEAT ch:=Upcase(Readkey) UNTIL ch IN [#27,'S','L','P'];
    CASE ch OF
       'S': Systemprog;
       'L': Sektorloeschen;
       'P': Programmspeichern(Workfile.CName,False);
    END;
   UNTIL ch=#27;
   Put_Byte(Bef_Startsys);
  END;

PROCEDURE ProgFlash;
BEGIN
 ok:=True;
 InputRec.Meldung[2]:='Flash-Eprom Anwendungen';
 InputRec.Meldung[3]:='LUCHS einschalten oder Reset-Impuls geben';
 InputRec.Meldung[4]:='<RET> oder ESC zum Abbruch';
 Show_Meldung;
 GotoXY(4,16);
 REPEAT Taste:=Readkey UNTIL (Taste=#13) OR (Taste=#27);
 IF Taste = #27
 THEN InputRec.Meldung[3]:='Flash-Zugriff abgebrochen'
 ELSE
  BEGIN
    Suche_Flash;
    IF Flash_typ <> NoFlash THEN Flash_Handling;
  END
END;

BEGIN END.
