unit Flashwin;

interface

uses
  Luchstyp, CommWin, 
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, Gauges;

type
  TFlashform = class(TForm)
    Ueberschrift: TLabel;
    Flashname: TLabel;
    Sektor1: TButton;
    ProgDateiButton: TButton;
    SystemButton: TButton;
    Dateiname: TLabel;
    Sektor2: TButton;
    Sektor3: TButton;
    Sektor4: TButton;
    Sektor5: TButton;
    Sektor6: TButton;
    Sektor7: TButton;
    StartAdrButton: TButton;
    StartAdrLabel: TLabel;
    Quitbutton: TBitBtn;
    FlashGauge: TGauge;
    Loeschlabel: TLabel;
    FlashOpenDialog: TOpenDialog;
    Openbutton: TButton;
    Sektor17: TButton;
    procedure Sektor1Click(Sender: TObject);
    procedure Sektor2Click(Sender: TObject);
    procedure Sektor3Click(Sender: TObject);
    procedure Sektor4Click(Sender: TObject);
    procedure Sektor5Click(Sender: TObject);
    procedure Sektor6Click(Sender: TObject);
    procedure Sektor7Click(Sender: TObject);
    procedure QuitbuttonClick(Sender: TObject);
    procedure ProgDateiButtonClick(Sender: TObject);
    procedure SystemButtonClick(Sender: TObject);
    procedure StartAdrButtonClick(Sender: TObject);
    procedure OpenbuttonClick(Sender: TObject);
    procedure Sektor17Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Flashform: TFlashform;

  PROCEDURE ProgFlash;

implementation

TYPE T_Flash=(NoFlash,AMD29F010,AMD29F040,ST29F040);

VAR  Flash_ok           : Boolean;
     Flash_Typ          : T_Flash;
     Flash_Breite       : Word;
     Flash_Sektorgroesse,
     Flash_Startadresse : LongInt;
     Taste              : Char;
     Flash_Dateiname    : T_Filename;

{$R *.DFM}


FUNCTION Hex_Flashadr(Adresse: Longint): String;
BEGIN
   Hex_FlashAdr:='$'+Copy(HexLong(Adresse),4,5);
END;

FUNCTION Hex_FlashSektorAdr(Nr: Word): String;
BEGIN
   Hex_FlashSektorAdr:='$'+Copy(HexLong(Flash_sektorgroesse*Nr),4,5);
END;

PROCEDURE Zeige_FlashDatei;
VAR f:File;
BEGIN
  Flashform.Dateiname.Caption:='';
  Flashform.StartAdrLabel.Caption:='';
  FlashForm.Startadrbutton.enabled:=False;
  FlashForm.Progdateibutton.enabled:=False;
  IF Flash_Dateiname <> ''
     THEN BEGIN Flashform.Dateiname.Caption:=    'Datei: '+Flash_DateiName;
                Assign(Code.f,Flash_Dateiname);
                Reset(Code.f);
                IF Ioresult = 0
                  THEN BEGIN
                         Blockread(Code.f, Code.Block, 1);
                         Flash_Startadresse := Code.Block[0] * $1000000 +
                                              (Code.Block[1] * $10000) AND $00FF0000+
                                              (Code.Block[2] * $100) AND $0000FF00 +
                                              Code.Block[3];
                         Close(Code.f);
                         Flashform.StartAdrLabel.Caption:='Startadresse: $'+Hexlong(Flash_Startadresse);
                         Flashform.StartAdrButton.enabled:=True;
                         Flashform.ProgDateiButton.enabled:=True;
                       END
           END
END;

PROCEDURE Suche_Flash;
VAR Flashcode: Longint;
    b: Byte;
    abbruch: Boolean;
    Fehler: String;
BEGIN
   Flash_Typ:=NoFlash; Flash_ok:=True;
   Start_Kommunikation(Flash_ok,Fehler);
   IF Flash_ok THEN BEGIN Put_Byte(Bef_MonInsRam);
                    Abbruch:=False;
                    Read_Byte(b,Abbruch);   (* auf erstes $FF warten *)
                    Start_Kommunikation(Flash_ok,Fehler)
              END;
   IF Flash_ok THEN
      BEGIN Put_Byte(Bef_Liesflash);
            Read_Long_HS(FlashCode,Flash_ok);
                 IF FlashCode=$01012020
                    THEN BEGIN Flash_Typ:=AMD29F010;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$08000;
                               FlashForm.FlashName.Caption:='AMD 29F010 16 Bit breit' END
            ELSE IF FlashCode=$0101A4A4
                    THEN BEGIN Flash_Typ:=AMD29F040;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$20000;
                               Flashform.Flashname.Caption:='AMD 29F040 16 Bit breit' END
            ELSE IF FlashCode=$2020E2E2
                    THEN BEGIN Flash_Typ:=ST29F040;
                               Flash_Breite:=16;
                               Flash_Sektorgroesse:=$20000;
                               Flashform.Flashname.Caption:='ST 29F040 16 Bit breit'  END
            ELSE IF FlashCode=$0120
                    THEN BEGIN Flash_Typ:=AMD29F010;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$04000;
                               Flashform.Flashname.Caption:='AMD 29F010 8 Bit breit'  END
            ELSE IF FlashCode=$01A4
                    THEN BEGIN Flash_Typ:=AMD29F040;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$10000;
                               Flashform.Flashname.Caption:='AMD 29F040 8 Bit breit'  END
            ELSE IF FlashCode=$20E2
                    THEN BEGIN Flash_Typ:=ST29F040;
                               Flash_Breite:=8;
                               Flash_Sektorgroesse:=$10000;
                               Flashform.Flashname.Caption:='ST 29F040 8 Bit breit'  END
            ELSE BEGIN Flash_Typ:=NoFlash;
                 END
      END;
   Flash_ok:=Flash_ok AND (Flash_Typ <> NoFlash)
END;

PROCEDURE ProgFlash;
VAR Flash_Fehler: String;
BEGIN
  IF MessageDlg('Flash-Programmroutinen, LUCHS aus- und wieder einschalten',
                mtconfirmation,[mbok,mbcancel], 0)=idok
     THEN BEGIN
           Zeige_FlashDatei;
           Suche_Flash;
           IF Flash_typ <> NoFlash
              THEN BEGIN Flashform.Sektor1.Caption:= 'Sektor 1 ab '+Hex_FlashSektorAdr(1)+' lschen';
                         Flashform.Sektor2.Caption:= 'Sektor 2 ab '+Hex_FlashSektorAdr(2)+' lschen';
                         Flashform.Sektor3.Caption:= 'Sektor 3 ab '+Hex_FlashSektorAdr(3)+' lschen';
                         Flashform.Sektor4.Caption:= 'Sektor 4 ab '+Hex_FlashSektorAdr(4)+' lschen';
                         Flashform.Sektor5.Caption:= 'Sektor 5 ab '+Hex_FlashSektorAdr(5)+' lschen';
                         Flashform.Sektor6.Caption:= 'Sektor 6 ab '+Hex_FlashSektorAdr(6)+' lschen';
                         Flashform.Sektor7.Caption:= 'Sektor 7 ab '+Hex_FlashSektorAdr(7)+' lschen';
                         Flashform.Showmodal;
                   END
              ELSE Luchs_info('Kein Flash-Eprom gefunden');
          END
  ELSE Luchs_info('Flash-Zugriff abgebrochen');
END;

PROCEDURE Sektor_Loeschen(Sektornummer: Word; Sysloesch:Boolean);
VAR Sektoradresse: Longint;
    Antwort: Byte;
    Adressstring: String;
    Abbruch: Boolean;
BEGIN
  Sektoradresse:=Flash_Sektorgroesse*Sektornummer;
  Adressstring:=Hex_FlashSektorAdr(Sektornummer);
  FlashForm.Loeschlabel.Caption:='Lsche Sektor ab $'+Hexlong(Sektoradresse);
  Flashform.Loeschlabel.Color:=Clred;
  Flashform.Loeschlabel.Show;
  FlashForm.Update;
  Put_Byte(Bef_Sektorloeschen); Put_Long(Sektoradresse);
  Read_Byte_HS(Antwort,Abbruch);
  FlashForm.Loeschlabel.Hide;
  IF (Antwort <> $A5) OR Abbruch
     THEN BEGIN Luchs_Info('Sektor '+AdressString+' konnte nicht geloescht werden');
                Flash_ok:=False
          END
     ELSE IF NOT Sysloesch
             THEN Luchs_Info('Sektor '+AdressString+' ist geloescht')
END;

PROCEDURE Programmspeichern(Dateiname: T_Filename; SysProg: Boolean);
 VAR Code : T_Code;
     i,size : Word;

     (* TestClear prueft, ob die Datei zu gross ist   *)
     (* bzw, ob das Flasheprom geloescht ist          *)

     PROCEDURE TestClear;
     VAR Ergebnis: Byte;
         Abbruch: Boolean;
         Max: Longint;
     BEGIN
        Max:=8*Flash_Sektorgroesse;
        IF Code.Startadresse>=Max
           THEN BEGIN Flash_ok:=False;
                      Luchs_Info('Die Startadresse $'+
                                 HexLong(Code.Startadresse)+
                                 'liegt nicht im Flash-Eprom');
                END
           ELSE IF Code.Startadresse+Code.Laenge >= Max
           THEN BEGIN Flash_ok:=False;
                      Luchs_Info('Die Datei '+Workfile.CName
                                +' ist zu gross fuer das Flash-Eprom');
                END;
        IF Flash_ok
           THEN BEGIN Put_Byte(Bef_TestClear);
                      Put_Long(Code.Startadresse);
                      Put_Long(Code.Laenge);
                      Read_Byte_HS(Ergebnis,Abbruch);
                      Flash_ok:=NOT Abbruch AND (Ergebnis=$FF);
                      IF NOT Flash_ok THEN
                         Luchs_Info('Das Flash-Eprom ist nicht geloescht');
                END
     END;

     PROCEDURE ProgDatei;
     VAR Rest,Adresse: LongInt;
         Ergebnis,i: Byte;
         Abbruch: Boolean;
     BEGIN
       FlashForm.Loeschlabel.Caption:='Programmiere ab $'+Hexlong(Code.Startadresse);
       Flashform.Loeschlabel.Color:=claqua;
       Flashform.Loeschlabel.Show;
       FlashForm.FlashGauge.Progress:=0;
       FlashForm.FlashGauge.Visible:=True;
       FlashForm.Update;
       Adresse:=Code.Startadresse; Rest:=Code.Laenge;
       WHILE Flash_ok AND (Rest>0) DO
         BEGIN Blockread(Code.f, Code.Block, 1);  (* 128 Byte lesen *)
               Flash_ok:=Ioresult=0;
               i:=0;
               Put_Byte(Bef_Prog);
               Put_Long(Adresse);
               IF Rest<128 THEN Put_Byte(Rest) ELSE Put_Byte(128);
               WHILE (Rest>0) AND (i<128) DO     (* Block senden *)
                 BEGIN Put_Byte(Code.Block[i]);
                       i:=i+1; Rest:=Rest-1;
                 END;
               Read_Byte_HS(Ergebnis,Abbruch);
               Flash_ok:=(Ergebnis=$A5) AND NOT Abbruch;
               Adresse:=Adresse+128;
               Flashform.FlashGauge.progress:=((Code.Laenge-Rest) * 100 ) DIV Code.Laenge;
               FlashForm.Update
         END;
         Flashform.Loeschlabel.Hide;
         FlashForm.FlashGauge.Visible:=False;
         IF Abbruch OR NOT Flash_ok
            THEN Luchs_Info('Programmier-Fehler')
            ELSE Luchs_Info('Datei '+Dateiname+' ist programmiert');
     END;

     PROCEDURE ProgStart;
     VAR Taste: Char;
         Ergebnis: Byte;
         Abbruch: Boolean;
     BEGIN
     {
       InputRec.Meldung[1]:='Datei '+WorkFile.CName;
       InputRec.Meldung[2]:='Startadresse $'+HexLong(SysInfo.Epromstart)+' fuer Autostart aktivieren?';
       InputRec.Meldung[3]:='Das Anwenderprogramm wird anschlieend selbstaendig laufen';
       InputRec.Meldung[5]:='S(tartadresse programmieren         <ESC>';
       Show_Meldung;
       REPEAT Taste:=Upcase(Readkey) UNTIL Taste IN [#27,'S'];
       IF Taste ='S' THEN
         BEGIN Put_Byte(Bef_TestClear);
               Put_Long(Adr_Standalone);
               Put_Long(4);
               Read_Byte_HS(Ergebnis,Abbruch);
               ok:=NOT Abbruch AND (Ergebnis=$FF);
               IF ok THEN
                BEGIN
                 Put_Byte(Bef_Prog);
                 Put_Long($18);        (* Adresse des Standalonezeigers *)
                 Put_Byte(4);          (* ein Langwort programmieren    *)
                 Put_Byte((Code.StartAdresse shr 24) AND $FF);
                 Put_Byte((Code.StartAdresse shr 16) AND $FF);
                 Put_Byte((Code.StartAdresse shr  8) AND $FF);
                 Put_Byte(Code.StartAdresse AND $FF);
                 Read_Byte_HS(Ergebnis,Abbruch);
                 ok:=(Ergebnis=$A5) AND NOT Abbruch;
                 IF NOT ok OR Abbruch
                  THEN InputRec.Meldung[3]:='fehlerhafte Programmierung der Startadresse'
                  ELSE BEGIN InputRec.Meldung[1]:='Standalone-Betrieb ist ab dem naechsten Reset aktiviert';
                             InputRec.Meldung[3]:='Eine erneute Kommunikation mit dem Hostrechner';
                             InputRec.Meldung[4]:='ist danach nur mit dem Manual-Reset-Verfahren moeglich.';
                       END
                END
                ELSE BEGIN InputRec.Meldung[1]:='Eine Startadresse ist bereits eingetragen';
                           InputRec.Meldung[3]:='Programmieren Sie zunaechst SYSLUCHS neu';
                     END;
              Flash_Return_meldung
         END;
         }
     END;

 BEGIN        (* Programmspeichern *)
    IF Dateiname <> ''
       THEN BEGIN Assign(Code.f,Dateiname);
                  Reset(Code.f);
                  Flash_ok:=Ioresult IN [0,105];
            END
       ELSE Flash_ok:=False;
    IF NOT Flash_ok
     THEN Luchs_Info('Datei '+Dateiname+' nicht vorhanden')
     ELSE
       BEGIN
        size := Filesize(Code.F)- 1;
        Blockread(Code.f, Code.Block, 1);
        Code.Startadresse := Code.Block[0] * $1000000 +
                             (Code.Block[1] * $10000) AND $00FF0000+
                             (Code.Block[2] * $100) AND $0000FF00 +
                             Code.Block[3];
        Code.Laenge :=       Code.Block[4] * $1000000 +
                             (Code.Block[5] * $10000) AND $00FF0000 +
                             (Code.Block[6] * $100) AND $0000FF00 +
                             Code.Block[7];
        IF SysProg AND (Code.Startadresse <> 0)
           THEN Luchs_Info('Startadresse ist nicht $000000')
           ELSE
            BEGIN
             IF SysProg THEN Sektor_Loeschen(0,True);
             IF Flash_ok THEN
              BEGIN
(*
               InputRec.Meldung[3]:='Programmiere die Datei '+Dateiname;
               InputRec.Meldung[4]:='Startadresse='+Hex_FlashAdr(Code.Startadresse);
               InputRec.Meldung[5]:='Codelaenge  ='+Hex_FlashAdr(Code.Laenge);
               Show_Meldung;
*)
               (*
               TestClear;
               *)
               IF Flash_ok THEN ProgDatei;
               IF Flash_ok THEN ProgStart;
              END;
            END;
        Close(Code.f);
       END
  END;

procedure TFlashform.Sektor1Click(Sender: TObject);
begin
  Sektor_Loeschen(1,False);
end;

procedure TFlashform.Sektor2Click(Sender: TObject);
begin
  Sektor_Loeschen(2,False);
end;

procedure TFlashform.Sektor3Click(Sender: TObject);
begin
  Sektor_Loeschen(3,False);
end;

procedure TFlashform.Sektor4Click(Sender: TObject);
begin
  Sektor_Loeschen(4,False);
end;

procedure TFlashform.Sektor5Click(Sender: TObject);
begin
  Sektor_Loeschen(5,False);
end;

procedure TFlashform.Sektor6Click(Sender: TObject);
begin
  Sektor_Loeschen(6,False);
end;

procedure TFlashform.Sektor7Click(Sender: TObject);
begin
  Sektor_Loeschen(7,False);
end;

procedure TFlashform.QuitbuttonClick(Sender: TObject);
begin
    Put_Byte(Bef_Startsys);
    Flashform.Close
end;

procedure TFlashform.ProgDateiButtonClick(Sender: TObject);
begin
   IF Flash_Dateiname<>''
      THEN IF MessageDlg('Datei ins Flash-Eprom brennen, bitte besttigen',
                mtconfirmation,[mbok,mbcancel], 0)=idok
              THEN Programmspeichern(Flash_Dateiname,false)
end;

procedure TFlashform.SystemButtonClick(Sender: TObject);
begin
  IF MessageDlg('System neu ins Flash-Eprom brennen, bitte besttigen',
                mtconfirmation,[mbok,mbcancel], 0)=idok
  THEN Programmspeichern(Sysinfo.Sysname,True)
END;

procedure TFlashform.StartAdrButtonClick(Sender: TObject);
VAR Ergebnis: Byte;
    Abbruch: Boolean;
begin
  IF MessageDlg('Startadresse $'+Hexlong(Code.Startadresse)+' ins Flash-Eprom brennen, bitte besttigen',
                mtconfirmation,[mbok,mbcancel], 0)=idok
    THEN BEGIN Put_Byte(Bef_TestClear);
               Put_Long(Adr_Standalone);
               Put_Long(4);
               Read_Byte_HS(Ergebnis,Abbruch);
               Flash_ok:=NOT Abbruch AND (Ergebnis=$FF);
               IF Flash_ok THEN
                BEGIN
                 Put_Byte(Bef_Prog);
                 Put_Long($18);        (* Adresse des Standalonezeigers *)
                 Put_Byte(4);          (* ein Langwort programmieren    *)
                 Put_Byte((Code.StartAdresse shr 24) AND $FF);
                 Put_Byte((Code.StartAdresse shr 16) AND $FF);
                 Put_Byte((Code.StartAdresse shr  8) AND $FF);
                 Put_Byte(Code.StartAdresse AND $FF);
                 Read_Byte_HS(Ergebnis,Abbruch);
                 Flash_ok:=(Ergebnis=$A5) AND NOT Abbruch;
                 IF NOT Flash_ok OR Abbruch
                  THEN Luchs_Info('fehlerhafte Programmierung der Startadresse')
                  ELSE BEGIN (*
                             InputRec.Meldung[1]:='Standalone-Betrieb ist ab dem naechsten Reset aktiviert';
                             InputRec.Meldung[3]:='Eine erneute Kommunikation mit dem Hostrechner';
                             InputRec.Meldung[4]:='ist danach nur mit dem Manual-Reset-Verfahren moeglich.';
                             *)
                       END
                END
                ELSE BEGIN Luchs_Info('Eine Startadresse ist bereits eingetragen');
                           Luchs_Info('Programmieren Sie zunaechst SYSLUCHS neu');
                     END;
    END
end;

procedure TFlashform.OpenbuttonClick(Sender: TObject);
begin
   Flashopendialog.Filename:=Workfile.CName;
   IF Flashopendialog.execute
      THEN BEGIN Flash_Dateiname:=Flashopendialog.Filename;
                 Zeige_FlashDatei;
           END
end;

procedure TFlashform.Sektor17Click(Sender: TObject);
var Nr: Word;
begin
  FOR nr:=1 TO 7 DO Sektor_Loeschen(Nr,True);
  Luchs_Info('Die Sektoren 1 ..7 sind geloescht')
end;

end.
