UNIT MoniDOS;

(* HJ: Start_komm,show_meldung,read_word_hs,read_long_hs
   jetzt auch in CommDos, kann hier entfallen *)

(* 14.3.96: HJ .BRAL und .BSRL als Pseudocodes eingefhrt     *)
(*  1.4.96: HJ Monitorinhalte als WORDS lesen und schreiben
               Adressen werden immer auf gerade Werte gesetzt *)

INTERFACE

USES  LuchsTyp;

PROCEDURE Monitor;
PROCEDURE StartMonitor;
PROCEDURE Execute;

IMPLEMENTATION
USES Crt, DOS, CodeSave, CommDOS,Gaugedos;

TYPE str20   = String[20];
     str80   = String[80];
     Str8    = String[8];
     Str5    = String[5];
     Str4    = String[4];
     Str25   = String[25];
     T_AdrRes = (Adr_ok,Adr_Per,Adr_Err);
     T_Reg   = ( o_R, b_R, w_R, l_R, ccR, k_R);
     T_SH    = RECORD PC,PR,SR,VBR,GBR,MACH,MACL: Longint;
                      R: Array[0..15] OF Longint;
               END;
     T_Input = RECORD Zeiger : Byte;
                      Taste  : Char;
                      EingabeZeile : Str80
               END;

     T_DisZ  = RECORD Adr       : Str8;
                      Befcode   : Str5;
                      LongOffset: Str8;
                      Befehl    : Str8;
                      Operand1, Operand2,Info: Str20;
                      Ende      : Str5;
                      Offset    : Char;
                      NextAdr   : Longint;
                      STCTyp,Slotaktiv: Boolean;
               END;

     T_M     = RECORD SH: T_SH;
                      Breakaktiv,Hostkommando,Traceaktiv,
                      EndKomm,Abbruch,ExecEnd: Boolean;
                      Breakadresse,Adresse,NextTrAdr: Longint;
               END;

{ hier neu, damit die anderen Units keine Ausgaben machen muessen }

PROCEDURE MonFehler(s: Str80);
BEGIN writeln(#7); writeln(s) END;

   FUNCTION HexAdr(Long: LongInt): Str20;
   VAR HB,MB,LW: Word;
       Hilf: Str8;
   BEGIN
     Hexadr:=Hexword(Long shr 16)+Hexword(Long AND $FFFF)
   END;

   FUNCTION HexByteErw(B:Byte): Str20;
   BEGIN
     IF (b AND $80) = $0
        THEN HexByteErw:=HexByte(B)
        ELSE HexByteErw:=Hexadr(B OR $FFFFFF00);
   END;

PROCEDURE holbyte(VAR b: Byte; VAR Abbruch: Boolean; VAR Adr: Longint);
BEGIN
  Put_Byte(Bef_Readbyte); put_Byte(1);
  Read_Byte_HS(b,Abbruch); inc(Adr)
END;

PROCEDURE holWord(VAR W: Word; VAR Abbruch: Boolean; VAR Adr: Longint);
VAR bh, bl : Byte;
BEGIN
  Holbyte(bh, Abbruch,Adr); HolByte(bl, Abbruch,Adr);
  w := $100*bh + bl
END;

PROCEDURE Set_Adresse(Adr: Longint);
BEGIN
  put_Byte(Bef_Setadresse);
  put_long(Adr)
END;

PROCEDURE MEM_Vorschau(    newadr,oldadr: LongInt;
                       VAR Inhalt: Longint;
                           Gr: Char;
                       VAR Result: T_AdrRes);
VAR ist_Peripherie: Boolean;
    Byt: Byte;
    Wrd: Word;
    Abbruch: Boolean;
BEGIN
  newadr:=Newadr AND $0FFFFFFF;    (* high nibble ignorieren *)
  ist_Peripherie:=((newadr>=$05000000) AND (newadr<=$06FFFFFF))
                  OR ((newadr>=$0D000000) AND (newadr <=$0EFFFFFF));
  IF Ist_Peripherie
     THEN Result:=Adr_Per
     ELSE BEGIN Result:=Adr_Ok;
                Set_Adresse(NewAdr);
                CASE Gr OF
                 'B': BEGIN HolByte(Byt,Abbruch,NewAdr); Inhalt:=Byt END;
                 'W': IF odd(NewAdr) THEN Result:=Adr_Err
                                     ELSE BEGIN HolWord(Wrd,Abbruch,NewAdr);
                                                Inhalt:=Wrd
                                          END;
                 'L': IF (Newadr AND 3) =0 THEN BEGIN Put_Byte(Bef_Readbyte);
                                                      put_Byte(4);
                                                      Read_Long_HS(Inhalt,Abbruch)
                                                END
                                           ELSE Result:=Adr_Err
                END;
                Set_Adresse(Oldadr);
          END
END;

PROCEDURE Lies_Quelladr(VAR DisZ: T_DisZ; Memadr,Adr: Longint;Gr:Char);
VAR Inhalt : Longint;
    Inh_Str: Str20;
    Result : T_AdrRes;
BEGIN
  DisZ.Info:=HexAdr(Memadr); Inh_Str:=''; Result:=Adr_Err;
  MEM_Vorschau(Memadr,Adr,Inhalt,Gr,Result);
  CASE Result OF
    Adr_Ok:  BEGIN IF   Gr='B'    THEN Inh_str:=HexByte(Inhalt)
                   ELSE IF Gr='W' THEN Inh_str:=HexWord(Inhalt)
                   ELSE Inh_str:=HexAdr(Inhalt);
             END;
    Adr_Per: Inh_Str:='Peripherie_Adr'; (* Peripherie: nichts anzeigen *)
    Adr_Err: Inh_Str:='Quell_Err';
  END;
  DisZ.Info:=DisZ.Info+': '+Inh_Str;
END;

PROCEDURE Make_Zieladr(VAR DisZ: T_DisZ; Adr: Longint; Gr: Char);
BEGIN
  IF ((Gr='L') AND ((Adr AND 3) <> 0)) OR ((Gr='W') AND odd(Adr))
     THEN DisZ.Info:='Ziel_Err: '+HexAdr(Adr)
     ELSE DisZ.Info:='Ziel_Adr: '+Hexadr(Adr)
END;

PROCEDURE DisassZeile(VAR DisZ : T_DisZ; VAR M: T_M);
VAR Hexcode: Word;

{ ================= Disassembler ====================================== }

  FUNCTION MakeRn(Rn: Byte): Str5;
  VAR Hilf: Str5;
  BEGIN
    IF Rn >= 10
       THEN BEGIN Hilf:='R1'; Rn:=Rn-10 END
       ELSE Hilf:='R';
    MakeRn:=Hilf+Chr(Rn+$30);
  END;

  FUNCTION MakeMovGr(Gr: Byte): Str5;
  BEGIN
    CASE (Gr AND 3) OF
      0: MakeMovGr:='MOV.B';
      1: MakeMovGr:='MOV.W';
      2: MakeMovGr:='MOV.L';
    END;
  END;

  FUNCTION MakeMach(Fx: Byte): Str5;
  BEGIN
    CASE Fx OF
       0: MakeMach:='MACH';
       1: MakeMach:='MACL';
       2: MakeMach:='PR';
    END;
  END;

  FUNCTION MakeSr(Fx: Byte): Str5;
  BEGIN
    CASE Fx OF
       0: MakeSr:='SR';
       1: MakeSr:='GBR';
       2: MakeSr:='VBR';
    END;
  END;

  PROCEDURE DisBra8(VAR DisZ: T_DisZ; Bef: Str5; Adr: Longint;
                        Off: Byte; VAR Statusreg: Longint);
  VAR T_Bit: Boolean;
  BEGIN
    T_Bit:=((Statusreg AND 1)=1);
    DisZ.Befehl:=Bef;
    IF off <= $7F THEN Adr:=Adr+2*off+2
                  ELSE Adr:=Adr-2*($100-off)+2;
    IF (Bef[2]='F') AND (NOT T_Bit)
       OR ((Bef[2]='T') AND T_Bit) THEN DisZ.NextAdr:=Adr;
    DisZ.Operand1:=HexAdr(Adr)
  END;


  PROCEDURE Page0(Rn,Fx,LSB:Byte; VAR DisZ: T_DisZ);

    PROCEDURE Page0STC;
    BEGIN
      (* IF (CPU7600 AND (Fx=0)) OR (Fx IN [1,2]) *) (*???? FX=0 fuer 7000 verboten *)
      IF Fx <= 2 THEN BEGIN DisZ.Befehl:='STC';
                            DisZ.STCTyp:=True;
                            DisZ.Operand1:=MakeSr(Fx);
                            DisZ.Operand2:=MakeRn(Rn);
                      END;
    END;

    PROCEDURE Page0Br;
    BEGIN
     (*$IFDef CPU7600 *)
        IF Fx=0 THEN
           BEGIN DisZ.Befehl:='BSRF'; DisZ.Operand1:='@'+MakeRn(Rn) END
        ELSE IF Fx=$2 THEN
           BEGIN DisZ.Befehl:='BRAF'; DisZ.Operand1:='@'+MakeRn(Rn) END;
     (*$ENDIF *)
    END;

    PROCEDURE Page0_4;
    BEGIN
      CASE LSB OF
        $4..$6: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                      DisZ.Operand1:=MakeRn(Fx);
                      DisZ.Operand2:='@(R0,'+MakeRn(Rn)+')';
                      Make_Zieladr(DisZ,M.SH.R[0]+M.SH.R[Rn],DisZ.Befehl[5]);
                END;
        $7    : (*$IFDef CPU7600 *)
                BEGIN DisZ.Befehl:='MUL';
                      DisZ.Operand1:=MakeRn(Fx);
                      DisZ.Operand2:=MakeRn(Rn)
                END
                (*$ENDIF *);
      END;
    END;

    PROCEDURE PAGE0_8;
    BEGIN
      IF Rn=0 THEN
         CASE Fx OF
           0: DisZ.Befehl:='CLRT';
           1: DisZ.Befehl:='SETT';
           2: DisZ.Befehl:='CLRMAC';
        END;
    END;

    PROCEDURE PAGE0_9;
    BEGIN
           IF (Rn=0) AND (Fx=0) THEN DisZ.Befehl:='NOP'
      ELSE IF (Rn=0) AND (Fx=1) THEN DisZ.Befehl:='DIV0U'
      ELSE IF Fx=2 THEN BEGIN DisZ.Befehl:='MOVT';
                              DisZ.Operand1:=MakeRn(Rn)
                        END
    END;

    PROCEDURE PAGE0_A;
    BEGIN
      IF Fx <= 2 THEN
         BEGIN DisZ.Befehl:='STS'; DisZ.STCTyp:=True;
               CASE Fx OF
                 0: DisZ.Operand1:='MACH';
                 1: DisZ.Operand1:='MACL';
                 2: DisZ.Operand1:='PR';
               END;
               DisZ.Operand2:=MakeRn(Rn);
         END
    END;

    PROCEDURE PAGE0_B;
    VAR dummy: Boolean;
    BEGIN
      IF Rn=0 THEN
         CASE Fx OF
           0: BEGIN DisZ.Befehl:='RTS';
                    DisZ.NextAdr:=M.SH.PR;
                    DisZ.Slotaktiv:=True
              END;
           1: DisZ.Befehl:='SLEEP';
           2: BEGIN DisZ.Befehl:='RTE';
                    DisZ.Slotaktiv:=True;
                    Lies_Quelladr(DisZ,M.SH.R[15],M.Adresse,'L');
                    Set_Adresse(M.SH.R[15]);
                    put_Byte(Bef_ReadByte); put_Byte(4);
                    Read_Long_HS(DisZ.Nextadr,M.Abbruch);
                    Set_Adresse(M.Adresse);
              END
         END;
    END;

    PROCEDURE Page0_C;
    BEGIN
      CASE LSB OF
        $C..$E: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                      Disz.Operand1:='@(R0,'+MakeRn(Fx)+')';
                      DisZ.Operand2:=MakeRn(Rn);
                      Lies_Quelladr(DisZ,M.SH.R[0]+M.SH.R[Fx],M.Adresse,DisZ.Befehl[5]);
                END;
        $F    : (*$IFDef CPU7600 *)
                BEGIN DisZ.Befehl:='MAC.L';
                      DisZ.Operand1:='@'+MakeRn(Fx)+'+';
                      DisZ.Operand2:='@'+MakeRn(Rn)+'+'
                END
                (*$ENDIF *);
      END;
    END;

    PROCEDURE Page0Bkpt;
    BEGIN
      Disz.Befehl:='.bkpt';
      Str(Rn*16+Fx,Disz.Operand1);
      Disz.Operand1:='#'+DisZ.Operand1
    END;

    PROCEDURE Page0Trace;
    BEGIN
      IF Fx=0 THEN Disz.Befehl:='.tron';
      IF Fx=1 THEN Disz.Befehl:='.troff';
    END;

  BEGIN
    CASE LSB OF
      $0    : Page0BKPT;                (* Sonderbefehl COCK *)
      $1    : IF Rn=0 THEN Page0Trace;  (* Sonderbefehle     *)
      $2    : Page0STC;
      $3    : Page0Br;
      $4..$7: Page0_4;
      $8    : Page0_8;
      $9    : Page0_9;
      $A    : Page0_A;
      $B    : Page0_B;
      $C..$F: Page0_C;
    END;
  END;

  PROCEDURE Page1(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV.L';
    DisZ.Operand1:=MakeRn(Rm);
    DisZ.Operand2:='@('+HexByte(LSB*4)+','+MakeRn(Rn)+')';
    Make_Zieladr(DisZ,LSB*4+M.SH.R[Rn],'L');
  END;

  PROCEDURE Page2(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  VAR Kor: Word;
  BEGIN
    CASE LSB OF
      $0..$2: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:='@'+MakeRn(Rn);
                    Make_Zieladr(DisZ,M.SH.R[Rn],DisZ.Befehl[5]);
              END;
      $3    : ;
      $4..$6: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:='@-'+MakeRn(Rn);
                    IF DisZ.Befehl[5]='B' THEN Kor:=1
                    ELSE IF DisZ.Befehl[5]='W' THEN Kor:=2
                    ELSE Kor:=4;    (* Zieladresse nach unten korrig. *)
                    Make_Zieladr(DisZ,M.SH.R[Rn]-Kor,DisZ.Befehl[5]);
              END;
      $7..$F: BEGIN CASE LSB OF
                       $7: DisZ.Befehl:='DIV0S';
                       $8: DisZ.Befehl:='TST';
                       $9: DisZ.Befehl:='AND';
                       $A: DisZ.Befehl:='XOR';
                       $B: DisZ.Befehl:='OR';
                       $C: DisZ.Befehl:='CMP/STR';
                       $D: DisZ.Befehl:='XTRCT';
                       $E: DisZ.Befehl:='MULU.W';
                       $F: DisZ.Befehl:='MULS.W';
                    END;
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:=MakeRn(Rn);
              END;
    END;
  END;

  PROCEDURE Page3(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    CASE LSB OF
      $0: DisZ.Befehl:='CMP/EQ';
      $2: DisZ.Befehl:='CMP/HS';
      $3: DisZ.Befehl:='CMP/GE';
      $4: DisZ.Befehl:='DIV1';
      $5: (*$IFDef CPU7600 *) DisZ.Befehl:='DMULU.L' (*$ENDIF *);
      $6: DisZ.Befehl:='CMP/HI';
      $7: DisZ.Befehl:='CMP/GT';
      $8: DisZ.Befehl:='SUB';
      $A: DisZ.Befehl:='SUBC';
      $B: DisZ.Befehl:='SUBV';
      $C: DisZ.Befehl:='ADD';
      $D: (*$IFDef CPU7600 *) DisZ.Befehl:='DMULS.L' (*$ENDIF *);
      $E: DisZ.Befehl:='ADDC';
      $F: DisZ.Befehl:='ADDV';
    END;
    IF DisZ.Befehl <> '.word'
       THEN BEGIN DisZ.Operand1:=MakeRn(Rm); DisZ.Operand2:=MakeRn(Rn) END;
  END;

  PROCEDURE Page4(Rn,Fx,LSB:Byte; VAR DisZ: T_DisZ);

    PROCEDURE Page4_0;
    BEGIN
      CASE Fx OF
        0: DisZ.Befehl:='SHLL';
        1: (*$IFDef CPU7600 *) DisZ.Befehl:='DT' (*$ENDIF *);
        2: DisZ.Befehl:='SHAL';
      END;
      IF DisZ.Befehl <> '.word' THEN DisZ.Operand1:=MakeRn(Rn)
    END;

    PROCEDURE Page4_1;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='SHLR';
                 1: DisZ.Befehl:='CMP/PZ';
                 2: DisZ.Befehl:='SHAR';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_2;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='STS.L';
               DisZ.Operand1:=MakeMACH(Fx);
               DisZ.Operand2:='@-'+MakeRn(Rn);
               Make_Zieladr(DisZ,M.SH.R[Rn]-4,'L');
              END
    END;

    PROCEDURE Page4_3;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='STC.L';
               DisZ.Operand1:=MakeSR(Fx);
               DisZ.Operand2:='@-'+MakeRn(Rn);
               Make_Zieladr(DisZ,M.SH.R[Rn]-4,'L');
              END
    END;

    PROCEDURE Page4_4;
    BEGIN
      IF Fx IN [0,2]
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='ROTL';
                 2: DisZ.Befehl:='ROTCL';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_5;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='ROTR';
                 1: DisZ.Befehl:='CMP/PL';
                 2: DisZ.Befehl:='ROTCR';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_6;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='LDS.L';
               DisZ.Operand2:=MakeMACH(Fx);
               DisZ.Operand1:='@'+MakeRn(Rn)+'+'
              END
    END;

    PROCEDURE Page4_7;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Slotaktiv:=True;
               DisZ.Befehl:='LDC.L';
               DisZ.STCTyp:=True;
               Inc(DisZ.Nextadr,2);
               DisZ.Operand2:=MakeSr(Fx);
               DisZ.Operand1:='@'+MakeRn(Rn)+'+'
              END
    END;

    PROCEDURE Page4_8(Bef: Str5);
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Befehl:=Bef;
               CASE Fx OF
                 0: DisZ.Befehl:=Bef+'2';
                 1: DisZ.Befehl:=Bef+'8';
                 2: DisZ.Befehl:=Bef+'16';
               END;
               DisZ.Operand1:=MakeRn(Rn);
              END
    END;

    PROCEDURE Page4_A;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='LDS';
               DisZ.Operand2:=MakeMACH(Fx);
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_B;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='JSR';
                 1: DisZ.Befehl:='TAS.B';
                 2: DisZ.Befehl:='JMP';
               END;
               DisZ.Operand1:='@'+MakeRn(Rn);
               IF Fx <> 1 THEN BEGIN DisZ.Slotaktiv:=True;
                                     DisZ.Nextadr:=M.SH.R[Rn]
                               END;
              END
    END;

    PROCEDURE Page4_E;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Slotaktiv:=True;
               DisZ.Befehl:='LDC';
               DisZ.STCTyp:=True;
               Inc(DisZ.Nextadr,2);
               DisZ.Operand1:=MakeRn(Rn);
               DisZ.Operand2:=MakeSr(Fx);
              END
    END;

    PROCEDURE Page4_F;
    BEGIN
      DisZ.Befehl:='MAC.W';
      DisZ.Operand1:='@'+MakeRn(Fx)+'+';
      DisZ.Operand2:='@'+MakeRn(Rn)+'+'
    END;

  BEGIN
    CASE LSB OF
      $0: Page4_0;
      $1: Page4_1;
      $2: Page4_2;
      $3: Page4_3;
      $4: Page4_4;
      $5: Page4_5;
      $6: Page4_6;
      $7: Page4_7;
      $8: Page4_8('SHLL');
      $9: Page4_8('SHLR');
      $A: Page4_A;
      $B: Page4_B;
      $C,$D: ;     (* verboten *)
      $E: Page4_E;
      $F: Page4_F;
    END
  END;

  PROCEDURE Page5(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV.L';
    DisZ.Operand1:='@('+HexByte(4*LSB)+','+MakeRn(Rm)+')';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,4*LSB+M.SH.R[Rm],M.Adresse,'L');
  END;

  PROCEDURE Page6(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    CASE LSB OF
      0..2,4..6: DisZ.Befehl:=MakeMovGr(LSB);
      3        : DisZ.Befehl:='MOV';
      7        : DisZ.Befehl:='NOT';
      8        : DisZ.Befehl:='SWAP.B';
      9        : DisZ.Befehl:='SWAP.W';
      $A       : DisZ.Befehl:='NEGC';
      $B       : DisZ.Befehl:='NEG';
      $C       : DisZ.Befehl:='EXTU.B';
      $D       : DisZ.Befehl:='EXTU.W';
      $E       : DisZ.Befehl:='EXTS.B';
      $F       : DisZ.Befehl:='EXTS.W';
    END;
    CASE LSB OF
      $0,$1,$2 : BEGIN DisZ.Operand1:='@'+MakeRn(Rm);
                       Lies_Quelladr(DisZ,M.SH.R[Rm],M.Adresse,DisZ.Befehl[5]);
                 END;
      $4,$5,$6 : BEGIN DisZ.Operand1:='@'+MakeRn(Rm)+'+';
                       Lies_Quelladr(DisZ,M.SH.R[Rm],M.Adresse,DisZ.Befehl[5]);
                 END;
      $3,$7..$F: DisZ.Operand1:=MakeRn(Rm);
    END;
    DisZ.Operand2:=MakeRn(Rn);

  END;

  PROCEDURE Page7(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='ADD';
    DisZ.Operand1:='#H'''+HexByteErw(16*Rm+LSB);
    DisZ.Operand2:=MakeRn(Rn);
  END;

  PROCEDURE Page8(MD,Rn,LSB:Byte; VAR DisZ: T_DisZ; Adresse: Longint);
  VAR Imm: Byte;
  BEGIN
    Imm:=16*Rn+LSB;
    CASE MD OF
     $0: BEGIN DisZ.Befehl:='MOV.B';
               DisZ.Operand1:='R0';
               DisZ.Operand2:='@('+HexByte(LSB)+','+MakeRn(Rn)+')';
               Make_Zieladr(DisZ,LSB+M.SH.R[Rn],'B');
         END;
     $1: BEGIN DisZ.Befehl:='MOV.W';
               DisZ.Operand1:='R0';
               DisZ.Operand2:='@('+HexByte(2*LSB)+','+MakeRn(Rn)+')';
               Make_Zieladr(DisZ,2*LSB+M.SH.R[Rn],'W');
         END;
     $2,$3,$6,$7,$A,$C,$E: ; (* verboten *)
     $4: BEGIN DisZ.Befehl:='MOV.B';
               DisZ.Operand2:='R0';
               DisZ.Operand1:='@('+HexByte(LSB)+','+MakeRn(Rn)+')';
               Lies_Quelladr(Disz,LSB+M.SH.R[Rn],Adresse,'B')
         END;
     $5: BEGIN DisZ.Befehl:='MOV.W';
               DisZ.Operand2:='R0';
               DisZ.Operand1:='@('+HexByte(2*LSB)+','+MakeRn(Rn)+')';
               Lies_Quelladr(Disz,2*LSB+M.SH.R[Rn],Adresse,'W')
         END;
     $8: BEGIN DisZ.Befehl:='CMP/EQ';
               DisZ.Operand1:='#H'''+HexByteErw(Imm);
               DisZ.Operand2:='R0';
         END;
     $9: DisBra8(DisZ,'BT',Adresse,Imm,M.SH.SR);
     $B: DisBra8(DisZ,'BF',Adresse,Imm,M.SH.SR);
     $D: (*$IFDef CPU7600 *) DisBra8(DisZ,'BT/S',Adresse,Imm,M.SH.SR) (*$ENDIF*);
     $F: (*$IFDef CPU7600 *) DisBra8(DisZ,'BF/S',Adresse,Imm,M.SH.SR) (*$ENDIF *);
    END;
  END;

  PROCEDURE Page9(Rn,imm:Byte; VAR DisZ: T_DisZ; Adresse: Longint);
  VAR ZielAdr,Inhalt: Longint;
  BEGIN
    DisZ.Befehl:='MOV.W';
    Zieladr:=Adresse+2*imm+2;
    DisZ.Operand1:='@('+HexWord(Imm*2)+',PC)';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,Zieladr,Adresse,'W')
  END;

  PROCEDURE PageBra(Bef: Str5; Rn,Rm,LSB:Byte; VAR DisZ:T_DisZ; Adr:Longint);
  VAR Displ: Word;
      Ziel: LongInt;
  BEGIN
    DisZ.Befehl:=Bef;
    Displ:=Rn*256+Rm*16+LSB;
    IF Displ <= $7FF
       THEN Ziel:=Adr+2*Displ+2 ELSE Ziel:=Adr-2*($1000-Displ)+2;
    DisZ.Operand1:=HexAdr(Ziel);
    DisZ.NextAdr:=Ziel; DisZ.Slotaktiv:=True;
  END;

  PROCEDURE PageC(MD,imm:Byte; VAR DisZ: T_DisZ; Adresse:Longint);

    PROCEDURE PageC_8(Bef: Str5);
    BEGIN
      DisZ.Befehl:=Bef;
      DisZ.Operand1:='#H'''+HexByte(imm);
      DisZ.Operand2:='R0';
    END;

    PROCEDURE PageC_C(Bef: Str5);
    BEGIN
      DisZ.Befehl:=Bef;
      DisZ.Operand1:='#H'''+HexByte(imm);
      DisZ.Operand2:='@(R0,GBR)';
    END;

    PROCEDURE DisPseudoBraL(VAR DisZ: T_DisZ; imm: Byte);
    VAR DistanzH,DistanzL: Word;
        Ziel,Distanz     : LongInt;
    BEGIN
      CASE imm OF
        $29: DisZ.Befehl:='.BRAL';
        $2A: DisZ.Befehl:='.BSRL';
        $2B: BEGIN DisZ.Befehl:='.MOVAL'; DisZ.Operand2:='R0' END;
      END;
      Ziel:=M.Adresse;
      Holword(DistanzH,M.Abbruch,M.Adresse);
      Holword(DistanzL,M.Abbruch,M.Adresse);
      DisZ.LongOffset:=HexWord(DistanzH)+HexWord(DistanzL);
      Distanz:=DistanzH;
      Distanz:=((Distanz shl 8) shl 8 + DistanzL + 4);
      Ziel:=Ziel+Distanz;
      DisZ.Operand1:=Hexlong(Ziel);
      IF imm=$2B
         THEN BEGIN DisZ.Nextadr:=M.Adresse; M.NextTrAdr:=M.Adresse END
         ELSE BEGIN DisZ.Nextadr:=Ziel; M.NextTrAdr:=Ziel END;
    END;

  BEGIN
    CASE MD OF
      $0: BEGIN DisZ.Befehl:='MOV.B';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexByte(imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+imm,'B');
          END;
      $1: BEGIN DisZ.Befehl:='MOV.W';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexWord(2*imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+2*imm,'W');
          END;
      $2: BEGIN DisZ.Befehl:='MOV.L';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexWord(4*imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+4*imm,'L');
          END;
      $3: IF imm IN [$29,$2A,$2B]
             THEN DisPseudoBral(DisZ,imm)
             ELSE BEGIN DisZ.Befehl:='TRAPA';
                        DisZ.Operand1:='#H'''+Hexbyte(imm);
                        Lies_Quelladr(DisZ,M.SH.VBR+4*imm,Adresse,'L');
                  END;
      $4: BEGIN DisZ.Befehl:='MOV.B';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexByte(imm)+',GBR)';
                lies_Quelladr(DisZ,imm+M.SH.GBR,Adresse,'B');
          END;
      $5: BEGIN DisZ.Befehl:='MOV.W';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexWord(2*imm)+',GBR)';
                lies_Quelladr(DisZ,2*imm+M.SH.GBR,Adresse,'W');
          END;
      $6: BEGIN DisZ.Befehl:='MOV.L';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexWord(4*imm)+',GBR)';
                lies_Quelladr(DisZ,4*imm+M.SH.GBR,Adresse,'L');
          END;
      $7: BEGIN DisZ.Befehl:='MOVA';
                DisZ.Operand1:='@('+HexWord(4*imm)+',PC)';
                (*
                DisZ.Operand1:=HexAdr(((Adresse+2) AND $FFFFFFFC)+(4*imm));
                *)
                Lies_Quelladr(DisZ,(Adresse+2) AND $FFFFFFFC+4*imm,Adresse,'L');
                DisZ.Operand2:='R0'
          END;
      $8: PageC_8('TST');
      $9: PageC_8('AND');
      $A: PageC_8('XOR');
      $B: PageC_8('OR');
      $C: PageC_C('TST.B');
      $D: PageC_C('AND.B');
      $E: PageC_C('XOR.B');
      $F: PageC_C('OR.B');
    END;
  END;

  PROCEDURE PageD(Rn,imm:Byte; VAR DisZ: T_DisZ);
  VAR Zieladr,Inhalt: LongInt;
  BEGIN
    DisZ.Befehl:='MOV.L';
    ZielAdr:=(M.Adresse+2) AND $FFFFFFFC+4*imm;
    DisZ.Operand1:='@('+HexWord(4*imm)+',PC)';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,Zieladr,M.Adresse,'L');
  END;

  PROCEDURE PageE(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV';
    DisZ.Operand1:='#H'''+HexbyteErw(RM*16+LSB);
    DisZ.Operand2:=MakeRn(Rn)
  END;

VAR MSB,Rn,Fx,LSB,imm: Byte;

BEGIN  (* DisassZeile *)
  DisZ.Adr:=HexAdr(M.Adresse);
  Holword(Hexcode,M.Abbruch,M.Adresse);
  DisZ.BefCode := HexWord(HexCode);  DisZ.LongOffset:='';
  DisZ.Befehl := '.word';
  DisZ.Operand1 := ''; DisZ.Operand2:=''; DisZ.Info:='';
  DisZ.Ende  := '';    DisZ.Offset := 'X';
  Disz.NextAdr:=M.Adresse; DisZ.Slotaktiv:=False; DisZ.STCTyp:=False;
  MSB:=Hexcode shr 12;
  Rn:=(Hexcode AND $0F00) shr 8;
  Fx :=(Hexcode AND $00F0) shr 4;
  LSB:=Hexcode AND $000F;
  imm:=HexCode AND $FF;
  CASE MSB OF
    $0: Page0(Rn,Fx,LSB,DisZ);
    $1: Page1(Rn,Fx,LSB,DisZ);
    $2: Page2(Rn,Fx,LSB,DisZ);
    $3: Page3(Rn,Fx,LSB,DisZ);
    $4: Page4(Rn,Fx,LSB,DisZ);
    $5: Page5(Rn,Fx,LSB,DisZ);
    $6: Page6(Rn,Fx,LSB,DisZ);
    $7: Page7(Rn,Fx,LSB,DisZ);
    $8: Page8(Rn,Fx,LSB,DisZ,M.Adresse);
    $9: Page9(Rn,imm,DisZ,M.Adresse);
    $A: PageBra('BRA',Rn,Fx,LSB,DisZ,M.Adresse);
    $B: PageBra('BSR',Rn,Fx,LSB,DisZ,M.Adresse);
    $C: PageC(Rn,imm,DisZ,M.Adresse);
    $D: PageD(Rn,imm,DisZ);
    $E: PageE(Rn,Fx,LSB,DisZ);
    $F: ;    (* verboten *)
  END;
  IF DisZ.Befehl='.word' THEN DisZ.Operand1:=DisZ.BefCode
END;

PROCEDURE Ausgabe(DisZ : T_DisZ);
VAR Ausgabezeile: Str80;

  FUNCTION lbg(s: String; laenge : Integer): String;
  BEGIN
    WHILE length(s) < laenge DO s := s + ' ';
    lbg := s
  END;

BEGIN
  Ausgabezeile:=DisZ.Adr+':'+lbg(DisZ.Befcode,5)+DisZ.LongOffset+' '
                +lbg(DisZ.Befehl,8)
                +DisZ.Operand1;
  IF DisZ.Operand2[0]>#0 THEN Ausgabezeile:=Ausgabezeile+','+DisZ.Operand2;
  Ausgabezeile:=lbg(Ausgabezeile,40);
  IF DisZ.Info[0]>#0 THEN Ausgabezeile:=Ausgabezeile+DisZ.Info;
  Ausgabezeile:=lbg(Ausgabezeile,60);
  Ausgabezeile:=Ausgabezeile+'   next='+hexadr(disz.nextadr);
  writeln(Ausgabezeile);
END;

PROCEDURE Disassemble(VAR M: T_M);
VAR DisZ      : T_DisZ;
    taste     : Char;
    Hexcode   :Word;
    zeilen,a,b: Byte;
    NextAdr   : Longint;
BEGIN
  zeilen:=0; Taste:=#0;
  REPEAT
    inc(zeilen);
    Set_Adresse(M.Adresse);
    Disasszeile(DisZ, M); Ausgabe(DisZ);
    IF keypressed
       THEN BEGIN Taste:=readkey;
                  IF Taste<>#27 THEN Taste:=Readkey
            END
  UNTIL (Taste=#27) OR (Zeilen = 20)
END;

  PROCEDURE lies(VAR Input: T_Input);
  BEGIN
    IF Input.Zeiger>Length(Input.Eingabezeile)
       THEN Input.Taste:=#13
       ELSE BEGIN Input.Taste:=Input.Eingabezeile[Input.Zeiger];
                  Inc(Input.Zeiger)
            END
  END;

  PROCEDURE liesUpcase(VAR Input : T_Input);
  BEGIN
    Lies(Input); Input.Taste:=Upcase(Input.Taste);
  END;

  PROCEDURE Lieswert(VAR Input: T_Input; VAR wert: LongInt);
  BEGIN
    wert:=0;
    WHILE Input.Taste=' ' DO liesUpcase(Input);
    IF ((Input.Taste>='0') AND (Input.Taste<='9')) OR
       ((Input.Taste>='A') AND (Input.Taste<='F'))
      THEN WHILE ((Input.Taste>='0') AND (Input.Taste<='9')) OR
                 ((Input.Taste>='A') AND (Input.Taste<='F'))
             DO BEGIN Wert := Wert * 16 + ord(Input.Taste);
                      IF Input.Taste <= '9' THEN Dec(wert,48)
                                            ELSE Dec(wert,55);
                      liesUpcase(Input)
                END
      ELSE MonFehler('Hexwert erwartet')
  END;

  PROCEDURE lies_und_sende_adresse(VAR Input :T_Input; VAR Adresse: LongInt);
  BEGIN
    Lieswert(Input, Adresse);
    IF Adresse >=$8000000 THEN Adresse:=Adresse AND $FFFFFFFE;
    Set_Adresse(Adresse);
  END;

  PROCEDURE lies_und_sende_Word(VAR Input :T_Input; VAR Adresse: LongInt);
  VAR lHilf: LongInt;
      hilf: Word;
  BEGIN
    Lieswert(Input, lhilf);
    Hilf := LHilf mod $10000;
    put_Byte(Bef_SetByte); put_byte(2); put_byte(Hi(Hilf)); Put_Byte(lo(hilf));
    inc(Adresse,2)
  END;

  PROCEDURE lies_und_sende_Byte(VAR Input :T_Input; VAR Adresse: LongInt);
  VAR lHilf: LongInt;
      hilf: Word;
  BEGIN
    Lieswert(Input, lhilf);
    Hilf := LHilf mod $100;
    put_Byte(Bef_SetByte); put_byte(1); put_byte(Hilf);
    inc(Adresse,1)
  END;

  PROCEDURE hole_und_zeige_Mem(VAR S,AscS: Str80; VAR Adr : LongInt);
  VAR l,h : Byte;
      Abbruch: Boolean;

     FUNCTION MonChr(b:Byte):Char;
     BEGIN IF b < $1F THEN MonChr:=' ' ELSE MonChr:=Chr(b) END;

  BEGIN
     IF (Adr >= $1000000) AND (Adr < $8000000)
        THEN BEGIN
               put_Byte(Bef_ReadByte); put_Byte(1);
               Read_Byte_HS(l,Abbruch);
               S := S + ' ' +HexByte(l); Adr:=Adr+1;
               IF l <= $1F THEN l:=$20;
               AscS:=AscS+MonChr(l)
             END
        ELSE BEGIN
               put_Byte(Bef_ReadByte); put_Byte(2);
               Read_Byte_HS(h,Abbruch); Read_Byte_HS(l,Abbruch);
               S := S + ' ' + hexByte(h)+HexByte(l); Adr:=Adr+2;
               IF l <= $1F THEN l:=$20;
               AscS:=AscS+MonChr(h)+MonChr(l)
             END
  END;

  PROCEDURE zeige_adresse(VAR S: Str80; Adresse : LongInt);
  BEGIN S := ''; s:=hexAdr(Adresse); S:=S + ': ' END;

  PROCEDURE Get_Register(VAR M:T_M);
  VAR i: Integer;
  BEGIN
    Put_Byte(Bef_ReadReg);
    Read_Long_HS(M.SH.VBR,M.Abbruch); Read_Long_HS(M.SH.GBR,M.Abbruch);
    Read_Long_HS(M.SH.MACH,M.Abbruch); Read_Long_HS(M.SH.MACL,M.Abbruch);
    FOR i:=0 TO 15 DO Read_Long_HS(M.SH.R[i],M.Abbruch);
    Inc(M.SH.R[15],12);         (* Korrektur, da R15 zu tief liegt *)
    Read_Long_HS(M.SH.PR,M.Abbruch);
    Read_Long_HS(M.SH.PC,M.Abbruch); Read_Long_HS(M.SH.SR,M.Abbruch);
  END;

  PROCEDURE Put_Register(VAR M: T_M);
  VAR i: Byte;
  BEGIN
    Dec(M.SH.R[15],12);   (* Korrektur von R15 ist noetig *)
    Put_Byte(3);
    Put_Long(M.SH.VBR); Put_Long(M.SH.GBR);
    Put_Long(M.SH.MACH); Put_Long(M.SH.MACL);
    FOR i:=0 TO 15 DO Put_Long(M.SH.R[i]);
    Put_long(M.SH.PR);
    Put_Long(M.SH.PC); Put_Long(M.SH.SR);
  END;

  PROCEDURE read_register(VAR M:T_M);
  VAR i: byte;
  BEGIN
    get_register(M);
    Lowvideo;
    write(#218,'   PC '+HexLong(M.SH.PC)+
          '       PR '+Hexlong(M.SH.PR)+'       SR '+Hexlong(M.SH.SR));
    write('     M=',(M.SH.SR shr 8) AND 1);
    write('  Q=',(M.SH.SR shr 7) AND 1);
    write(' I=');
    i:= (M.SH.SR shr 4) AND $F;
    IF i <= 9 THEN write(i,' ') ELSE write(i);
    write(' S=',(M.SH.SR shr 1) AND 1);
    writeln(' T=',M.SH.SR AND 1,' ',#191);
    writeln(#179,'  VBR '+hexlong(M.SH.VBR)+'      GBR '+Hexlong(M.SH.GBR)
             +'     MACH '+Hexlong(M.SH.MACH)+'     MACL '+HexLong(M.SH.MACL),'         ',#179);
    write(#179,'R0-7 '); FOR i:=0 TO 7 DO write(' '+Hexlong(M.SH.R[i])); writeln(#179);
    write(#192,'R8-15'); FOR i:=8 TO 15 DO write(' '+Hexlong(M.SH.R[i])); writeln(#217);
    Highvideo
  END;

  PROCEDURE readmanyWords(VAR Adr :LongInt; Endadr : LongInt);
  VAR S: Str80;
      AscS: Str80;
      Taste : Char;
  BEGIN
    Taste:=#0;
    REPEAT zeige_adresse(S,Adr);
           AscS:='';
           REPEAT hole_und_zeige_Mem(S,AscS,Adr)
           UNTIL (adr>Endadr) OR (adr AND $F = 0);
           Writeln(S,' ':60-length(s),AscS);
           IF keypressed
              THEN BEGIN Taste:=Readkey;
                         IF taste<>#27 THEN Taste:=Readkey;
                   END
    UNTIL (Taste=#27) OR (Adr>Endadr)
  END;

  PROCEDURE Movebefehl(VAR QuellAdresse: LongInt; Endadresse: LongInt;
                       VAR Input: T_Input; VAR Hostkomm : Boolean);
  VAR ZielSAdresse : LongInt;
  BEGIN
    Put_Byte(Bef_Move); put_Long(Endadresse);
    liesUpcase(Input); lieswert(Input,ZielSAdresse);
    Put_Long(ZielSAdresse); HostKomm:=False (* erzwingt Warten *)
  END;

  PROCEDURE VerifyBefehl(VAR Adresse: LongInt; Endadresse: LongInt;
                         VAR Input: T_Input; VAR Hostkomm : Boolean);

  VAR ZielSAdresse : LongInt;
      b            : Byte;
      Zeile        : Str80;
      Taste        : Char;
      M,M_old      : T_M;
  BEGIN
   Get_Register(M_Old);    (* Registersatz lesen *)
   m:=M_Old;
   liesUpcase(Input); lieswert(Input,ZielSAdresse);
   M.SH.R[5]:=Adresse; M.SH.R[6]:=Endadresse; M.SH.R[7]:=ZielSAdresse;
   REPEAT
      Taste:=#0;
      Put_Register(M);                         (* Registersatz schreiben *)
      Put_Byte(Bef_Verify);                    (* Verify starten *)
      read_byte_HS(b,M.Abbruch);               (* Auf Antwort warten *)
      IF b = 1                                 (* Unterschied gefunden *)
         THEN BEGIN
                Get_Register(M);
                Zeile:=Hexadr(M.SH.R[5])+':'+Hexbyte(M.SH.R[3])
                       +'  '+HexAdr(M.SH.R[7])+':'+Hexbyte(M.SH.R[4]);
                writeln(Zeile);
                IF keypressed
                   THEN BEGIN Taste:=Readkey;
                              IF Taste <> #27 THEN Taste:=Readkey
                        END;
                IF Taste=#27  THEN b:=2;    (* ESC=Abbruch *)
                inc(M.SH.R[5]); Inc(M.SH.R[7])  (* Zeiger erhoehen *)
              END
    UNTIL (b <> 1) OR M.Abbruch OR (M.SH.R[5]>Endadresse);
    IF b=0 THEN writeln('Verify ok');
    Put_Register(M_Old)
  END;

  PROCEDURE lies_Endadresse(VAR Adresse: LongInt; Endadresse: LongInt;
                            VAR Input: T_Input; VAR Hostkomm : Boolean);
  BEGIN          { mu hier Endadresse nicht VAR sein ???? }
    liesUpcase(Input);
    lieswert(Input, Endadresse);
    CASE Input.Taste OF
      #13: readmanywords(Adresse, EndAdresse);
      'M': Movebefehl(Adresse, EndAdresse, Input, HostKomm);
      'V': Verifybefehl(Adresse, EndAdresse, Input, HostKomm)
    END
  END;

  PROCEDURE SetMem(VAR Adresse: LongInt; VAR Input: T_Input);
  BEGIN REPEAT liesUpcase(Input);
               IF Adresse < $8000000
                  THEN Lies_und_sende_Byte(Input,Adresse)
                  ELSE lies_und_sende_Word(Input, Adresse);
        UNTIL Input.Taste <> ' '
  END;

PROCEDURE Set_Trace(VAR M: T_M; BRR:Word; GoAdr: Longint);
BEGIN
  Set_Adresse($5FFFF90);       (* BreakAdressregister     *)
  put_Byte(Bef_SetByte); put_byte(10); Put_Long(M.NextTrAdr);
  put_Long(0); put_Word(BRR);     (* BMR aus, BRR aktivieren *)
  Set_Adresse(GoAdr); Put_Byte(Bef_Go);
  M.Traceaktiv:=False; M.Hostkommando:=False;
END;


  PROCEDURE Monitoradresse(VAR Input : T_Input; VAR M: T_M);
  VAR S,AscS: Str80;
      EndAdresse : LongInt;
  BEGIN
    lies_und_sende_adresse(Input, M.Adresse);
    CASE Input.Taste OF
         ':':  setmem(M.Adresse, Input);
         '.':  Lies_Endadresse(M.Adresse, EndAdresse, Input, M.HostKommando);
         'Z':  Disassemble(M);
         'G':  BEGIN Put_Byte(Bef_Go);
                     M.Hostkommando:=False
               END;
         'T':  BEGIN M.NextTrAdr:=M.Adresse; Set_Trace(M,$54,M.Adresse) END;
         ELSE  BEGIN zeige_adresse(S,M.Adresse);
                     AscS:='';
                     hole_und_zeige_Mem(S,AscS,M.Adresse);
                     Writeln(s,'   ',AscS);
               END
      END
  END;

  PROCEDURE set_register(VAR Adresse : LongInt; VAR Input : T_Input);
  VAR RegName: Str20;
      Wert: LongInt;
      Index: Integer;
      RegOk: Boolean;
      M    : T_M;
  BEGIN { Set_Register }
    get_register(M);
    RegName:='';
    WHILE input.Taste IN ['0'..'9','A'..'Z'] DO
      BEGIN RegName:=RegName+Input.Taste; LiesUpcase(Input) END;
    IF Input.Taste=':'
       THEN BEGIN Input.Taste:=' '; Lieswert(Input,Wert) END
       ELSE RegOk:=False;
    IF RegName[1]='R'
       THEN BEGIN IF (RegName[0]=#2) AND (RegName[2] IN ['0'..'9'])
                     THEN BEGIN Index:=ord(RegName[2])-$30; RegOk:=True END;
                  IF (RegName[0]=#3) AND (RegName[2] ='1')
                     AND (RegName[3] IN ['0'..'5'])
                     THEN BEGIN Index:=ord(RegName[3])-$30+10; RegOk:=True END;
                  M.SH.R[Index]:=Wert
            END
    ELSE IF RegName='MACL' THEN BEGIN M.SH.MACL:=Wert; RegOk:=True END
    ELSE IF RegName='MACH' THEN BEGIN M.SH.MACH:=Wert; RegOk:=True END
    ELSE IF RegName='PC'   THEN BEGIN M.SH.PC:=Wert; RegOk:=True END
    ELSE IF RegName='VBR'  THEN BEGIN M.SH.VBR:=Wert; RegOk:=True END
    ELSE IF RegName='GBR'  THEN BEGIN M.SH.GBR:=Wert; RegOk:=True END
    ELSE IF RegName='I'
            THEN BEGIN IF Wert IN [$10..$15] THEN Wert:=Wert-6; (* Hex-Dez *)
                       RegOk:=(Wert IN [0..15]);
                       IF RegOk THEN M.SH.SR:=(M.SH.SR AND $FFFFFF0F)+Wert shl 4
                 END
    ELSE IF RegName='T'
            THEN BEGIN RegOk:=(Wert IN [0,1]);
                       IF Regok THEN M.SH.SR:=(M.SH.SR AND $FFFFFFFE) + Wert
                 END;
    IF RegOk THEN Put_Register(M)
             ELSE writeln('unbekannter Befehl')
  END;

  PROCEDURE Register(VAR Adresse: Longint; VAR Input: T_Input);
  VAR M: T_M;
  BEGIN
    IF (Input.EingabeZeile[0]=#1) AND (Input.Taste ='R')
       THEN Read_Register(M)
       ELSE Set_Register(Adresse,Input);
  END;

  PROCEDURE Kontinue(VAR M: T_M);
  BEGIN
    IF M.Breakaktiv
       THEN BEGIN Set_Adresse(M.BreakAdresse);
                  Put_Byte(Bef_Go);
                  M.HostKommando:=False;
                  M.Breakaktiv:=False
            END
       ELSE writeln('BREAK ist nicht aktiv')
  END;

  PROCEDURE Sende_StartAdresse(Adr: LongInt; Go : Boolean);
  BEGIN
    Put_Byte(Bef_SetAdresse);
    Put_Long(Adr);
    IF go THEN Put_Byte(Bef_go)
  END;


  PROCEDURE Lies_sende_Block(VAR Code : T_Code;
                             VAR size: Word; VAR diskok : Boolean);
  VAR Anzahl, Anfang, i, j : Word;
  BEGIN
     IF size < PufferBlock
        THEN Anzahl := size
        ELSE Anzahl := PufferBlock;
     Blockread(Code.F, Code.Block, Anzahl);
     {write('.');}
     Diskok := Ioresult = 0;
     dec(size, Anzahl);
     FOR i := 1 TO Anzahl DO
       BEGIN Put_Byte(Bef_SetByte);
             Put_Byte(128);
             Anfang := (i-1) * 128;
             FOR j := 0 TO 127 DO Put_Byte(Code.Block[Anfang+j])
       END
  END;

  PROCEDURE Loadfile(VAR Input : T_Input; VAR HostKommando : Boolean;
                     Act: Boolean);

      PROCEDURE Startadresse_Und_Go_Kommando(VAR StartAdresse : LongInt;
                                             VAR Go_Komm : Boolean;
                                             VAR Input : T_Input);
      VAR Ausgabe : Str80;
      BEGIN
         Go_Komm:=False;
         IF Input.Taste=','
            THEN BEGIN LiesUpcase(Input);
                       IF Input.Taste='G'
                          THEN Go_Komm:=True
                          ELSE BEGIN Lieswert(Input, StartAdresse);
                                     IF Input.Taste=','
                                        THEN BEGIN LiesUpcase(Input);
                                                   Go_Komm:=Input.Taste='G'
                                             END
                               END
                END;
      END;

  VAR Filename: T_Filename;
      Go_Kommando, ok: Boolean;
      Code : T_Code;
      groesse,pr,proz,nr,i,size : Word;
  BEGIN
    FileName:=''; Lies(Input);
    WHILE NOT (Input.Taste IN [' ',#13,',']) DO
      BEGIN FileName:=Filename+Input.Taste; Lies(Input) END;
     IF Filename <> ''
       THEN BEGIN
              Assign(Code.f,FileName); reset(Code.f); ok:=Ioresult = 0;
              IF ok
                 THEN BEGIN
                        nr:=wherey;
                        WHILE nr > 10 do begin writeln; dec(nr) end;
                        groesse:=Filesize(Code.f);
                        size := Filesize(Code.F)- 1;
                        Blockread(Code.f, Code.Block, 1);
                        Code.Startadresse := Code.Block[0] * $1000000 +
                                             (Code.Block[1] * $10000) AND $00FF0000 +
                                             (Code.Block[2] * $100) AND $0000FF00 +
                                             Code.Block[3];
                    {   Code.Laenge :=       Code.Block[4] * $1000000 +
                                             Code.Block[5] * $10000 +
                                             Code.Block[6] * $100 +
                                             Code.Block[7]; }
                        Startadresse_und_Go_Kommando
                              (Code.Startadresse, Go_Kommando, Input);
                        Sende_Startadresse(Code.Startadresse, false);
                        nr:=0;
                        InitMainGauge('Lade Code-Datei',Filename);
                        WHILE (size > 0) AND ok DO
                           BEGIN Lies_Sende_Block(Code, size, ok);
                                 inc(nr,2);
                                 Showgauge(Nr * 100 div Groesse);
                           END;
                        IF NOT ok THEN writeln('Lesefehler')
                                  else showgauge(100);
                        writeln;
                        IF ok THEN  writeln('  Startadresse=$',Hexlong(Code.Startadresse));
                        exitmaingauge;
                        Close(Code.f);
                        Sende_StartAdresse(Code.StartAdresse, Go_Kommando)
                      END
                 ELSE MonFehler('File ' + FileName + ' nicht vorhanden');
                  IF ok THEN HostKommando:= not Go_kommando
            END
  END;

    PROCEDURE TraceIt(VAR M: T_M);
    VAR
        DisZ:  T_DisZ;
        Taste: Char;
        GoAdr: LongInt;
        BRR: Word;
    BEGIN
       M.Breakaktiv:=False;
       Read_register(M); M.Adresse:=M.SH.PC; GoAdr:=M.Adresse; BRR:=$54;
       Set_Adresse(M.Adresse);
       Disasszeile(DisZ,M); Ausgabe(DisZ); M.NextTrAdr:=DisZ.NextAdr;
       IF (DisZ.Befehl[1]='.')
         AND NOT ((DisZ.Befehl='.BRAL') OR (DisZ.Befehl='.BSRL')
                  OR (DisZ.Befehl='.MOVAL')) THEN BRR:=0;
       WHILE DisZ.STCTyp
            DO BEGIN Disasszeile(DisZ,M);
                     Ausgabe(DisZ); M.NextTrAdr:=DisZ.NextAdr
               END;
       IF DisZ.Slotaktiv
          THEN BEGIN Disasszeile(DisZ,M); Ausgabe(DisZ) END;
       Taste:=ReadKey;
       CASE Taste OF
          #27: Set_Trace(M,$00,GoAdr);  (* ESC Trace aufhren *)
          #24: Put_Byte(Bef_Abbruch);   (* Ctrl-X Programm abbrechen *)
          'm','M': BEGIN M.Traceaktiv:=True; M.Hostkommando:=True END
          ELSE Set_Trace(M,BRR,GoAdr);  (* weitermachen   *)
       END
    END;

  PROCEDURE Monitor_main(VAR M: T_M);
  VAR EndAdresse : LongInt;
      Input      : T_Input;
  BEGIN
   Write('Luchs_Mon ');
   IF M.Traceaktiv THEN write('[T]');
   IF M.Breakaktiv THEN write('[B]');
   write(' > ');readln(Input.eingabezeile);
   IF (Input.Eingabezeile[0]=#1) AND (Upcase(Input.Eingabezeile[1])='Q')
   THEN BEGIN M.EndKomm:=True; Put_Byte(Bef_Quit);
              M.Traceaktiv:=False; M.Breakaktiv:=True
        END
   ELSE BEGIN
    Input.Zeiger:=1; Input.Taste := ' ';
    REPEAT liesUpcase(Input) UNTIL Input.Taste <> ' ';
         IF Input.Taste=#13  THEN BEGIN Endadresse:=M.Adresse OR $F;
                                        readmanywords(M.Adresse, EndAdresse)
                                  END
    ELSE IF Input.Taste=':'  THEN setmem(M.Adresse, Input)
    ELSE IF Input.Taste='Z'  THEN disassemble(M)
    ELSE IF Input.Taste='L'  THEN Loadfile(Input, M.Hostkommando, False)
    ELSE IF Input.Taste='K'  THEN BEGIN IF M.Traceaktiv THEN Traceit(M)
                                                        ELSE Kontinue(M)
                                  END
    ELSE IF Input.Taste IN ['0'..'9','A'..'F']
                             THEN Monitoradresse(Input,M)
    ELSE Register(M.Adresse, Input)
   END
  END;

  PROCEDURE Hostslave(VAR M: T_M);

    PROCEDURE IllIRQ;
    VAR b,Typ: Byte;
    BEGIN Read_Byte_HS(Typ,M.Abbruch);
          write('nicht initialisierter ');
          CASE Typ OF
            0: write('SCI');
            1: write('SPI');
            2: write('Pulse Akku Input Edge');
            3: write('Pulse Akku Output');
            4: write('Timer Overflow');
            5: write('TOC3');
            6: write('TOC2');
            7: write('TOC1');
            8: write('TIC3');
            9: write('TIC2');
           10: write('TIC1');
           11: write('RTI');
           12: write('externer IRQ');
           13: write('SWI')
          END;
          Writeln('-Interrupt',#7);
          REPEAT Read_Byte_HS(b,M.Abbruch) UNTIL b=0; (* warte auf Monitorfreigabe *)
          M.HostKommando:=True
    END;

    PROCEDURE Breakpoint(VAR M: T_M);
    VAR BkptNr : Byte;
    BEGIN
      read_Byte_HS(BkptNr,M.abbruch);
      Get_Register(M);
      writeln(#7,'Unterbrechung durch Breakpoint #',bkptnr,
              ' bei Adresse ',hexadr(M.SH.pc));
      M.Adresse:=M.SH.PC; M.Breakadresse:=M.Adresse+2;
      M.Breakaktiv:=true; M.Traceaktiv:=False; M.Hostkommando:=True
    END;

    PROCEDURE Mon_Error(Meldung: Str80);
    VAR DisZ : T_DisZ;
    BEGIN
       writeln(#7,'Fehler: ',Meldung);
       Read_register(M); M.Adresse:=M.SH.PC; Set_Adresse(M.Adresse);
       Disasszeile(DisZ, M); Ausgabe(DisZ);
       M.HostKommando:=True;
    END;

    PROCEDURE Mon_Message;
    VAR Nr: Byte;
    BEGIN
      Read_Byte_HS(Nr,M.Abbruch);
      CASE Nr OF
        0: Mon_Error('Illegaler Opcode');
        1: Mon_Error('Illegale Slot-Anweisung nach einem Sprungbefehl mit Ziel:');
        2: Mon_Error('Adresszugriff zwei Anweisungen vor:');
        3: Mon_Error('DMA-Adresszugriff, aktueller PC:');
        4: Mon_Error('nicht initialisierter Interrupt, aktueller PC:');
        5: TraceIt(M);
      ELSE writeln(#7,#7,#7,'Woher kommt Meldung ',Nr,'??')
      END;
    END;

    PROCEDURE MonAusgabe(B: Byte);
    BEGIN
      CASE b OF
        $08  : write(#8,' ',#8);
        $0C  : clrscr
        ELSE   write(chr(b));
      END
    END;

    PROCEDURE MonGotoxy;
    VAR x,y: Byte;
    BEGIN
      Read_Byte_HS(x,M.Abbruch);
      Read_Byte_HS(y,M.Abbruch);
      Gotoxy(x,y)
    END;

  VAR B     : Byte;
      Taste : Char;
  BEGIN
    read_Byte_HS(b,M.Abbruch);
    IF M.Abbruch OR (b=0)
                  THEN BEGIN M.Hostkommando:=True; M.ExecEnd:=True END
    ELSE IF b=255 THEN Mon_Error('Kommunikation gestoert')
    ELSE IF b=1 THEN BEGIN IF keypressed THEN Put_Byte(1) ELSE Put_Byte(0) END
    ELSE IF b=2 THEN BEGIN Taste:=Readkey; Put_Byte(ord(Taste)) END
    ELSE IF b=3 THEN M.EndKomm:=True
    ELSE IF b=4 THEN Mon_Message
    ELSE IF b=5 THEN IllIrq
    ELSE IF b=6 THEN Breakpoint(M)
    ELSE IF b=$1E THEN MonGotoxy
    ELSE MonAusgabe(b);
  END;

PROCEDURE InitM(VAR M: T_M);
BEGIN
 M.Adresse:=0; M.HostKommando:=False; M.EndKomm:=False;
 M.ExecEnd:=False; M.Traceaktiv:=False;
 M.Breakaktiv:=False; M.Abbruch:=False;
END;

PROCEDURE StartMonitor;
VAR M: T_M;
BEGIN
 InitM(M);
 REPEAT
    IF M.Hostkommando
       THEN Monitor_main(M)
       ELSE HostSlave(M)
 UNTIL M.EndKomm OR M.ExecEnd OR M.Abbruch
END;

PROCEDURE kommunikation;

VAR   B: Byte; M: T_M;
BEGIN
 InitM(M);
 ClrScr; writeln('Monitor-Start mit '+SysInfo.Baudrate);
 Get_Register(M);
 M.Adresse:=M.SH.PC;
 M.Hostkommando:=True;
 M.EndKomm:=False; M.Abbruch:=False;
 M.Breakaktiv:=False;
 REPEAT
    IF M.Hostkommando
       THEN Monitor_main(M)
       ELSE HostSlave(M);
 UNTIL M.EndKomm OR M.Abbruch;
END;

PROCEDURE Monitor;
VAR ok: Boolean;
BEGIN
  Start_Kommunikation(ok);
  IF ok THEN kommunikation
END;

PROCEDURE Execute;

PROCEDURE StartFile(Filename: T_FileName; VAR ok : Boolean);
  VAR
      Code : T_Code;
      Groesse,Nr,size : Word;
  BEGIN
    Assign(Code.f,FileName); reset(Code.f); ok:=Ioresult = 0;
    IF ok
       THEN BEGIN
              InitMainGauge('Lade Code-Datei',Filename);
              Groesse:=Filesize(Code.f);
              size := Filesize(Code.F)- 1;
              Blockread(Code.f, Code.Block, 1);
              Code.Startadresse := Code.Block[0] * $1000000 +
                                   (Code.Block[1] * $10000) AND $00FF0000 +
                                   (Code.Block[2] * $100) AND $0000FF00 +
                                   Code.Block[3];
          {   Code.Laenge :=       Code.Block[4] SHL 24 +
                                   Code.Block[5] SHL 16 +
                                   Code.Block[6] SHL  8 +
                                   Code.Block[7]; }
              Sende_Startadresse(Code.Startadresse, false);
              nr:=0;
              WHILE (size > 0) AND ok DO
                 BEGIN inc(Nr,2);
                       Lies_Sende_Block(Code, size, ok);
                       Showgauge(Nr * 100 div Groesse);
                 END;
              {IF NOT ok THEN Fehler('Lesefehler');}
              Close(Code.f);
              Showgauge(100);
              ExitMainGauge;
              Sende_StartAdresse(Code.StartAdresse, False)
            END
       ELSE { Fehler('File ' + CName + ' nicht vorhanden');  }
END;


VAR M          : T_M;
    Taste      : Char;
    b          : Byte;
    ok         : Boolean;
BEGIN
  M.Abbruch:=False;
  Start_Kommunikation(ok);
  IF ok
     THEN BEGIN
            StartFile(Workfile.CName, Ok);
            IF ok
               THEN BEGIN
                      InputRec.Meldung[1]:='Programm im RAM starten?';
                      InputRec.Meldung[3]:='        S(tandalone';
                      InputRec.Meldung[4]:='        H(ostrechner';
                      InputRec.Meldung[5]:='        N(icht starten';
                      Show_Meldung;
                      Taste:=Upcase(Readkey);
                      IF (Taste='S') OR (Taste='H')
                       THEN Put_Byte(Bef_Go);
                      IF Taste='S' THEN InputRec.Meldung[3]:='Programm gestartet...';
                      IF Taste='H'
                       THEN BEGIN
                             clrscr;
                             InitM(M);
                             REPEAT
                              IF M.Hostkommando
                               THEN Monitor_main(M)
                               ELSE HostSlave(M);
                              IF M.ExecEnd THEN Put_Byte(Bef_Quit)
                             UNTIL M.EndKomm OR M.ExecEnd OR M.Abbruch
                            END;
                      IF Taste='N' THEN Put_Byte(Bef_Quit);
                    END
               ELSE InputRec.Meldung[5]:='Fehler beim Einlesen von '+Workfile.CName;
          END
END;

END.

