{
 29.01.98 Alf Pullvariable bei Funktionsvariablen
 }
UNIT PasCode;

INTERFACE
USES LuchsTyp, CodeSave, PasScan;

CONST Push_R0=$2F06;     (* mov.l R0,@-R15 *)
      Push_R1=$2F16;     (* mov.l R1,@-R15 *)
      Push_R2=$2F26;     (* mov.l R2,@-R15 *)
      Push_R3=$2F36;     (* mov.l R3,@-R15 *)
      Pull_R0=$60F6;     (* mov.l @R15+,R0 *)
      Pull_R1=$61F6;     (* mov.l @R15+,R1 *)
      Pull_R2=$62F6;     (* mov.l @R15+,R2 *)
      Pull_R3=$63F6;     (* mov.l @R15+,R3 *)
      Push_PR=$4F22;     (* sts.l PR,@-R15 *)
      Pull_PR=$4F26;     (* lds.l @R15+,PR *)
      Push_VR=$2FC6;     {  MOV.L R12,@-R15 }
      Pull_VR=$6CF6;     {  MOV.L @R15+,R12 }
      NOP    =$0009;     {  NOP }
      Leer   =$FFFF;     {  kein Opcode }
      VarReg =12;        { bezeichnet den lokalen Variablenstart  }
      ExtReg =13;        { fr globale Variablen }
      Display =- $80;    { im CPU-Ram  0FFFFFF80-0FFFFF9F }

TYPE  T_BralInfo  = RECORD AdrBra, AdrDiff : T_AdrInfo;
                           BraPC           : LongInt
                    END;

      T_Element     = RECORD Zahl      : LongInt;
                             Definiert : Boolean;
                             BInfo     : T_BralInfo
                    END;

      T_Stack  = ^Knoten;
      T_GLStack   = RECORD G, L : T_STack
                    END;
      Knoten      = RECORD Inh  : T_Element;
                           next : T_Stack
                    END;


PROCEDURE CodiereWord(W: Word);
PROCEDURE CodiereLong(L: LongInt );
PROCEDURE Codiere_Trap(Nr : T_Trap );
PROCEDURE Codiere_BraBack(Ziel: Longint);
PROCEDURE Ersetze_BraL(VAR Info: T_BralInfo);
PROCEDURE Ersetze_GotoBraL(VAR Info : T_BralInfo; PC: LongInt);
PROCEDURE Codiere_Bral(VAR Info: T_BralInfo);
PROCEDURE Push_VarRegister(RegVars : LongInt);
PROCEDURE Pull_VarRegister(RegVars : LongInt);

PROCEDURE Codiere_JSR ( Ziel  : LongInt; Tiefe : Word; RegVars : LongInt);
PROCEDURE Codiere_RTS;
PROCEDURE CodiereNop;
PROCEDURE LastOpcode_leer;
PROCEDURE Load_Var(PrNr, LokPrNr,Offset, Laenge: LongInt);
PROCEDURE Push_VarAdr(PrNr, LokPrNr: Word; Offset: LongInt);
PROCEDURE Push_RefVarAdr(PrNr, LokPrNr : Word; Offset: LongInt);
PROCEDURE GetVarSpace( Laenge: LongInt);
PROCEDURE FreeVarSpace(Laenge: LongInt);
PROCEDURE Put_lokVarAdr(PrNr : Word; ParSpace: LongInt);
PROCEDURE Codiere_Exit(PrNr, Tiefe : Word);
PROCEDURE Codiere_Inc(Offset, Laenge, Wert : LongInt);
PROCEDURE Push_RealRegister;
PROCEDURE Push_Integer(i : LongInt );
PROCEDURE Push_String(Stri: String );
PROCEDURE Push_Variable(Laenge: Integer ; ErgebString: Boolean);
PROCEDURE Pull_Variable(Laenge: Integer ; IstStr, Funktionsvar : Boolean);
PROCEDURE Store_Variable(Offset, Laenge: LongInt);
PROCEDURE Load_Variable(Offset, Laenge: LongInt; VarParam : Boolean);
PROCEDURE Addiere_IntStack;
PROCEDURE Subtrahiere_IntStack;
PROCEDURE Neg_IntStack;
PROCEDURE Push_Real(R : Double);
PROCEDURE Create_Empty_Set;
PROCEDURE ChartoStringTop;
PROCEDURE CodiereCMPReal(Token: T_Token);
PROCEDURE CodiereCMPInteger(Token: T_Token);
PROCEDURE CodiereCMPSet(Token: T_Token);
PROCEDURE CodiereCMPString(Token: T_Token);
PROCEDURE CodiereCMPViel(Token: T_Token; Anzahl : Word);
PROCEDURE Create_St(VAR S : T_Stack);
FUNCTION  empty_S(S : T_Stack): Boolean;
PROCEDURE push(VAR S: T_Stack; x : T_Element);
PROCEDURE Pull(VAR S : T_Stack);
PROCEDURE Top(S: T_Stack; VAR X : T_Element);

PROCEDURE Delete_S(VAR S : T_Stack);
PROCEDURE Setze_idJmp(LbS :T_Stack);
FUNCTION  ProcAdr(Nr : Word): LongInt;
PROCEDURE machPClang;
PROCEDURE machLangWort(VAR x: LongInt);
PROCEDURE machWort(VAR x: LongInt);

VAR LastOpCode: Word;

IMPLEMENTATION
{$IFDEF Delphi }
USES CommWin;
{$ELSE }
USES CommDOS;
{$ENDIF }

(* ----------------------------------------------------------------------- *)
(*  Hilfsprozeduren fr die Pascal-Code-Erzeugung                                 *)
(* ----------------------------------------------------------------------- *)

PROCEDURE CodiereWord(W: Word);
VAR anders : Boolean;
    LastOp : Word;
BEGIN
  anders := false;  LastOp := LastOpcode;
  CASE LastOpcode OF
        Push_R0: IF W = Pull_R0 THEN LastOp := leer
                                ELSE anders := true;
        Push_R1: IF W = Pull_R1 THEN LastOp := leer
                                ELSE anders := true;
        Push_R2: IF W = Pull_R2 THEN LastOp := leer
                                ELSE anders := true;
        Push_R3: IF W = Pull_R3 THEN LastOp := leer
                                ELSE anders := true;
        Push_PR: IF W = Pull_PR THEN LastOp := leer
                                ELSE anders := true;
        Push_VR: IF W = Pull_VR THEN LastOp := leer
                                ELSE anders := true;
        leer   : LastOp := w;
        ELSE    anders := true
     END;
  IF anders THEN BEGIN CodiereCodeWord(LastOpcode);
                       LastOpcode := W
                 END
            ELSE LastOpcode := LastOp
END;

PROCEDURE LastOpcode_leer;
BEGIN
   IF LastOpcode <> leer
      THEN CodiereCodeWord(LastOpcode);
   LastOpcode := leer
END;

PROCEDURE CodiereLong(L : LongInt);
BEGIN
  LastOpcode_leer;
  CodiereCodeLong(L);
END;

PROCEDURE Codiere_Trap(Nr: T_Trap);
BEGIN
  LastOpcode_leer;
  IF Nr > R_Last
     THEN Fehler('Runtime-Aufruf nicht implementiert');
  CodiereCodeWord($E100+Ord(Nr));  (* mov #0..127,R1   *)
  CodiereCodeWord($C320);          (* Trapa #T_Runtime *)
END;

PROCEDURE CodiereNop;
BEGIN LastOpcode_leer; CodiereCodeWord($0009) END;

PROCEDURE Codiere_Bral(VAR Info: T_BralInfo);
BEGIN
  LastOpcode_leer;
  IF Code.PC AND 2 = 0 THEN CodiereNop;
  Info.BraPC := Code.PC;
  LiesAdresse(Info.AdrBra);
  CodiereCodeword($C702);    { MOVA Zielptr,R0 }
  CodiereCodeWord($6102);    { MOV.L @R0,R1 }
  CodiereCodeWord($310C);    { ADD R0,R1 }
  CodiereCodeWord($412B);    { JMP @R1 }
  CodiereCodeWord($0009);    { NOP }
  IF Code.PC and 2 = 2 THEN CodiereCodeWord($0009);
  LiesAdresse(Info.AdrDiff); { hier spaeter Offset einsetzen }
  CodiereCodeLong($00090009);{ DoppNopp }
END;

PROCEDURE Ersetze_BraL(VAR Info : T_BralInfo);
VAR Distanz: LongInt;
BEGIN
  LastOpcode_leer;
  Distanz:=Code.PC-Info.BraPC-4;
  IF Distanz<= 4090
     THEN ErsetzeLong((($A000+(Distanz shr 1))shl 8)shl 8+$0009,Info.AdrBra)   { BRA Distanz }
     ELSE ersetzeLong(Code.PC-Info.BraPC-10,Info.AdrDiff);
END;

PROCEDURE Ersetze_GotoBraL(VAR Info : T_BralInfo; PC: LongInt);
VAR Distanz: LongInt;
BEGIN
  LastOpcode_leer;
  ersetzeLong(PC-Info.BraPC-10,Info.AdrDiff);
END;

PROCEDURE Codiere_BraBack(Ziel: Longint);
VAR Distanz: LongInt;
BEGIN
  LastOpcode_Leer;
  Distanz:=Ziel-Code.PC-4;
  IF Distanz >= -4090
     THEN BEGIN CodiereCodeWord($A000+((Distanz shr 1) AND $FFF));
                CodiereNop
          END
     ELSE BEGIN CodiereCodeword($C702);    { MOVA Zielptr,R0 }
                CodiereCodeWord($6102);    { MOV.L @R0,R1 }
                CodiereCodeWord($310C);    { ADD R0,R1 }
                CodiereCodeWord($412B);    { JMP @R1 }
                CodiereCodeWord($0009);    { NOP }
                MachPClang;
                CodiereCodeLong(Ziel - Code.PC)
          END;
END;

PROCEDURE Codiere_JSR ( Ziel  : LongInt; Tiefe: Word; RegVars: LongInt);
{ in PASCAL immer zurck mit bekannter Adresse !
  Jetzt mit neuem Hans-Jrgschen Code ! }
VAR Diff : LongInt;
BEGIN
  lastOpcode_leer;
  Diff := Ziel - Code.PC - 4;
  IF Diff >= -4090
     THEN BEGIN Diff := 4096 + Diff div 2;
                CodiereCodeWord($B000 +  Diff);  { BSR diff }
                CodiereNOP
          END
     ELSE BEGIN
                    CodiereCodeword($C703);    { MOVA Zielptr,R0 }
                    CodiereCodeWord($6102);    { MOV.L @R0,R1 }
                    CodiereCodeWord($310C);    { ADD R0,R1 }
                    CodiereCodeWord($410B);    { JSR @R1 }
                    CodiereCodeWord($0009);    { NOP }
                    MachPClang;
                    CodiereCodeWord($A002);    { BRA +2 }
                    CodiereCodeWord($0009);    { NOP }
                    CodiereCodeLong(Ziel - Code.PC)
          END;
   CodiereCodeWord(Pull_Pr);                   { LDS   @R15+,PR }
   CodiereCodeWord($60F6+$100*VarReg);         { MOV.L @R15+,VarReg }
   Pull_VarRegister(RegVars);
END;

PROCEDURE Codiere_RTS;
BEGIN
  LastOpcode_leer;
  CodiereCodeWord($000B);  { RTS }
  CodiereNOP;
END;

FUNCTION ProcAdr(Nr : Word): LongInt;
BEGIN
  ProcAdr := Display + 4 * Nr
END;

PROCEDURE Load_Var(PrNr, lokPrNr, Offset, Laenge: LongInt);
{ Ldt den Wert der Variablen in R0 und die Adresse in R1
  - nur fr For-Schleife ! }
BEGIN
  IF Laenge = 0
     THEN IF PrNr = LokPrNr
             THEN CodiereWord($6003+$10*Offset)  { MOV Roffset, R0 }
             ELSE Fehler('globales Register verboten')
     ELSE BEGIN
             LastOpcode_leer;
             KS_CodiereS_Long(Offset,1);
             IF PrNr = lokPrNr
                THEN CodiereCodeWord($310C+$10*VarReg)    { ADD VarReg,R1 }
                ELSE BEGIN     { globale Variable }
                       KS_CodiereS_long(ProcAdr(PrNr),ExtReg);
                       CodiereCodeWord($6002+$110*ExtReg); { MOV.L @ExtReg,ExtReg }
                       CodiereCodeWord($310C+$10*ExtReg)  { ADD ExtReg, R1 }
                     END;
             CASE Laenge OF
               1 : CodiereCodeWord($6010);    { MOV.B @R1,R0 }
               2 : CodiereCodeWord($6011);    { MOV.W @R1,R0 }
               4 : CodiereCodeWord($6012);    { MOV.L @R1,R0 }
               ELSE Fehler('als Schleifenparameter verboten ')
             END
           END
END;

PROCEDURE Push_VarAdr(PrNr, lokPrNr: Word; Offset: LongInt);
BEGIN
  LastOpcode_leer;
  KS_CodiereS_Long(Offset,0);
  IF PrNr = lokPrNr
     THEN CodiereCodeWord($300C+$10*VarReg)    { ADD VarReg,R0 }
     ELSE BEGIN     { globale Variable }
            KS_CodiereS_long(ProcAdr(PrNr),ExtReg);
            CodiereCodeWord($6002+$110*ExtReg); { MOV.L @ExtReg,ExtReg }
            CodiereCodeWord($300C+$10*ExtReg)  { ADD ExtReg, R0 }
          END;
  CodiereWord(Push_R0)
END;

PROCEDURE Push_VarRegister(RegVars : LongInt);
VAR i : LongInt;
BEGIN
  IF RegVars > 4
     THEN FOR i := 4 TO RegVars - 1 DO
              CodiereWord($2F06+$10*i) { MOV.L Ri,@-R15 }
END;

PROCEDURE Pull_VarRegister(RegVars : LongInt);
VAR i : LongInt;
BEGIN
  IF RegVars > 4
     THEN FOR i := RegVars - 1 DOWNTO 4 DO
              CodiereWord($60F6+$100*i) { MOV.L @R15+,Ri }
END;

PROCEDURE Push_RefVarAdr(PrNr,lokPrNr: Word; Offset: LongInt);
BEGIN
  LastOpcode_leer;
  KS_CodiereS_Long(Offset,0);
  IF PrNr = lokPrNr
     THEN CodiereCodeWord($300C+$10*VarReg)    { ADD VarReg,R0 }
     ELSE BEGIN     { globale Variable }
            KS_CodiereS_long(ProcAdr(PrNr),ExtReg);
            CodiereCodeWord($6002+$110*ExtReg); { MOV.L @ExtReg,ExtReg }
            CodiereWord($300C+$10*ExtReg)  { ADD ExtReg, R0 }
          END;
  CodiereCodeWord($6002);  { MOV.L @R0,R0 }
  CodiereWord(Push_R0)
END;

PROCEDURE GetVarSpace( Laenge: LongInt);
BEGIN
  LastOpcode_leer;
  IF Laenge > 0
     THEN IF Laenge <= 128
             THEN  CodiereCodeWord($7F00+256-Laenge)  { SUB #Laenge,R15 }
             ELSE  BEGIN
                     KS_CodiereS_Long(Laenge,0);      { MOV #Laenge,R0 }
                     CodiereCodeWord($3F08)           { SUB  R0,R15 }
                   END
END;


PROCEDURE FreeVarSpace(Laenge: LongInt);
{ gibt Variablenplatz des Stacks frei }
BEGIN
  IF Laenge > 0
     THEN IF Laenge <= 127
             THEN CodiereWord($7F00+Laenge)     { Add #Laenge,R15 }
             ELSE BEGIN
                    LastOpcode_leer;
                    KS_CodiereS_Long(Laenge,1);    { MOV #Laenge,R1 }
                    CodiereCodeWord($3F1C)           { ADD R1,R15 }
                  END
 END;

PROCEDURE Put_lokVarAdr(PrNr : Word; Parspace: LongInt);
{ Erzeugt korrekte Display-Adresse, Wird auch bei Space = 0 ausgefhrt,
  damit exit(proc) funktioniert.  }
BEGIN
   LastOpcode_leer;
   CodiereCodeWord($60F3+$100*VarReg);            { MOV R15,VarReg (lokaler Datenzeiger) }
   KS_CodiereS_long(ProcAdr(PrNr),1);             { MOV #PrAdr,R1  }
   IF ParSpace <> 0
      THEN BEGIN KS_CodiereS_long(ParSpace,0);       { MOV #ParSpace,R0 }
                 CodiereCodeWord($300C+$100*VarReg); { ADD R0,VarReg }
           END;
   CodiereCodeWord($2102+$10*VarReg)              { MOV VarReg,@R1 }
END;

PROCEDURE Codiere_Exit(PrNr, Tiefe : Word);
BEGIN
  LastOpcode_leer;
  KS_CodiereS_long(ProcAdr(PrNr),1);
  CodiereCodeWord($6F12);                { MOV.L @R1,R15 }
  IF PrNr < Tiefe
      THEN BEGIN
              KS_CodiereS_long(ProcAdr(PrNr+1),0);
              CodiereCodeWord($6102);  { MOV.L @R0,R1 }
              CodiereCodeWord($6212);  { MOV.L @R1,R2 }
              CodiereCodeWord($422B);  { JMP   @R2 }
              Codierenop
           END
      ELSE Codiere_RTS;
END;

PROCEDURE Codiere_Inc(Offset, Laenge, Wert : LongInt);
BEGIN
 IF Wert < 0 THEN Wert := $100 + Wert;
 LastOpcode_leer;
 CASE Laenge OF
   0: CodiereWord($7000+$100*Offset+Wert);
   1: BEGIN KS_CodiereS_long(Offset,0);
            CodiereWord($010C+$10*VarReg);  { MOV.B @(R0,VarReg),R1 }
            CodiereWord($7100+Wert);        { ADD   #Wert,R1 }
            CodiereWord($0014+$100*VarReg); { MOV.B R1,@(R0,VarReg) }
      END;
   2: BEGIN  KS_CodiereS_long(Offset,0);
            CodiereWord($010D+$10*VarReg);  { MOV.W @(R0,VarReg),R1 }
            CodiereWord($7100+Wert);        { ADD   #Wert,R1 }
            CodiereWord($0015+$100*VarReg); { MOV.W R1,@(R0,VarReg) }
      END;
   4: BEGIN KS_CodiereS_long(Offset,0);
            CodiereWord($010E+$10*VarReg);  { MOV.L @(R0,VarReg),R1 }
            CodiereWord($7100+Wert);        { ADD   #Wert,R1 }
            CodiereWord($0016+$100*VarReg); { MOV.L R1,@(R0,VarReg) }
      END;
   ELSE FEHLER(' INC mit dieser Variable nicht erlaubt')
   END
END;

PROCEDURE Push_RealRegister;
{ ldt den Real-Wert aus den Registern R2 /R3 auf den Stack }
BEGIN
  CodiereWord(Push_R3);
  CodiereWord(Push_R2)
END;

PROCEDURE Push_Real(R : Double);
{ legt R als Real auf dem Stack ab }
BEGIN
  LastOpcode_leer;
  KS_CodiereS_Real(R,2);
  Push_RealRegister
END;

PROCEDURE Push_Integer(i : LongInt);
{ legt i als Langwort auf dem Stack ab }
BEGIN
  LastOpcode_leer;
  KS_CodiereS_long(i,1);
  CodiereWord(Push_R1)
END;

PROCEDURE Push_String(Stri: String);
VAR i: Integer;
BEGIN
   LastOpcode_leer;
   KS_CodiereS_Str(Stri);
   CodiereWord(Push_R0);
   Codiere_Trap(R_StrPush)
END;

PROCEDURE Push_Variable(Laenge: Integer; ErgebString : Boolean);
BEGIN
  IF ErgebString
     THEN Codiere_Trap(R_StrPush)
     ELSE IF Laenge <= 4
             THEN BEGIN
                    CodiereWord(Pull_R0);
                    CASE Laenge OF
                      0 : Fehler ('globale Register nicht erlaubt');
                      1 : CodiereWord($6100);    { MOV.B @R0,R1 }
                      2 : CodiereWord($6101);    { MOV.W @R0,R1 }
                      4 : CodiereWord($6102);    { MOV.L @R0,R1 }
                      END;
                    CodiereWord(Push_R1)
                  END
             ELSE IF Laenge = 8
                     THEN BEGIN CodiereWord(Pull_R0);
                                CodiereWord($6206); { MOV.L @R0+,R2 }
                                CodiereWord($6302); { MOV.L @R0,R3 }
                                Push_RealRegister;
                          END
                     ELSE BEGIN Push_Integer((Laenge+3) div 4);
                                Codiere_Trap(R_PushViel)
                          END
END;

PROCEDURE Pull_Variable(Laenge: Integer;
                        IstStr, FunktionsVar: Boolean);
BEGIN
  IF IstStr
     THEN BEGIN
             Push_Integer(255);        { maxlaenge des Strings }
             Codiere_Trap(R_StrPull)
          END
     ELSE IF Laenge <= 4         { Normalfall }
             THEN BEGIN
                    CodiereWord(Pull_R1);
                    CodiereWord(Pull_R0);
                    IF FunktionsVar             {29.1.98}
                       THEN CodiereWord($2012)
                       ELSE BEGIN
                              IF Laenge = 0 THEN Fehler('globale Register nicht erlaubt');
                              IF Laenge = 1   { Byte }
                                 THEN CodiereWord($2010)         { MOV.B R1,@R0 }
                                 ELSE IF Laenge = 2
                                         THEN CodiereWord($2011) { MOV.W R1,@R0 }
                                          ELSE CodiereWord($2012){ MOV.L R1,@R0 }
                            END
                  END
             ELSE IF Laenge = 8   { Real }
                     THEN BEGIN
                            CodiereWord(Pull_R2);
                            CodiereWord(Pull_R3);
                            CodiereWord(Pull_R0);
                            CodiereWord($2022); { MOV.L R2,@R0 }
                            CodiereWord($7004); { ADD #4,R0 }
                            CodiereWord($2032)  { MOV.L R3,@R0 }
                          END
                     ELSE BEGIN Push_Integer((Laenge+3) div 4);
                                Codiere_Trap(R_PullViel)
                          END
END;

PROCEDURE Store_Variable(OffSet, Laenge: LongInt);
{ Bei Zuweisungen mit Laenge <= 4 auf lokale Variablen }
BEGIN
  CodiereWord(Pull_R1);                      { Ausdruck}
  IF Laenge = 0
     THEN CodiereWord($6013+$100*Offset)   { MOV R1,Roffset }
     ELSE BEGIN
             Lastopcode_leer;
             KS_CodiereS_long(Offset, 0);
             CASE Laenge OF
               1 : CodiereCodeWord($0014+$100*VarReg);  { MOV.B R1,@(R0,VarReg) }
               2 : CodiereCodeWord($0015+$100*VarReg);  { MOV.W R1,@(R0,VarReg) }
               4 : CodiereCodeWord($0016+$100*VarReg);  { MOV.L R1,@(R0,VarReg) }
               ELSE Fehler('falsche Variablenlaenge')
             END
          END
END;

PROCEDURE Load_Variable(OffSet, Laenge: LongInt; VarParam: Boolean);
{ Bei Zuweisungen mit Laenge <= 4 auf lokale Variablen }
BEGIN
  IF Laenge = 0
     THEN CodiereWord($6103+$10*Offset)   { MOV Roffset,R1 }
     ELSE BEGIN
            Lastopcode_leer;
            KS_CodiereS_long(Offset, 0);
            IF VarParam
               THEN BEGIN
                      CodiereCodeWord($010E+$10*VarReg);    { MOV.L @(R0,VarReg),R1 }
                      CASE Laenge OF
                           1 : CodiereCodeWord($6110);      { MOV.B @R1,R1 }
                           2 : CodiereCodeWord($6111);      { MOV.W @R1,R1 }
                           4 : CodiereCodeWord($6112);      { MOV.L @R1,R1 }
                           ELSE Fehler('falsche Variablenlaenge')
                      END
                    END
               ELSE CASE Laenge OF
                      1 : CodiereCodeWord($010C+$10*VarReg);  { MOV.B @(R0,VarReg),R1 }
                      2 : CodiereCodeWord($010D+$10*VarReg);  { MOV.W @(R0,VarReg),R1 }
                      4 : CodiereCodeWord($010E+$10*VarReg);  { MOV.L @(R0,VarReg),R1 }
                      ELSE Fehler('falsche Variablenlaenge')
                    END;
           END;
  CodiereWord(Push_R1);
END;

PROCEDURE Addiere_IntStack;
BEGIN
  CodiereWord(Pull_R1);
  CodiereWord(Pull_R0);
  CodiereWord($310C);    { ADD R0,R1 }
  CodiereWord(Push_R1)
END;

PROCEDURE Subtrahiere_IntStack;
BEGIN
  CodiereWord(Pull_R1);
  CodiereWord(Pull_R0);
  CodiereWord($3018);    { SUB R1,R0 }
  CodiereWord(Push_R0)
END;

PROCEDURE Neg_IntStack;
BEGIN
  CodiereWord(Pull_R1);
  CodiereWord($611B);  { NEG R1,R1 }
  CodiereWord(Push_R1)
END;

{ --- Vergleichsoperationen -------------------------------- }

PROCEDURE CodiereInvertT;
{ invertiert das T-Flag }
BEGIN
  CodiereWord($0029); { MOVT R0 }
  CodiereWord($8800); { CMP/EQ #0,R0 }
END;

PROCEDURE CodiereCMPSet(Token: T_Token);
BEGIN
  CASE Token OF
       Groesser_Gleich : Codiere_Trap(R_SetBkgA);
       Gleich          : BEGIN Push_Integer(32);
                               Codiere_Trap(R_CmpViel)
                         END;
       Ungleich        : BEGIN Push_Integer(32);
                               Codiere_Trap(R_CmpViel);
                               CodiereInvertT
                         END;
       Kleiner_Gleich  : Codiere_Trap(R_SetAkgB);
       In_T            : Codiere_Trap(R_SetIn);
       ELSE    Fehler('Operation fuer Mengen nicht erlaubt')
      END
END;

PROCEDURE CodiereCMPString(Token: T_Token);
BEGIN
  Codiere_Trap(R_StrCmp);
  CodiereWord(Pull_R0);
  CASE Token OF
       Groesser_Gleich : BEGIN CodiereWord($88FF); { kleiner }
                               CodiereInvertT
                         END;
       Groesser        : CodiereWord($8801);    { CMP/EQ #1,R0 }
       Gleich          : CodiereWord($8800);    { CMP/EQ #0,R0 }
       Ungleich        : BEGIN CodiereWord($8800); { gleich }
                               CodiereInvertT
                         END;
       Kleiner_Gleich  : BEGIN CodiereWord($8801);  { groesser }
                               CodiereInvertT
                         END;
       Kleiner         : CodiereWord($88FF);    { CMP/EQ #-1,R0 }
       ELSE    Fehler('Operation fuer Strings nicht erlaubt')
      END
END;

PROCEDURE CodiereCMPReal(Token: T_Token);
BEGIN
  Codiere_Trap(R_FloatCmp);
  CodiereWord(Pull_R0);
  CASE Token OF
       Groesser_Gleich : BEGIN CodiereWord($88FF);  { kleiner }
                               CodiereInvertT
                         END;
       Groesser        : CodiereWord($8801);        { CMP/EQ #1,R0 }
       Gleich          : CodiereWord($8800);        { CMP/EQ #0,R0 }
       Ungleich        : BEGIN CodiereWord($8800);  { gleich }
                               CodiereInvertT
                         END;
       Kleiner_Gleich  : BEGIN CodiereWord($8801);  { groesser }
                               CodiereInvertT
                         END;
       Kleiner         : CodiereWord($88FF);        { CMP/EQ #-1,R0 }
       ELSE    Fehler('Operation fr Reals nicht erlaubt')
      END
END;

PROCEDURE CodiereCMPViel(Token: T_Token; Anzahl : Word);
BEGIN
  CASE Token OF
       Gleich          : BEGIN Push_Integer(Anzahl);
                               Codiere_Trap(R_CmpViel)
                         END;
       Ungleich        : BEGIN Push_Integer(Anzahl);
                               Codiere_Trap(R_CmpViel);
                               CodiereInvertT
                         END;
       ELSE    Fehler('Operation fr diesen Typ nicht erlaubt')
      END
END;


PROCEDURE CodiereCMPInteger(Token: T_Token);
BEGIN
   CodiereWord(Pull_R0);
   CodiereWord(Pull_R1);
   CASE Token OF
     Groesser       : CodiereWord($3107); { CMP/GT R0,R1 }
     Groesser_Gleich: CodiereWord($3103); { CMP/GE R0,R1 }
     Gleich         : CodiereWord($3100); { CMP/EQ R0,R1 }
     UnGleich       : BEGIN
                         CodiereWord($3100); { CMP/EQ R0,R1 }
                         CodiereInvertT;
                      END;
     Kleiner        : CodiereWord($3017); { CMP/GT R1,R0 }
     Kleiner_Gleich : CodiereWord($3013); { CMP/GE R1,R0 }
   END
END;

PROCEDURE Create_Empty_Set;
BEGIN
  CodiereWord($E000);     { MOV #0, R0 }
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
  CodiereWord(Push_R0);
END;

PROCEDURE ChartoStringTop;
{ Verwandelt Char auf dem Stack in einen String der Laenge 1 }
BEGIN
  CodiereWord(Pull_R0);
  KS_CodiereS_long(252,1);
  CodiereWord($3F18);         { SUB    R1,R15 }
  CodiereWord($7104);         { ADD    #4,R1 }
  CodiereWord($301C);         { ADD    R1,R0 }
  CodiereWord($6009);         { SWAP.W R0,R0 }
  CodiereWord(Push_R0)
END;

(* ----------------------------------------------------------------------- *)
(*  Hilfsprozeduren fr den Goto- Stack                                    *)
(* ----------------------------------------------------------------------- *)

PROCEDURE Create_St(VAR S : T_Stack);
BEGIN S := nil END;

FUNCTION empty_S(S : T_Stack): Boolean;
BEGIN Empty_S := s = nil END;

PROCEDURE push(VAR S: T_Stack; x : T_Element);
VAR Hilf : T_Stack;
BEGIN
   new(Hilf);
   Hilf^.Inh := x;
   Hilf^.next := S;
   S := Hilf
END;

PROCEDURE Pull(VAR S : T_Stack);
VAR Help : T_Stack;
BEGIN
   Help := S;
   S := S^.next;
   Dispose(Help)
END;

PROCEDURE Top(S: T_Stack; VAR X : T_Element);
BEGIN x := S^.Inh   END;


PROCEDURE Delete_S(VAR S : T_Stack);
BEGIN
  WHILE not empty_S(S) DO pull(S)
END;

PROCEDURE Setze_idJmp(LbS :T_Stack);
Var aktlb : T_Element;
    Hilf  : T_Stack;
BEGIN
   WHILE not Empty_S(LbS)
      DO BEGIN Top(LbS, aktLb);
               Hilf := LBS;
               Ersetze_Bral(aktlb.BInfo);
               LBS := LBS^.next;
               Dispose(Hilf)
         END
END;

PROCEDURE machPClang;
BEGIN
  LastOpcode_leer;
  IF Code.PC mod 4 <> 0 THEN CodiereNOP
END;

PROCEDURE machLangWort(VAR X : LongInt);
BEGIN
 IF x mod 4 <> 0
    THEN x := 4 * (x div 4 + 1)
END;

PROCEDURE machWort(VAR X : LongInt);
BEGIN
 IF x mod 2 <> 0 THEN inc(x)
END;

BEGIN
  LastOpcode := leer;
END.
