UNIT PasDekl; { Typen-, Prozeduren- und Variablendeklaration Pascal }
{ 05.06.95 Alf Ursprungsversion aus MOPS\VER22
  15.10.96 Alf Die Prozedur Ersetze_BralInfo ist verlorengegangen!
}

INTERFACE

USES LuchsTyp ,PasScan, PasCode;
CONST Sys_Proc   = -1;   { um System-Prozeduren zu identifizieren}

TYPE
(* ------ Typen-Baum ----------------------------------------------------- *)
     Typ_Art         = (Array_Tp, Set_Tp, Record_Tp, Subrange_Tp, Pointer_Tp,
                        LongInt_Tp, Integer_Tp, ShortInt_Tp, Register_Tp, Char_Tp, String_Tp, AufZaehl_Tp,
			Real_Tp);

     T_FeldListe     = ^FeldKnoten;
     T_TypBaum       = ^TypKnoten;
     T_AZTListe      = ^AZTKnoten;

     FeldKnoten      = RECORD
                           KtypDir    : Boolean;
                           Komponente : T_Bezeichner;
                           KompTyp    : T_TypBaum;
                           next       : T_Feldliste
                        END;

     AZTKnoten       = RECORD
                           Name       : T_Bezeichner;
                           next       : T_AZTListe
                       END;

     TypKnoten       = RECORD Laenge   : LongInt;
                              TypDir   : Boolean;
                              CASE Art : Typ_Art OF
                                AufZaehl_Tp : ( Werte  : T_AZTListe);
                                Array_Tp    : ( Index, Wert : T_TypBaum);
                                Set_Tp      : ( Element : T_TypBaum);
				Record_Tp   : ( Feld : T_Feldliste);
                                Subrange_Tp : ( Start, Ende : LongInt;
                                                Basis : T_TypBaum);
                                Pointer_Tp  : ( Bezug : T_TypBaum)
                       END;



(* ------ User-Bezeichner-Stack ------------------------------------------ *)

     Bez_Art         = (Var_Bez, Typ_Bez, Const_Bez, String_Cnst,
                        Proc_Bez, Func_Bez);

     T_ProcTyp       = (Main_Proc, Normal_Proc, Irpt_Proc, Par_Proc, Func_Proc);

     T_BezStack      = ^UserBezKnoten;
     UserBezKnoten   = RECORD
                          next        : T_BezStack;
                          Name        : T_Bezeichner;
                          Var_Param, TypDirekt   : Boolean;
			  CASE Bez    : Bez_Art OF
                            Var_Bez   : (VTypZ            : T_TypBaum;
                                         Offset,
                                         ProcNr           : LongInt);
                            Typ_Bez   : (TTypZ            : T_TypBaum);
			    Const_Bez : (CTyp             : Typ_Art;
                                         Wert             : LongInt;
                                         Zahl             : Double);
                            String_Cnst : (StrP           : T_StringPtr);
                            Proc_Bez  : (PParam           : T_BezStack; { Reihenfolge nicht aendern!!}
                                         PrNr, PVarSpace,
                                         PParSpace, PRegVars,
                                         PAddr            : LongInt;
                                         PTyp             : T_ProcTyp;
                                         PFWDekl          : Boolean);
                            Func_Bez  : (FParam           : T_BezStack;
                                         FuNr, FVarSpace,
                                         FParSpace, FRegVars,
                                         FAddr            : LongInt;
                                         FTypZ            : T_TypBaum;
                                         FFWDekl          : Boolean)
                       END;

     T_ForwardListe = ^FWDKnoten;
     FWDKnoten      = RECORD Name  : T_Bezeichner;
                             Z     : T_BezStack;
                             BInfo : T_BralInfo;
                             next  : T_ForwardListe
                      END;


VAR  LongIntTypB, IntegerTypB, ShortIntTypB, CharTypB, BooleanTypB, RealTypB, StringTypB,
     PointerTypB, AufzTypB, leere_MengeTypB, RegisterTypB     : T_TypBaum;
     FWL           : T_ForwardListe;

PROCEDURE Create_StdTyp(VAR S : T_BezStack);
PROCEDURE Create_StdProzeduren(VAR S : T_BezStack);
PROCEDURE Insert_UserTyp(VAR S       : T_BezSTack;
			     Name    : T_Bezeichner;
			     AktTyp  : T_TypBaum;
			     Art     : Bez_Art;
			     VarP    : Boolean);
PROCEDURE Test_if(ist, soll: T_Token; Was : String);
FUNCTION is_Integer(T : T_TypBaum): Boolean;
PROCEDURE Create_Typ (VAR S     : T_BezStack;
		      VAR T     : T_Typbaum;
		      lokal     : T_BezStack;
		      VAR TDir  : Boolean);

PROCEDURE Konstanten_dekl_P(VAR S     : T_BezStack;
			    lokal     : T_BezStack);

PROCEDURE Var_dekl_P(VAR S, Proz_Kopf : T_BezStack);

PROCEDURE Typ_dekl_P(VAR S     : T_BezStack;
		     lokal     : T_BezStack );

PROCEDURE Label_dekl_P(VAR LbS : T_Stack);
FUNCTION Finde_Bezeichner(    S     : T_BezStack;
			      Suche : T_Bezeichner;
			  VAR F       : T_BezStack;
			  VAR Nr    : longInt): Boolean;
PROCEDURE Typen_Gleich(T1, T2 : T_TypBaum);
PROCEDURE Var_Typen_Gleich(T1, T2 : T_TypBaum);
PROCEDURE Find_Art_Wert(VAR Art    : Typ_Art;
			VAR Wert   : LongInt;
                        VAR RWert  : Double;
			VAR Stri   : String);
PROCEDURE Doppel_Test(S     : T_BezStack;
		      Suche : T_Bezeichner;
		      Ende  : T_BezStack);
FUNCTION Finde_Typ(    S     : T_BezStack;
		       Suche : T_Bezeichner;
		   VAR T     : T_TypBaum): Boolean;
PROCEDURE Find_Def_Konst(LinksTyp : T_TypBaum;
			 VAR Wert     : LongInt);


PROCEDURE Dispose_all_User(von, bis : T_BezStack);
PROCEDURE Mathematisch(T: T_TypBaum);
PROCEDURE abzaehl_Typ(TypZ :T_TypBaum);
PROCEDURE AZTnachPTR(az : Typ_Art; VAR Ptr : T_TypBaum);

PROCEDURE Define_Label(LblStack  : T_Stack);
PROCEDURE Setze(suchGo: T_Element; LbS :T_Stack);
PROCEDURE Trage_label_ein(VAR LbS, GoS : T_Stack);

FUNCTION In_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner;
			 VAR F : T_BezStack): Boolean;
PROCEDURE Del_aus_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner);
PROCEDURE Insert_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner;
			      F: T_BezStack; Info : T_BralInfo);

PROCEDURE Vergleiche_Param(vonA, bisA, vonB, bisB : T_BezStack);

{ =====================================================================}

IMPLEMENTATION
{$IFDEF Delphi }
USES CommWin;
{$ELSE }
USES CommDOS;
{$ENDIF }

{ Hier erst mal ein paar vorlufige Prozeduren ------------------- }

PROCEDURE Insert_StdTyp(VAR S      : T_BezStack;
			    Name   : T_Bezeichner;
			    Laenge : LongInt;
			    Art    : Typ_Art;
			Var THilf  : T_TypBaum);
VAR Hilf : T_BezStack;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Typ_Bez;
  New(THilf);
  THilf^.Laenge := Laenge;
  THilf^.Art    := Art;
  THilf^.TypDir := false;              (* nicht weiter lschen *)
  Hilf^.TTypZ   := THilf;
  Hilf^.TypDirekt := True;             (* den lschen *)
  S             := Hilf
END;

PROCEDURE Insert_UserTyp(VAR S       : T_BezSTack;
			     Name    : T_Bezeichner;
			     AktTyp  : T_TypBaum;
			     Art     : Bez_Art;
			     VarP    : Boolean);
VAR Hilf : T_BezStack;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Art;
  Hilf^.Var_Param:= VarP;
  Hilf^.TypDirekt := false;
  CASE  Art OF
     Var_Bez  : Hilf^.VTypZ := AktTyp;
     Typ_Bez  : Hilf^.TTypZ := AktTyp;
     Func_Bez : Hilf^.FTypZ := AktTyp;
     ELSE
  END;
  S             := Hilf
END;


(* Prozeduren fr direktes Einfgen der System-Prozeduren / Funktionen *)

PROCEDURE Insert_Proc(VAR S       : T_BezSTack;
			  Name    : T_Bezeichner;
			  AnzParam: Word;
			  Art     : Typ_Art;
			  Trap_Nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := True;              (* um variable zu lschen *)
  Hilf^.PAddr   := Word(Trap_Nr);       { eventuell Typ T_Trap ? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PVarSpace := 0;
  Hilf^.PTyp    := Normal_Proc;
  FOR i := 1 TO AnzParam DO
    BEGIN
      CASE Art OF
         LongInt_Tp : Insert_usertyp(Hilf^.PParam,'',LongIntTypB, Var_Bez, false);
	 Integer_Tp : Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
	 Char_Tp    : Insert_usertyp(Hilf^.PParam,'',CharTypB, Var_Bez, false);
	 ShortInt_Tp: Insert_usertyp(Hilf^.PParam,'',ShortIntTypB, Var_Bez, false);
	 Real_Tp    : Insert_usertyp(Hilf^.PParam,'',RealTypB, Var_Bez, false);
	 Pointer_Tp : Insert_usertyp(Hilf^.PParam,'',PointerTypB, Var_Bez, false);
	 String_Tp  : Insert_usertyp(Hilf^.PParam,'',StringTypB, Var_Bez, false);
      END;
      Hilf^.PParam^.ProcNr := Sys_Proc;
      Hilf^.PParam^.Offset := Hilf^.PVarSpace;
      IF Art = Integer_TP THEN Inc(Hilf^.PVarSpace,4) { alt : 2 }
			  ELSE Inc(Hilf^.PVarSpace,4) { alt : 1 }
    END;
    S := Hilf
END;

PROCEDURE Insert_Func(VAR S       : T_BezSTack;
			  Name    : T_Bezeichner;
                          AnzParam: Word;
                          Art     : Typ_Art;
                          FuncTyp : T_TypBaum;
                          Trap_nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Func_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.FAddr   := Word(Trap_Nr);    { ev. T_Trap als Typ ????? }
  Hilf^.FuNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.FParam  := Hilf;
  Hilf^.FTypZ   := FuncTyp;
  Hilf^.FVarSpace := 0;
  FOR i := 1 TO AnzParam DO
    BEGIN
      CASE Art OF
         LongInt_Tp : Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, false);
         Integer_Tp : Insert_usertyp(Hilf^.FParam,'',IntegerTypB, Var_Bez, false);
         Char_Tp    : Insert_usertyp(Hilf^.FParam,'',CharTypB, Var_Bez, false);
         ShortInt_Tp: Insert_usertyp(Hilf^.FParam,'',ShortIntTypB, Var_Bez, false);
         Real_Tp    : Insert_usertyp(Hilf^.FParam,'',RealTypB, Var_Bez, false);
	 String_Tp  : Insert_usertyp(Hilf^.FParam,'',StringTypB, Var_Bez, false);
      END;
      Hilf^.FParam^.ProcNr := Sys_Proc;
      Hilf^.FParam^.Offset := Hilf^.FVarSpace;
      IF Art = Integer_TP THEN Inc(Hilf^.FVarSpace,4)
                          ELSE Inc(Hilf^.FVarSpace,4)
    END;
  S             := Hilf
END;

PROCEDURE Insert_Str_F(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Func_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.FAddr   := Word(Trap_Nr); { ??? }
  Hilf^.FuNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.FParam  := Hilf;
  Hilf^.FVarSpace := 0;
  Hilf^.FTypZ   := StringTypB;
  Insert_usertyp(Hilf^.PParam,'',RealTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  S := Hilf
END;


PROCEDURE Insert_WReal(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);  { ????? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := Normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.PParam,'',RealTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  S := Hilf
END;


PROCEDURE Insert_WStr(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_nr); { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := Normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.PParam,'',StringTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.PParam,'',IntegerTypB, Var_Bez, false);
  S := Hilf
END;

PROCEDURE Insert_Copy(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_nr : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Func_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.FAddr   := Word(Trap_Nr);   { T_Trap ???? }
  Hilf^.FuNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.FParam  := Hilf;
  Hilf^.FTypZ   := StringTypB;
  Hilf^.FVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',StringTypB,  Var_Bez, false);
  Insert_usertyp(Hilf^.FParam,'',IntegerTypB, Var_Bez, false);
  Insert_usertyp(Hilf^.FParam,'',IntegerTypB, Var_Bez, false);
  S := Hilf
END;

PROCEDURE Insert_Alloc(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr  : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);   { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',PointerTypB, Var_Bez, True);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  S := Hilf
END;

PROCEDURE Insert_RSInit(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr  : T_Trap);
VAR Hilf : T_BezStack;
    i    : Word;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);   { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',PointerTypB, Var_Bez, True);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  S := Hilf
END;

PROCEDURE Insert_RSStat(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr  : T_Trap);
VAR Hilf : T_BezStack;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);   { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, True);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, True);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, True);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, True);
  S := Hilf
END;

PROCEDURE Insert_EEProgStr(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr  : T_Trap);
VAR Hilf : T_BezStack;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);   { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',StringTypB, Var_Bez, False);
  S := Hilf
END;


PROCEDURE Insert_EEProgReal(VAR S       : T_BezSTack;
                          Name    : T_Bezeichner;
                          Trap_Nr  : T_Trap);
VAR Hilf : T_BezStack;
BEGIN
  New(Hilf);
  Hilf^.next    := S;
  Hilf^.name    := Name;
  Hilf^.Bez     := Proc_Bez;
  Hilf^.Var_Param:= false;
  Hilf^.TypDirekt := true;
  Hilf^.PAddr   := Word(Trap_Nr);   { ???? }
  Hilf^.PrNr    := Sys_Proc;            (* Fr alle SystemProzeduren *)
  Hilf^.PParam  := Hilf;
  Hilf^.PTyp    := normal_Proc;
  Hilf^.PVarSpace := 0;
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',LongIntTypB, Var_Bez, False);
  Insert_usertyp(Hilf^.FParam,'',RealTypB, Var_Bez, False);
  S := Hilf
END;

PROCEDURE Insert_UserConst(VAR S     : T_BezStack;
			       Name  : T_Bezeichner;
			       TArt  : Typ_Art;
			       Wert  : LongInt);
BEGIN
  Insert_UserTyp(S, Name, nil, Const_Bez, false);
  S^.Wert := Wert;
  S^.CTyp := TArt
END;

PROCEDURE Insert_RealConst(VAR S     : T_BezStack;
			       Name  : T_Bezeichner;
			       TArt  : Typ_Art;
			       RZahl : Double);
BEGIN
  Insert_UserTyp(S, Name, nil, Const_Bez, false);
  S^.Zahl := RZahl;
  S^.CTyp := TArt
END;

PROCEDURE Insert_StringCnst(VAR S    : T_BezStack;
				Name : T_Bezeichner;
				Stri : String);
BEGIN
  Insert_UserTyp(S, Name, nil, String_Cnst, false);
  New(S^.StrP);
  S^.StrP^ := Stri; S^.TypDirekt := true
END;

PROCEDURE Insert_AZTWert(x : T_Bezeichner; VAR Z : T_AZTListe);
VAR Hilf : T_AZTListe;
BEGIN
  IF z = nil
     THEN BEGIN new(Z);
		Z^.Name := x;
		Z^.next := nil
	  END
     ELSE BEGIN Hilf := z;
		WHILE  (Hilf^.next <> nil) DO
		      BEGIN IF Hilf^.name=x THEN Fehler('Bezeichner doppelt');
			    Hilf := Hilf^.next
		      END;
		new(Hilf^.next);
		Hilf^.next^.name := x;
		Hilf^.next^.next := nil
	  END
END;

FUNCTION Finde_AZTWert(x: T_Bezeichner; Z : T_AZTLIste; VAR Nr : LongInt):Boolean;
VAR gefunden : Boolean;
BEGIN
  Nr := 0; gefunden := false;
  WHILE not gefunden AND (z <> nil)  DO
     BEGIN gefunden := Z^.Name = x;
	   IF not gefunden THEN BEGIN Z := Z^.next; Inc(Nr) END
     END;
  Finde_AZTWert := gefunden
END;

PROCEDURE Create_StdTyp(VAR S : T_BezStack);
BEGIN
  S := nil;
  Insert_StdTyp(S, 'REGISTER',0, Register_Tp, RegisterTypB);
  Insert_StdTyp(S, 'LONGINT', 4, LongInt_Tp,  LongIntTypB);
  Insert_StdTyp(S, 'INTEGER', 2, Integer_Tp,  IntegerTypB);
  Insert_StdTyp(S, 'SHORTINT',1, ShortInt_Tp, ShortIntTypB);
  Insert_StdTyp(S, 'CHAR',    1, Char_Tp,     CharTypB);
  Insert_StdTyp(S, 'REAL',    8, Real_Tp,     RealTypB);
  Insert_StdTyp(S, 'STRING',  256, String_Tp,  StringTypB);
  Insert_StdTyp(S, 'BOOLEAN', 1, AufZaehl_Tp, BooleanTypB);
  BooleanTypB^.Werte := nil;  BooleanTypB^.TypDir := true;
  Insert_AZTWert('FALSE',BooleanTypB^.Werte);
  Insert_AZTWert('TRUE', BooleanTypB^.Werte);
  Insert_StdTyp(S, 'POINTER', 4, Pointer_Tp,  PointerTypB);
  Insert_UserConst(S,'NIL',Pointer_Tp,0)
END;

PROCEDURE Create_StdProzeduren(VAR S : T_BezStack);
BEGIN
  Insert_Proc(S,'EXIT'      ,1,  Pointer_Tp, R_Tunix); (* nicht echt *)
  Insert_Proc(S,'INC'       ,2,  Integer_Tp, R_Tunix);
  Insert_Proc(S,'DEC'       ,2,  Integer_Tp, R_Tunix);
  Insert_Proc(S,'WRITELN'   ,0, Integer_Tp, R_Writeline);
  Insert_Proc(S,'WRITECHR'  ,1, Char_Tp,    R_WriteChr);
  Insert_Proc(S,'WRITEINT'  ,2, Integer_Tp, R_WriteInt);
  Insert_Func(S,'LENGTH'    ,1, String_Tp, IntegerTypB, R_StrLength);
  Insert_Func(S,'CONCAT'    ,2, String_Tp, StringTypB, R_StrConcat);
  Insert_Func(S,'POS'       ,2, String_Tp, IntegerTypB, R_StrPos);
  Insert_Copy(S,'COPY',R_StrCopy);
  Insert_Str_F(S,'STR',R_RealzuStr);
  Insert_Func(S,'VAL'       ,1, String_Tp, RealTypB, R_StrzuReal);
  Insert_WStr(S,'WRITESTR' ,  R_WriteStr);
  Insert_WReal(S,'WRITEREAL', R_WriteReal);
  Insert_Func(S,'SIN'       ,1, Real_Tp,   RealTypB, R_FloatSin);
  Insert_Func(S,'COS'       ,1, Real_Tp,   RealTypB, R_FloatCos);
  Insert_Func(S,'TAN'       ,1, Real_Tp,   RealTypB, R_FloatTan);
  Insert_Func(S,'ARCSIN'    ,1, Real_Tp,   RealTypB, R_FloatASin);
  Insert_Func(S,'ARCCOS'    ,1, Real_Tp,   RealTypB, R_FloatACos);
  Insert_Func(S,'ARCTAN'    ,1, Real_Tp,   RealTypB, R_FloatATan);
  Insert_Func(S,'EXP'       ,1, Real_Tp,   RealTypB, R_FloatExp);
  Insert_Func(S,'LN'        ,1, Real_Tp,   RealTypB, R_FloatLN);
  Insert_Func(S,'SQR'       ,1, Real_Tp,   RealTypB, R_FloatQuadrat);
  Insert_Func(S,'SQRT'      ,1, Real_Tp,   RealTypB, R_FloatWurzel);
  Insert_Func(S,'TRUNC'     ,1, Real_Tp,   IntegerTypB, R_FloatInt);
  Insert_Func(S,'FRAC'      ,1, Real_Tp,   RealTypB, R_FloatTrunc);
  Insert_Func(S,'FLOAT'     ,1, Integer_Tp,RealTypB, R_IntFloat);
  Insert_Func(S,'FAK'       ,1, Integer_Tp,RealTypB, R_Fakultaet);
  Insert_Proc(S,'DELAY'     ,1, Integer_Tp, R_Delay);
  Insert_Func(S,'MEMAVAIL'  ,0, Integer_Tp, LongIntTypB, R_Memavail);
  Insert_Func(S,'MAXAVAIL'  ,0, Integer_Tp, LongIntTypB, R_Maxavail);
  Insert_Func(S,'FREECOUNT' ,0, Integer_Tp, LongIntTypB, R_FreeCount);
  Insert_Func(S,'SIZEOF'    ,1, Integer_Tp,IntegerTypB,  R_Tunix); (* keine echte Fkt. *)
  Insert_Proc(S,'NEW'       ,1, Pointer_Tp, R_GetMem);
  Insert_Proc(S,'DISPOSE'   ,1, Pointer_Tp, R_FreeMem);
  Insert_Alloc(S,'GETMEM',  R_GetMem);
  Insert_Alloc(S,'FREEMEM', R_FreeMem);
  Insert_Func(S,'READTIMER' ,0, Integer_Tp, IntegerTypB, R_ReadTimer);
  Insert_Proc(S,'SETCLOCK'  ,1,  Pointer_Tp, R_SetClock);
  Insert_Proc(S,'READCLOCK' ,1,  Pointer_Tp, R_ReadClock);
  Insert_Proc(S,'SETBPORT'  ,2, Integer_Tp, R_SetBPort);
  Insert_Func(S,'GETBPORT'  ,1, Integer_Tp, IntegerTypB, R_GetBPort);
  Insert_Proc(S,'SETWPORT'  ,2, Integer_Tp, R_SetWPort);
  Insert_Func(S,'GETWPORT'  ,1, Integer_Tp, IntegerTypB, R_GetWPort);
  Insert_Proc(S,'SETLPORT'  ,2, Integer_Tp, R_SetLPort);
  Insert_Func(S,'GETLPORT'  ,1, Integer_Tp, IntegerTypB, R_GetLPort);
  Insert_Func(S,'BITAND'    ,2, Integer_Tp, IntegerTypB, R_LongAnd);
  Insert_Func(S,'BITOR'     ,2, Integer_Tp, IntegerTypB, R_LongOr);
  Insert_Func(S,'BITNOT'    ,1, Integer_Tp, IntegerTypB, R_LongNot);
  Insert_Func(S,'BITEOR'    ,2, Integer_Tp, IntegerTypB, R_LongEor);
  Insert_Proc(S,'GOTOXY'    ,2, Integer_Tp, R_Gotoxy);
  Insert_FUNC(S,'EEREADBYTE',2, Integer_Tp, LongIntTypB, R_EEReadByte);
  Insert_FUNC(S,'EEREADWORD',2, Integer_Tp, LongIntTypB, R_EEReadWord);
  Insert_FUNC(S,'EEREADLONG',2, Integer_Tp, LongIntTypB, R_EEReadLong);
  Insert_FUNC(S,'EEREADREAL',2, Integer_Tp, RealTypB,    R_EEReadReal);
  Insert_FUNC(S,'EEREADSTR' ,2, Integer_Tp,  StringTypB,  R_EEReadStr);
  Insert_Proc(S,'EEPROGBYTE',3, Integer_Tp, R_EEProgByte);
  Insert_Proc(S,'EEPROGWORD',3, Integer_Tp, R_EEProgWord);
  Insert_Proc(S,'EEPROGLONG',3, Integer_Tp, R_EEProgLong);
  Insert_EEprogStr(S, 'EEPROGSTR', R_EEProgStr);
  Insert_EEProgReal(S, 'EEPROGREAL', R_EEProgReal);
  Insert_Func(S,'UPCASE'    ,1, Char_Tp,    CharTypB,    R_Uppercase);
  Insert_Func(S,'KEYPRESSED',0, Integer_Tp, BooleanTypB, R_KeyPress);
  Insert_Func(S,'READCHR'   ,0, Char_Tp,    CharTypB,    R_ReadChr);
  Insert_Func(S,'READSTR'   ,0, Integer_Tp, StringTypB,  R_ReadString);
  Insert_Proc(S,'LCDINIT'   ,3, Integer_Tp, R_LCDInit);
  Insert_Proc(S,'TASTINIT'  ,0, Integer_Tp, R_TastInit);
  Insert_Func(S,'CHR'       ,1, ShortInt_Tp,CharTypB,     R_TuNIX);
  Insert_Func(S,'ORD'       ,1, Char_Tp,    ShortIntTypB, R_TuNIX);
  Insert_Proc(S,'TASKSTART' ,1, Integer_Tp, R_TaskStart);
  Insert_Proc(S,'TASKSTOP'  ,0, Integer_Tp, R_TaskStop);
  Insert_Proc(S,'SEND'      ,1, Integer_Tp, R_Send);
  Insert_Proc(S,'WAIT'      ,1, Integer_Tp, R_Wait);
  Insert_Func(S,'AWAITED'   ,1, Integer_Tp, BooleanTypB, R_Awaited);
  Insert_Proc(S,'SLEEP'     ,1, Integer_Tp, R_Sleep);
  Insert_Proc(S,'INTMASK'   ,1, Integer_Tp, R_IntMask);
  Insert_Proc(S,'SETREGISTER',2, Integer_Tp, R_SetRegister);
  Insert_Proc(S,'RANDOMIZE' ,0, Integer_Tp, R_Randomize);
  Insert_Func(S,'RANDOM'    ,1, LongInt_TP, LongIntTypB, R_Random);
  Insert_Proc(S,'SETIRQMASK',1, LongInt_Tp, R_SetIrqMask);
  Insert_Func(S,'GETIRQMASK',0, Integer_Tp, LongIntTypB, R_GetIrqMask);
  Insert_Proc(S,'SCI1INIT'  ,0, Integer_Tp, R_SCI1Init);
  Insert_Proc(S,'DAOUT'     ,1, LongInt_Tp, R_DAOut);
  Insert_Func(S,'ADIN'      ,0, Integer_Tp, LongIntTypB, R_ADIn);
  Insert_Func(S,'ADIN16'    ,0, Integer_Tp, LongIntTypB, R_ADIn16);
  Insert_RSInit(S, 'RSINIT', R_RSInit);
  Insert_Func(S,'RSREADY', 1, Integer_Tp, BooleanTypB, R_RSReady);
  Insert_RSStat(S, 'RSSTAT', R_RSStat);
  Insert_Func(S,'RSREAD', 1, Integer_Tp, LongIntTypB, R_RSRead);
  Insert_Proc(S,'RSSEND', 2, Integer_Tp, R_RSSend);

  Insert_Proc(S,'I2CINIT',    0, LongInt_Tp, R_I2CInit);
  Insert_Proc(S,'I2CSTART',   1, LongInt_Tp, R_I2CStart);
  Insert_Proc(S,'I2CRESTART', 1, LongInt_Tp, R_I2CReStart);
  Insert_Proc(S,'I2CSEND',    1, LongInt_Tp, R_I2CSend);
  Insert_Proc(S,'I2CSTOP',    0, LongInt_Tp, R_I2CStop);
  Insert_Func(S,'I2CREADA',   0, LongInt_Tp, LongIntTypB, R_I2CReadA);
  Insert_Func(S,'I2CREADNA',  0, LongInt_Tp, LongIntTypB, R_I2CReadNA);
  Insert_Func(S,'I2CACK',     0, LongInt_Tp, BooleanTypB, R_I2CAck);

  Insert_Proc(S,'GOHOST'     ,0, Integer_Tp, R_GoHost);

END;

PROCEDURE Test_if(ist, soll: T_Token; Was : String);
BEGIN
  IF ist <> soll
     THEN BEGIN Fehler('''' + Was + ''' erwartet')
          END
END;

FUNCTION Finde_Bezeichner(    S     : T_BezStack;
                              Suche : T_Bezeichner;
                          VAR F       : T_BezStack;
                          VAR Nr    : longInt): Boolean;
VAR gefunden : Boolean;
BEGIN
  F := S; gefunden := false;     nr := -1;
  WHILE not gefunden AND (F <> nil) AND InputRec.C_Ok
    DO BEGIN gefunden := F^.Name = Suche;
             IF not gefunden
                THEN IF (F^.Bez = Typ_Bez) AND (F^.TTypZ <> NIL)
			THEN BEGIN
                               IF (F^.TTypZ^.Art = Aufzaehl_Tp)
                                THEN BEGIN
                                       gefunden := Finde_AZTWert(Suche, F^.TTypZ^.Werte, Nr);
                                       IF not gefunden THEN BEGIN F:= F^.next ; Nr := -1 END
				     END
                                ELSE F := F^.next;
                              END
                        ELSE F := F^.next;
       END;
  Finde_Bezeichner := gefunden;
END;

FUNCTION Finde_Typ(    S     : T_BezStack;
                       Suche : T_Bezeichner;
                   VAR T     : T_TypBaum): Boolean;
VAR Hilf : T_BezStack;
    nr : LongInt;
BEGIN
  IF Finde_Bezeichner(S, Suche, Hilf,nr)
     THEN BEGIN
             Finde_Typ := Hilf^.Bez = Typ_Bez;
             T := Hilf^.TTypZ
          END
     ELSE Finde_Typ := false
END;


PROCEDURE Doppel_Test(S     : T_BezStack;
                      Suche : T_Bezeichner;
                      Ende  : T_BezStack);
VAR ident : Boolean;
    nr    : LongInt;
BEGIN
  ident := false;
  WHILE (S<>Ende) AND not ident AND InputRec.C_Ok DO
    BEGIN
       ident := suche = S^.Name;
       IF not ident
          THEN IF (S^.Bez = Typ_Bez) AND (S^.TTypZ <> NIL)
		  THEN IF (S^.TTypZ^.Art = Aufzaehl_Tp)
                          THEN BEGIN ident := Finde_AZTWert(Suche, S^.TTypZ^.Werte, Nr);
                                     IF not ident THEN S := S^.next
                               END
                          ELSE S := S^.next
		  ELSE S := S^.next
    END;
  IF ident THEN Fehler('Identifier doppelt')
END;

FUNCTION is_Integer(T : T_TypBaum): Boolean;
BEGIN
  is_Integer := (T=LongIntTypB) OR (T=IntegerTypB) OR (T=ShortIntTypB)
                OR (T=RegisterTypB)
END;

PROCEDURE Typen_Gleich(T1, T2 : T_TypBaum);
BEGIN
  IF (T1 = T2)  OR is_Integer(T1) AND is_Integer(T2)
     THEN
     ELSE IF (T1^.Art = Subrange_Tp) AND (T2^.Art <> Subrange_TP)
             THEN Typen_Gleich(T1^.Basis,T2)
             ELSE IF (T1^.Art <> Subrange_Tp) AND (T2^.Art = Subrange_TP)
                     THEN Typen_Gleich(T1, T2^.Basis)
                     ELSE IF (T1^.Art = Subrange_Tp) AND (T2^.Art = Subrange_TP)
		     THEN Typen_Gleich(T1^.Basis, T2^.Basis)
                     ELSE IF (T2^.Art = Pointer_TP) AND (T1^.Art = Pointer_Tp)
                             THEN (* immer ok *)
                             ELSE IF (T1^.Art = Set_Tp) AND (T2^.Art = Set_Tp)
                                     THEN  IF (T1^.Element = leere_MengeTypB) OR
					      (T2^.Element = leere_MengeTypB)
                                              THEN { sind zuweisungskompatibel }
                                              ELSE Typen_gleich(T1^.Element, T2^.Element)
                                     ELSE Fehler ('Typenkonflikt') ;
END;

PROCEDURE VAR_Typen_Gleich(T1, T2 : T_TypBaum);
BEGIN
  IF (T1 = T2)
     THEN
     ELSE IF (T1^.Art = Subrange_Tp) AND (T2^.Art <> Subrange_TP)
             THEN Typen_Gleich(T1^.Basis,T2)
             ELSE IF (T1^.Art <> Subrange_Tp) AND (T2^.Art = Subrange_TP)
                     THEN Typen_Gleich(T1, T2^.Basis)
                     ELSE IF (T1^.Art = Subrange_Tp) AND (T2^.Art = Subrange_TP)
		     THEN Typen_Gleich(T1^.Basis, T2^.Basis)
                     ELSE IF (T2^.Art = Pointer_TP) AND (T1^.Art = Pointer_Tp)
                             THEN (* immer ok *)
                             ELSE IF (T1^.Art = Set_Tp) AND (T2^.Art = Set_Tp)
                                     THEN  IF (T1^.Element = leere_MengeTypB) OR
					      (T2^.Element = leere_MengeTypB)
                                              THEN { sind zuweisungskompatibel }
                                              ELSE Typen_gleich(T1^.Element, T2^.Element)
                                     ELSE Fehler ('Typenkonflikt') ;
END;

PROCEDURE Find_Art_Wert(VAR Art    : Typ_Art;
                        VAR Wert   : LongInt;
                        VAR RWert  : Double;
                        VAR Stri   : String);
VAR Positiv : boolean;
BEGIN
  { Real Integer, Char und String erlaubt !! }
  IF Scan.Token = Minus
       THEN  BEGIN Positiv := false; Scanner END
       ELSE Positiv := true;
  CASE Scan.Token OF
   Zahl_T : BEGIN Wert:= Scan.Zahl;  Art := LongInt_Tp;
                  IF not Positiv THEN Wert := - Wert
            END;
   Real_T : Begin RWert := Scan.Wert; Art := Real_Tp;
                  IF not Positiv THEN Wert := - Wert
            END;
   Hochkomma : BEGIN lies_String(Stri);
                        IF length(Stri) = 1
                           THEN BEGIN  Wert := Ord(Stri[1]);
                                       Art  := Char_Tp
                                END
                           ELSE Art   := String_Tp;
                  END;
   Kreuz  :BEGIN Scanner;
                 IF Scan.Token = Zahl_T
                    THEN BEGIN Wert := Ord(Scan.Zahl);
			       Art := Char_Tp
                         END
                    ELSE Fehler('Zahl erwartet')
           END;
   ELSE    Fehler('als Konstante nicht erlaubt')
   END { case }
END;

PROCEDURE Find_Def_Konst(LinksTyp : T_TypBaum;
                         VAR Wert     : longInt);
VAR x : String;
    B_Wert : LongInt;
BEGIN
  IF is_Integer(LinksTyp)
     THEN  IF Scan.Token = Zahl_T
              THEN Wert := Scan.Zahl
              ELSE Fehler('Zahl erwartet')
     ELSE IF (LinksTyp = CharTypB)
     THEN IF Scan.Token = Hochkomma
             THEN BEGIN lies_String( X);
			IF length(X) = 1
                           THEN Wert := Ord(X[1])
                           ELSE Fehler('Char erwartet')
                  END
             ELSE IF Scan.Token = Kreuz
                     THEN BEGIN
                              Scanner;
                              IF Scan.Token = Zahl_T
                                 THEN BEGIN Wert := Ord(Scan.Zahl);
                                      END
                                 ELSE Fehler('Zahl erwartet')
                          END
                     ELSE Fehler('Char erwartet')
     ELSE IF (LinksTyp^.Art = Aufzaehl_Tp)
     THEN IF Scan.Token = Bezeichner_T
             THEN IF Finde_AZTWert(Scan.Wort,LinksTyp^.Werte, B_Wert)
                     THEN Wert := B_wert
                     ELSE Fehler('Bezeichner unbekannt')
             ELSE Fehler('Aufzaehlwert erwartet')
     ELSE Fehler('nur konstante Werte erlaubt')
END;

PROCEDURE Standard_TypZ(VAR T: T_TypBaum; a: Typ_ART);
BEGIN
     CASE A OF
	ShortInt_Tp: T := ShortIntTypB;           (* neu in 1.4c *)
	Integer_Tp : T := IntegerTypB;
        LongInt_TP : T := LongIntTypB;
        Register_Tp: T := RegisterTypB;
	Char_Tp    : T := CharTypB;
	Real_Tp    : T := RealTypB;
	String_Tp  : T := StringTypB;
	ELSE         Fehler('dieser Typ ist hier nicht erlaubt')
     END

END;

(* ------ Deklarationen -------------------------------------------------- *)


PROCEDURE Create_Typ (VAR S     : T_BezStack;
                      VAR T     : T_Typbaum;
                      lokal     : T_BezStack;
                      VAR TDir  : Boolean);

   PROCEDURE Create_Subrange_Typ(VAR S     : T_BezStack;
                                 VAR Sub   : T_TypBaum;
                                 VAR Laenge: LongInt);

    PROCEDURE get_Wert(S : T_BezStack;
                       VAR TypZ  : T_TypBaum;
                       VAR Wert  : LongInt;
                       VAR istsub: Boolean);
    VAR Stri : String;
        BezP : T_BezStack;
        Art  : Typ_Art;
        Nr   : LongInt;
        Negativ : Boolean;
        Rdummy : Double;
    BEGIN
      istsub := false;
      IF Scan.Token = Bezeichner_T
         THEN IF Finde_Bezeichner(S, Scan.Wort, BezP, Nr)
		 THEN IF BezP^.Bez = Const_Bez
                         THEN BEGIN Wert := BezP^.Wert;
                                    Standard_typZ(TypZ,BezP^.CTyp)
                              END
                         ELSE IF (BezP^.Bez = Typ_Bez)
                                 THEN BEGIN
                                        IF (BezP^.TTypZ^.Art = aufzaehl_Tp)
                                         THEN Wert := Nr
                                         ELSE IF (BezP^.TTypZ^.Art = Subrange_Tp)
                                                 THEN istsub := true
                                                 ELSE Fehler('Typ nicht erlaubt');
					TypZ := BezP^.TTypZ
                                       END
                                 ELSE Fehler('Aufzaehltyp erwartet')
                 ELSE Fehler('Bezeichner unbekannt')
         ELSE BEGIN
                 Negativ := Scan.Token = Minus;
                 IF Negativ THEN Scanner;
                 Find_Art_Wert( Art, Wert,RDummy, Stri);
                 IF Negativ
                    THEN IF (Art = Integer_Tp) OR (Art = LongInt_Tp) OR (Art = ShortInt_Tp)
                            THEN Wert := - Wert
                            ELSE Fehler('falscher Wert');
                 Standard_TypZ(TypZ, Art)
              END;
      Scanner
    END;

   VAR ok :Boolean; ZweitesErgeb : T_TypBaum;
       l : LongInt;
   BEGIN
     New(Sub);
     Sub^.Art    := Subrange_Tp;    Sub^.TypDir := True;
     get_Wert(S,Sub^.Basis, Sub^.Start, ok);
     IF ok
        THEN
        ELSE BEGIN
               Test_If(Scan.Token, ZweiPunkte, '..');
               Scanner;
               get_Wert(S, ZweitesErgeb, Sub^.Ende,ok);
               Typen_gleich(Sub^.basis, ZweitesErgeb)
             END;
     IF Sub^.Ende < Sub^.Start THEN Fehler ('Werte absteigend');
     Sub^.Laenge := Sub^.Basis^.Laenge;
     l := 1;
     l := l + Sub^.Ende - Sub^.Start;
     Laenge := l
  END;

   PROCEDURE Create_ArrayTyp(VAR S     : T_BezStack;
                             VAR Typ_Z : T_TypBaum;
                             lokal     : T_BezStack);
   VAR Hilf  : T_BezStack;
       THilf : T_TypBaum;
       Nr    : LongInt;
       TypD  : boolean;
   BEGIN
     Scanner;
     New(Typ_Z);
     Typ_Z^.Art := Array_Tp; Typ_Z^.TypDir := True;
     Test_If(Scan.Token, EKAuf,'[');
     Scanner;
     IF InputRec.C_Ok
      THEN
         IF Finde_Bezeichner(S,Scan.Wort,Hilf, Nr )
	    THEN IF nr < 0
                    THEN BEGIN Typ_Z^.Index := Hilf^.TTypZ; Scanner END
                    ELSE Create_Subrange_Typ(S, Typ_Z^.Index, Typ_Z^.Laenge)
            ELSE  Create_Subrange_Typ(S, Typ_Z^.Index, Typ_Z^.Laenge);

     Test_If(Scan.Token, EKzu, ']');
     Scanner;
     Test_If(Scan.Token, Of_T, 'OF');
     Scanner;
     IF InputRec.C_Ok THEN Create_Typ(S, Typ_Z^.Wert, lokal, TypD);
     IF InputRec.C_Ok THEN Typ_Z^.Wert^.TypDir := TypD;
     Typ_Z^.Laenge := Typ_Z^.Laenge * Typ_Z^.Wert^.Laenge;
   END;

   PROCEDURE Create_SetTyp(VAR S     : T_BezStack;
                           VAR Typ_Z : T_TypBaum;
                           lokal     : T_BezStack);
   VAR Hilf  : T_BezStack;
       THilf : T_TypBaum;
   BEGIN
     Scanner;
     New(Typ_Z);
     Typ_Z^.Laenge := 32; (* Ist bei allen Mengen identisch *)
     Typ_Z^.Art := Set_Tp;
     Test_If(Scan.Token, Of_T,'OF');
     Scanner;
     IF InputRec.C_Ok THEN Create_Typ(S, Typ_Z^.Element, lokal, Typ_Z^.TypDir);
     IF  Typ_Z^.Element^.Art IN [Subrange_Tp,AufZaehl_Tp, Char_TP, ShortInt_Tp]
        THEN IF (Typ_Z^.Element^.Art = Subrange_TP) AND
                (Typ_Z^.Element^.Ende >= 256)
                THEN Fehler ('Menge zu gross')
                ELSE
        ELSE Fehler('einfacher Typ erwartet');
   END;

   PROCEDURE Create_RecordTyp(VAR S     : T_BezStack;
                              VAR Typ_Z : T_TypBaum;
                              lokal     : T_BezStack);

      PROCEDURE Doppel_im_Record(Suche: T_Bezeichner;
				 Feld: T_Feldliste);
      VAR ident : Boolean;
      BEGIN
        ident := false;
        WHILE (Feld<>nil) AND not ident DO
          BEGIN
            ident := suche = Feld^.Komponente;
            IF not ident THEN Feld := Feld^.next
          END;
        IF ident THEN Fehler('Feld-Identifier doppelt')
      END;


VAR First, FHilf           : T_Feldliste;
    i                      :  LongInt;
    erster, Gruppen_erster, TypDir : Boolean;
    aktTyp : T_TypBaum;
BEGIN   (* Create_RecordTyp *)
  Scanner;
  New(Typ_Z);  Typ_Z^.laenge := 0; Typ_Z^.TypDir := True;
  Typ_Z^.Art := Record_Tp; Typ_Z^.Feld := nil;
  erster := true;
  WHILE InputRec.C_Ok AND (Scan.Token <> End_T) DO
     BEGIN
        Gruppen_erster := true;
        REPEAT
           Test_If(Scan.Token, Bezeichner_T, 'Bezeichner');
           Doppel_im_Record(Scan.Wort, Typ_Z^.Feld);
           If erster
              THEN BEGIN erster := false;
                         New(Typ_Z^.Feld);
                         FHilf := Typ_Z^.Feld
                   END
              ELSE BEGIN New(FHilf^.next);
                         FHilf := FHilf^.next
                   END;
           FHilf^.Komponente := Scan.Wort;
           FHilf^.next := nil;
           IF Gruppen_erster THEN BEGIN First := FHilf;
                                        Gruppen_erster := false
				  END;
           Scanner;
           IF Scan.Token = Komma THEN Scanner
        UNTIL (Scan.Token = Doppelpunkt) OR not InputRec.C_Ok;
        Scanner;
        Create_Typ(S, aktTyp, lokal, TypDir);
        i := 0;
        IF InputRec.C_Ok THEN WHILE First <> nil DO
          BEGIN First^.KompTyp := aktTyp; First^.KTypDir := TypDir;
                Inc(i);  TypDir := false;
                First := First^.next
          END;
        IF InputRec.C_Ok THEN inc(Typ_Z^.Laenge, i * aktTyp^.Laenge);
        IF Scan.Token = Semikolon THEN Scanner;    (* ; *)
     END;
  Scanner;
END;

PROCEDURE Create_PointerTyp(VAR S     : T_BezStack;
			    VAR Typ_Z : T_TypBaum;
                            lokal     : T_BezStack);
BEGIN
  New(Typ_Z);
  Typ_Z^.Laenge := 4;
  Typ_Z^.Art := Pointer_Tp;
  Scanner;
  Create_Typ(S, Typ_Z^.Bezug, lokal, Typ_Z^.TypDir)
END;

PROCEDURE Create_AufZTyp(VAR S     : T_BezStack;
                            VAR Typ_Z : T_TypBaum;
                            lokal : T_BezStack);
BEGIN
  New(Typ_Z);
  Typ_Z^.Laenge := 1;
  Typ_Z^.Art    := AufZaehl_Tp;
  Typ_Z^.Werte  := nil;
  Scanner;
  WHILE InputRec.C_Ok AND (Scan.Token <> RKzu) DO
     BEGIN
        Test_If(Scan.Token, Bezeichner_T, 'Bezeichner');
        Doppel_Test(S, Scan.Wort, lokal);
        Insert_AZTWert(Scan.Wort, Typ_Z^.Werte);
        Scanner;
        IF Scan.Token = Komma THEN Scanner
     END;
  Scanner
END;

VAR Nr, SLaenge : LongInt;
    BezP : T_BezStack;
BEGIN
   TDir := true;                 (* Create_Typ *)
   CASE Scan.Token OF
     Dach     : Create_Pointertyp(S, T, lokal);
     Array_T  : Create_ArrayTyp(S, T ,lokal);
     Record_T : Create_RecordTyp(S, T,lokal);
     Set_T    : Create_SetTyp(S, T,lokal);
     RKauf    : Create_AufZTyp(S,  T,lokal);
     Minus, Zahl_T, HochKomma : Create_Subrange_Typ(S, T, SLaenge);
     Bezeichner_T : IF Finde_Bezeichner(S,Scan.Wort,BezP, Nr)
                       THEN IF (BezP^.Bez = Typ_Bez)
                               THEN IF (BezP^.TTypZ^.Art = Aufzaehl_Tp) AND (nr >=0)
                                       THEN Create_Subrange_Typ(S, T, SLaenge)
                                       ELSE BEGIN T := BezP^.TTypZ; TDir := false;
                                                  Scanner
                                            END
			       ELSE IF (BezP^.Bez = Const_Bez)
                                       THEN Create_Subrange_Typ(S,  T, SLaenge)
                                       ELSE Fehler('Dieser Typ nicht erlaubt')
                       ELSE Fehler('Bezeichner unbekannt')
  END
END;

PROCEDURE Konstanten_dekl_P(VAR S     : T_BezStack;
			    lokal     : T_BezStack);
VAR Art : Typ_Art;
    Wert : LongInt;
    RZahl : Double;
    Name : T_Bezeichner;
    Stri : String;
BEGIN
  Scanner;
  REPEAT
      Test_If(Scan.Token, Bezeichner_T, 'Bezeichner');
      Doppel_Test(S, Scan.Wort, lokal);
      Name := Scan.Wort;
      Scanner;
      Test_If(Scan.Token, Gleich,'=');
      Scanner;
      Find_Art_Wert( Art, Wert, RZahl, Stri );
      IF Art = String_Tp
         THEN Insert_StringCnst(S, Name,Stri)
         ELSE IF Art = Real_tp
                 THEN Insert_RealConst(S, Name, Art, RZahl)
                 ELSE Insert_UserConst(S, Name,Art, Wert);
      Scanner; (* ; *)
      Test_If(Scan.Token, Semikolon,';');
      Scanner
  UNTIL (Scan.Token IN [Procedure_T .. Begin_T]) OR not InputRec.C_Ok
END;

(* ------------ Stack fr Forward - TypReferenzen --------------------- *)
TYPE T_FRef  = ^RefKnoten;
     RefKnoten = RECORD next : T_FRef;
                        Name : T_Bezeichner;
                        TypZ : T_TypBaum
                    END;

PROCEDURE Create_S(VAR Forward_Ref: T_FRef);
BEGIN
   Forward_Ref := nil
END;

FUNCTION Ref_Empty(Forward_Ref: T_FRef): Boolean;
BEGIN
  Ref_Empty := Forward_Ref = nil
END;

PROCEDURE Ref_Eintragen(VAR Forward_Ref  : T_FRef;
                            Wort         : T_Bezeichner;
                            TypZ         : T_TypBaum);
VAR Hilf : T_FRef;
BEGIN
    new(Hilf);
    Hilf^.Name  := Wort;
    Hilf^.TypZ  := TypZ;
    Hilf^.next  := Forward_Ref;
    Forward_Ref := Hilf
END;

PROCEDURE Ref_Nachtragen(VAR Forward_Ref : T_FRef;
                             Name        : T_Bezeichner;
                             aktTyp  : T_TypBaum);

  PROCEDURE Typ_Eintragen(Forward_Ref : T_FRef;
                              Name        : T_Bezeichner;
                              aktTyp      : T_TypBaum);
  BEGIN
    WHILE not Ref_Empty(Forward_Ref) DO
      BEGIN
         IF Forward_Ref^.Name = Name
            THEN Forward_Ref^.TypZ^.Bezug := aktTyp;
         Forward_Ref := Forward_Ref^.next
      END
  END;

  PROCEDURE Ref_Entfernen(VAR  Forward_Ref : T_FRef;
                               Name        : T_Bezeichner);
  VAR Hilf : T_FRef;
  BEGIN
    IF Not Ref_Empty(Forward_Ref)
       THEN BEGIN
              Hilf := Forward_Ref;
              IF Hilf^.Name = Name
                 THEN BEGIN Forward_Ref := Hilf^.next;
                            Dispose(Hilf);
                            Ref_Entfernen(Forward_Ref, Name)
                      END
		 ELSE Ref_Entfernen(Hilf^.next, Name)
            END
    END;

BEGIN
  Typ_Eintragen(Forward_Ref, Name, AktTyp);
  Ref_Entfernen(Forward_Ref, Name)
END;

PROCEDURE Pointer_Sonderbehandlung(VAR S     : T_BezStack;
                            VAR Typ_Z : T_TypBaum;
                            lokal     : T_BezStack;
                            VAR Forward_Ref : T_FRef;
                            VAR Normal      : Boolean);
BEGIN
  Scanner;
  New(Typ_Z);
  Typ_Z^.Laenge := 4;
  Typ_Z^.Art    := Pointer_Tp;
  Typ_Z^.TypDir := false;
  IF Finde_Typ(S,Scan.Wort,Typ_Z^.Bezug)
     THEN Normal := True
     ELSE BEGIN Normal := false;
                Typ_Z^.Bezug  := nil;    (* wird spter eingetragen *)
                Ref_Eintragen(Forward_Ref, Scan.Wort, Typ_Z)
          END;
  Scanner
END;

PROCEDURE Typ_dekl_P(VAR S     : T_BezStack;
                     lokal     : T_BezStack );
VAR aktTyp      : T_TypBaum;
    Forward_Ref : T_FRef;
    Name        : T_Bezeichner;
    Normal, TypD      : Boolean;
BEGIN
  Create_S(Forward_Ref);
  Scanner;
  aktTyp:=NIL;
  REPEAT
    Test_If(Scan.Token, Bezeichner_T, 'Typ-Bezeichner');
    Doppel_Test(S, Scan.Wort, Lokal);
    Name := Scan.Wort;
    Insert_UserTyp(S, Scan.Wort,aktTyp, Typ_Bez,false);  (* echter Typ spter *)
    Scanner;
    Test_If(Scan.Token, Gleich, '=');
    Scanner; Normal := True;
    IF Scan.Token = Dach
       THEN Pointer_Sonderbehandlung(S, aktTyp, lokal, Forward_Ref,normal)
       ELSE IF InputRec.C_Ok THEN Create_Typ(S,  aktTyp,lokal, TypD);
    IF Normal
       THEN Ref_Nachtragen(Forward_Ref, Name, aktTyp);
    S^.TTypZ := aktTyp; S^.TypDirekt := TypD;
    Scanner;
  UNTIL (Scan.Token IN [Procedure_T .. Begin_T]) OR not InputRec.C_Ok;
  IF not Ref_Empty(Forward_Ref)
     THEN Fehler('Forward-Typdeklaration fehlt');
END;

PROCEDURE Var_dekl_P(VAR S, Proz_Kopf : T_BezStack);
VAR aktTyp       : T_TypBaum;
    erster, TypD : Boolean;
    first,hilf   : T_BezStack;
BEGIN
  Scanner;
  REPEAT
    first := S;
    aktTyp:= NIL;
    REPEAT
      Test_If(Scan.Token, Bezeichner_T, 'Var-Bezeichner');
      Doppel_Test(S, Scan.Wort, Proz_Kopf);
      Insert_UserTyp(S, Scan.Wort,aktTyp, Var_Bez,false);
                    (* echter Typ spter *)
            Scanner;
      IF Scan.Token = Komma THEN Scanner
    UNTIL (Scan.Token = Doppelpunkt) OR not InputRec.C_Ok;
    Scanner;
    IF InputRec.C_Ok
       THEN BEGIN
              Create_Typ(S, aktTyp, Proz_Kopf, TypD);
              Hilf := S;
        WHILE InputRec.C_Ok AND (Hilf <> first) DO
              BEGIN
                Inc(Proz_Kopf^.PVarSpace, aktTyp^.Laenge);
                IF aktTyp^.Laenge > 1
                   THEN IF AktTyp^.Laenge = 2
                           THEN machWort(Proz_Kopf^.PVarSpace)
                           ELSE machlangWort(Proz_Kopf^.PVarSpace);
                hilf^.VTypZ := aktTyp;  hilf^.TypDirekt := TypD; TypD := false;
                IF aktTyp^.Laenge = 0
                   THEN BEGIN Hilf^.Offset := Proz_Kopf^.PRegVars;
                              Inc(Proz_Kopf^.PRegVars);
                              IF Proz_Kopf^.PRegVars > VarReg
                                 THEN Fehler('zu viele Register-Variablen')
                        END
                   ELSE Hilf^.Offset := -Proz_Kopf^.PVarSpace;
                Hilf^.ProcNr := Proz_Kopf^.PrNr;
                hilf := hilf^.next;
              END;
              Scanner
            END
  UNTIL (Scan.Token IN [Procedure_T .. Begin_T]) OR not InputRec.C_Ok
END;

PROCEDURE Label_dekl_P(VAR LbS : T_Stack);
VAR Lbl : T_Element;
BEGIN
  Scanner;
  WHILE InputRec.C_Ok AND (Scan.Token <> Semikolon) DO
    BEGIN
       Test_If(Scan.Token, Zahl_T, 'Label-Zahl');
       Lbl.Zahl := Scan.Zahl;    (* Rest noch undefiniert *)
       LbL.Definiert := false;
       Push(Lbs, Lbl);
       Scanner;
       IF Scan.Token = Komma
          THEN Scanner
          ELSE Test_If(Scan.Token, Semikolon,';')
    END;
  Scanner
END;

PROCEDURE Dispose_Eintrag(User: T_BezStack);
  PROCEDURE Dispose_Typ(T : T_TypBaum);

    PROCEDURE Dispose_Feld(L : T_Feldliste);
    BEGIN
      IF L <> nil
         THEN BEGIN Dispose_Feld(L^.next);
                    IF L^.KTypDir THEN Dispose_Typ(L^.KompTyp);
                    Dispose(L)
              END
    END;

    PROCEDURE Dispose_AZT(L : T_AZTliste);
    BEGIN
      IF L <> nil
         THEN BEGIN Dispose_AZT(L^.next);
                    Dispose(L)
              END
    END;


  BEGIN                (* Dispose_Typ *)
    IF T <> nil
       THEN BEGIN
              IF T^.TypDir
               THEN Case T^.Art OF
                      AufZaehl_Tp   : Dispose_AZT(T^.Werte);
                      Array_Tp      : ; { Dispose_Typ(T^.Wert) }
                      Set_Tp        : Dispose_Typ(T^.Element);
                      Record_Tp     : Dispose_Feld(T^.Feld);
                      Subrange_Tp   : ; (* Basis darf nicht gelscht werden *)
                      Pointer_Tp    : Dispose_Typ(T^.Bezug);
                    END;
               Dispose(T)
            END
  END;

BEGIN                  (* Dispose_Eintrag *)
  IF User <> nil
     THEN IF User^.TypDirekt
             THEN CASE User^.Bez OF
                     Var_Bez       : Dispose_Typ(User^.VTypZ);
                     Typ_Bez       : Dispose_Typ(User^.TTypZ);
		     Const_Bez     : (* nix *);
                     String_Cnst   : Dispose(User^.StrP);
                     Proc_Bez      : Dispose_all_User(User^.PParam, User);
                     Func_Bez      : Dispose_all_User(User^.FParam, User);
                    END
END;


PROCEDURE Dispose_all_User(von, bis : T_BezStack);
VAR Hilf : T_BezStack;
BEGIN
  WHILE (von <> nil) AND (von <> bis) DO
    BEGIN
        Hilf := von;
        Dispose_Eintrag(von);
        von  := von^.next;
        Dispose(Hilf)
    END;
END;


PROCEDURE Mathematisch(T: T_TypBaum);
BEGIN
  IF (T= RegisterTypB) OR (T = LongIntTypB) OR (T= IntegerTypB) OR (T = ShortIntTypB) OR  (T = RealTypB)
     THEN
     ELSE IF T^.Art = Subrange_Tp
          THEN IF (T^.Basis = LongIntTypB) OR (T^.Basis= IntegerTypB) OR (T^.Basis = ShortIntTypB)
                  THEN (* alles Klar *)
                  ELSE Fehler('1 Rechnen mit diesem Typ nicht erlaubt')
          ELSE IF T^.Art = Set_Tp
                  THEN { Durchschnitt }
                  ELSE Fehler('2 Rechnen mit diesem Typ nicht erlaubt')
END;

PROCEDURE abzaehl_Typ(TypZ :T_TypBaum);
BEGIN
  IF TypZ^.Art IN [Subrange_Tp, LongInt_Tp, Register_Tp, Integer_Tp, Char_Tp, ShortInt_Tp, AufZaehl_Tp]
     THEN (* alles ok *)
     ELSE Fehler('Integer erwartet')
END;

PROCEDURE AZTnachPTR(az : Typ_Art; VAR Ptr : T_TypBaum);
BEGIN
  CASE az OF
    Pointer_Tp : Ptr := PointerTypB;
    Char_Tp    : Ptr := CharTypB;
    LongInt_Tp : Ptr := LongIntTypB;
    Integer_Tp : Ptr := IntegerTypB;
    String_Tp  : Ptr := StringTypB;
    ShortInt_Tp: Ptr := ShortIntTypB;
    Real_Tp    : Ptr := RealTypB;
    ELSE         Ptr := nil
  END
END;

(* --------- Prozeduren fr Labelverarbeitung  ------------------------ *)

PROCEDURE Define_Label(LblStack  : T_Stack);
VAR Hilf     : T_Stack;
    gefunden : Boolean;
BEGIN
  Hilf := LblStack;
  gefunden := false;
  WHILE not (gefunden OR empty_S(Hilf)) DO
     BEGIN gefunden := Hilf^.Inh.Zahl = Scan.Zahl;
           IF gefunden THEN BEGIN Hilf^.Inh.BInfo.BraPC   := Code.Pc;
                                  Hilf^.Inh.Definiert := true
                            END
                       ELSE Hilf := Hilf^.next
     END;
  IF not gefunden THEN Fehler('Label nicht definiert');
  Scanner;
  Test_If(Scan.Token, Doppelpunkt, ':');
  Scanner
END;


PROCEDURE Setze(suchGo: T_Element; LbS :T_Stack);
VAR aktLb : T_Element;
    gefunden : Boolean;
BEGIN
   Gefunden := false;
   WHILE not (gefunden OR (LBS=nil)) DO
       BEGIN Top(LbS, aktLb);
             Gefunden :=  aktLb.Zahl = suchGo.Zahl;
             IF Gefunden
                THEN IF aktLb.Definiert
                        THEN Ersetze_GotoBral(suchGo.BInfo,aktLB.BInfo.BraPC)
                        ELSE Fehler(' Label nicht definiert ')
                ELSE LBS := LBS^.next
       END;
   IF not gefunden THEN Fehler('Label nicht definiert');
END;

PROCEDURE Trage_label_ein(VAR LbS, GoS : T_Stack);
VAR aktGo : T_Element;
BEGIN
  WHILE not empty_S(GoS) DO
     BEGIN   Top(GoS, aktgo);
             Setze(aktGo, LbS);
             Pull(GoS)
     END;
  Delete_S(LbS)
END;

{ ----  Behandlung der Forward - Prozeduren und Funktionen  ------ }

FUNCTION In_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner;
                         VAR F : T_BezStack): Boolean;
VAR Help : T_ForwardListe;
BEGIN
  IF FWL = nil
     THEN In_ForwardListe := false
     ELSE IF FWL^.Name = x
             THEN BEGIN F := FWL^.Z;
                        In_ForwardListe := true;
                  END
             ELSE In_ForwardListe := In_ForwardListe(FWL^.next, X, F)
END;


PROCEDURE Del_aus_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner);
VAR Help : T_ForwardListe;
BEGIN
  IF FWL <> nil
     THEN IF FWL^.Name = x
             THEN BEGIN Help := FWL;
                        Ersetze_Bral(Help^.BInfo);
                        FWL  := FWL^.next;
                        Dispose(Help)
                  END
             ELSE Del_aus_ForwardListe(FWL^.next, X)
END;

PROCEDURE Insert_ForwardListe(VAR FWL : T_ForwardListe; x: T_Bezeichner;
                              F: T_BezStack; Info : T_BralInfo);
VAR Help : T_ForwardListe;
BEGIN
  new(Help);
  Help^.Name := x;
  Help^.Z    := F;
  Help^.BInfo:= Info;
  Help^.next := FWL;
  FWL        := Help
END;

PROCEDURE Vergleiche_Param(vonA, bisA, vonB, bisB : T_BezStack);
VAR Gleich : Boolean;
BEGIN
  gleich := true;
  WHILE gleich AND (vonA <> bisA) AND (vonB <> bisB) DO
     BEGIN
        gleich := (vonA^.Name = vonB^.Name) AND
                  (vonA^.Var_Param = vonB^.Var_Param) AND
                  (vonA^.VTypZ = vonB^.VTypZ);
        vonA := vonA^.next; vonB := vonB^.next
     END;
  IF (not gleich)   OR
     (vonA <> bisA) OR
     (vonB <> bisB) THEN Fehler('Parameter nicht identisch')
END;

END.
