UNIT PasScan;   { Scanner fr Pascal-Compiler  }
{ 10.02.96 Alf aus alter SCAN-Unit abgeleitet }

INTERFACE

USES  LuchsTyp;

TYPE  T_Token         = (Semikolon, Punkt, Doppelpunkt, Komma, Zuweisung,
                        RKauf, RKzu, EKauf, EKzu, GKauf, GKzu, Dollar, Prozent,
                  {13}  Hochkomma, Mal, Mod_T, Div_T, Durch,
                        Plus, Minus, Dach, Kreuz,
                        Kleiner, Kleiner_Gleich, Gleich, Ungleich, Groesser,
                  {27}  Groesser_Gleich, In_T, And_T, Or_T, Not_T,
                        Zweipunkte,
                        Array_T, Record_T, Set_T,
                        Program_T, Procedure_T, Task_T, Interrupt_T,
                  {40}  Function_T, Unit_T, Interface_T, Implementation_T,
			Const_T, Type_T, Var_T, Label_T,
                  {48}  Begin_T, End_T,
                        While_T, Do_T, For_T, To_T, Downto_T, Repeat_T, Until_T,
                        If_T, Then_T, Else_T, Case_T, Of_T, Forward_T, Goto_T,
                        TrOn_T, TrOff_T, Assembler_T,
                        Zahl_T, Real_T, Bezeichner_T, unbekannt);

   T_BezBaum       = ^BezKnoten;
     BezKnoten       = RECORD
                          Wort  : T_Bezeichner;
                          Token : T_Token;
                          l,r   : T_BezBaum
                       END;
   T_Scan          = RECORD
                          Token       : T_Token;   (* fr Pascal *)
			  Wert        : Double;
			  Wort        : T_Bezeichner;
			  Zahl        : LongInt;
		      END;

VAR StdBez : T_BezBaum;
    Scan   : T_Scan;

PROCEDURE Scanner;
PROCEDURE Create_StdBez(VAR StdBez : T_BezBaum);
PROCEDURE Dispose_StdBez(StdBez : T_BezBaum);

IMPLEMENTATION
{$IFDEF Delphi }
USES CommWin;
{$ELSE }
USES CommDOS;
{$ENDIF}

PROCEDURE Insert_StdBez(VAR BezBaum: T_BezBaum;
			    Name: T_Bezeichner; Token: T_Token);
BEGIN
  IF BezBaum = nil
     THEN BEGIN
            New(BezBaum);
            Bezbaum^.Wort := Name; BezBaum^.Token := Token;
            BezBaum^.l := nil; Bezbaum^.r := nil
          END
     ELSE IF name < BezBaum^.Wort
             THEN Insert_StdBez(Bezbaum^.l, Name, Token)
             ELSE Insert_StdBez(BezBaum^.r, Name, Token)
END;

PROCEDURE Dispose_StdBez(StdBez : T_BezBaum);
BEGIN
   IF StdBez <> nil
      THEN BEGIN Dispose_StdBez(StdBez^.l);
                 Dispose_StdBez(StdBez^.r);
                 Dispose(StdBez)
	   END
END;

PROCEDURE Create_StdBez(VAR StdBez : T_BezBaum);
BEGIN
  StdBez := nil;
  Insert_StdBez(StdBez, 'DO',        Do_T);
  Insert_StdBez(StdBez, 'REPEAT',    Repeat_T);
  Insert_StdBez(StdBez, 'FOR',       For_T);
  Insert_StdBez(StdBez, 'TASK',      Task_T);
  Insert_StdBez(StdBez, 'TYPE',      Type_T);
  Insert_StdBez(StdBez, 'ASSEMBLER', Assembler_T);
  Insert_StdBez(StdBez, 'ELSE',      Else_T);
  Insert_StdBez(StdBez, 'PROGRAM',   Program_T);
  Insert_StdBez(StdBez, 'THEN',      Then_T);
  Insert_StdBez(StdBez, 'VAR',       Var_T);
  Insert_StdBez(StdBez, 'ARRAY',     Array_T);
  Insert_StdBez(StdBez, 'BEGIN',     Begin_T);
  Insert_StdBez(StdBez, 'CASE',      Case_T);
  Insert_StdBez(StdBez, 'CONST',     Const_T);
  Insert_StdBez(StdBez, 'DOWNTO',    Downto_T);
  Insert_StdBez(StdBez, 'END',       End_T);
  Insert_StdBez(StdBez, 'FUNCTION',  Function_T);
  Insert_StdBez(StdBez, 'IF',        If_T);
  Insert_StdBez(StdBez, 'INTERRUPT', Interrupt_T);
  Insert_StdBez(StdBez, 'IN',        In_T);
  Insert_StdBez(StdBez, 'OF',        Of_T);
  Insert_StdBez(StdBez, 'PROCEDURE', Procedure_T);
  Insert_StdBez(StdBez, 'RECORD',    Record_T);
  Insert_StdBez(StdBez, 'SET',       Set_T);
  Insert_StdBez(StdBez, 'TO',        To_T);
  Insert_StdBez(StdBez, 'UNTIL',     Until_T);
  Insert_StdBez(StdBez, 'WHILE',     While_T);
  Insert_StdBez(StdBez, 'AND',       And_T);
  Insert_StdBez(StdBez, 'OR',        Or_T);
  Insert_StdBez(StdBez, 'NOT',       Not_T);
  Insert_StdBez(StdBez, 'DIV',       Div_T);
  Insert_StdBez(StdBez, 'MOD',       Mod_T);
  Insert_StdBez(StdBez, 'TRON',      Tron_T);
  Insert_StdBez(StdBez, 'TROFF',     TrOff_T);
  Insert_StdBez(StdBez, 'LABEL',     Label_T);
  Insert_StdBez(StdBez, 'GOTO',      Goto_T);
  Insert_StdBez(StdBez, 'FORWARD',   Forward_T);
  Insert_StdBez(StdBez, 'UNIT',      Unit_T);
  Insert_StdBez(StdBez, 'INTERFACE', Interface_T);
  Insert_StdBez(StdBez, 'IMPLEMENTATION', Implementation_T);
END;

FUNCTION Find_Bez(BezBaum : T_BezBaum; Name : T_Bezeichner;
                  VAR Token: T_Token): Boolean;
BEGIN
  IF (BezBaum = nil)
     THEN Find_Bez := false
     ELSE IF Name = BezBaum^.Wort
             THEN BEGIN Find_Bez := True;
                        Token := BezBaum^.Token
		  END
             ELSE IF Name < Bezbaum^.Wort
                     THEN Find_Bez := Find_Bez(BezBaum^.l, Name, Token)
                     ELSE Find_Bez := Find_Bez(BezBaum^.r, Name, Token)
END;

FUNCTION Standard_Identifier: Boolean;
BEGIN
  Standard_Identifier := Find_Bez(StdBez, Scan.Wort, Scan.Token)
END;

PROCEDURE Scanner;

  PROCEDURE Lies_Zahl;
  VAR ZStr           : String[79];
      NeuInt         : LongInt;
      Result         : Word;
      Must_be_Int    : Boolean;
      AltReal, NeuReal : Double;
  BEGIN
    IF InputRec.z = '$'
       THEN BEGIN Must_be_Int := true;
                  ZStr        := '$';
                  Lies;
                  ZStr        := ZStr + InputRec.z
            END
       ELSE BEGIN Must_be_Int := false;
                  ZStr := InputRec.z
            END;
    Val(ZStr,NeuInt,Result);
    Scan.Zahl:=NeuInt;
    WHILE Result=0 DO
       BEGIN Scan.Zahl :=NeuInt; Lies; ZStr:=ZStr + InputRec.z;
             Val(ZStr,NeuInt,Result)
       END;
    IF (InputRec.Z = '.') AND not Must_be_Int
       THEN BEGIN
               IF next_Char = '.'
                  THEN Scan.Token := Zahl_T  { kommt .. }
          ELSE BEGIN
               Val(ZStr,NeuReal,Result);
               AltReal :=NeuReal;
               WHILE Result=0 DO
                   BEGIN AltReal := NeuReal;
                         Lies;
                         IF upcase(InputRec.z) = 'E'
                            THEN BEGIN  ZStr:=ZStr + InputRec.z;
                                        Lies;
                                        IF (InputRec.z = '-') OR (InputRec.z = '+')
                                           THEN BEGIN  ZStr:=ZStr + InputRec.z;
                                                       Lies
                                                END
                                  END;
                         ZStr := ZStr + InputRec.z;
                         Val(ZStr,NeuReal,Result)
                   END;
               Scan.Token := Real_T;
               Scan.Wert := AltReal
               { ConVertReal(AltReal, Scan.RZahl) }
            END
          END
       ELSE Scan.Token := Zahl_T
  END;

  FUNCTION Up_Wort(S : T_bezeichner): T_Bezeichner;
  VAR i : Integer;
      x : T_Bezeichner;
  BEGIN
    x := '';
    FOR i := 1 TO length(S) Do x := x + Upcase(S[i]);
    Up_Wort := x
  END;

  PROCEDURE Lies_Wort;
  BEGIN
    Scan.Wort := '';
    WHILE InputRec.z IN ['0'..'9','A'..'Z','_', 'a'.. 'z']
      DO BEGIN Scan.Wort := Scan.Wort + InputRec.z;
               Lies
         END;
    Scan.Wort := Up_Wort(Scan.Wort)
  END;

PROCEDURE Lies_Pfad(VAR P : String);
BEGIN
  P := '';
  WHILE (InputRec.z = ' ') OR (InputRec.z = #13) DO Lies;
  WHILE InputRec.Z <> ' ' DO
        BEGIN P := P + InputRec.z;
              Lies
        END;
  Scanner;
  If Scan.Token <> GKzu
     THEN Fehler('Kommentar nicht geschlossen');
END;

PROCEDURE Comp_Option;
VAR Pfad : String;
BEGIN
   IF InputRec.Include
      THEN Fehler('verschachtelte Include-Datei')
      ELSE BEGIN Lies;    (* $ *)
                 IF InputRec.Z = 'I'
                    THEN Lies
                    ELSE Fehler('Option nicht definiert');
                IF InputRec.C_Ok
                  THEN BEGIN Lies_Pfad(Pfad);
                             OpenInclude(Pfad);
                             Scanner;
                       END
           END
END;

VAR must_read : Boolean;
    c         : Integer;
BEGIN    (* Scanner *)
  IF InputRec.C_Ok THEN
  BEGIN
     WHILE (InputRec.z = ' ') OR (InputRec.z = #13) DO Lies;
  must_read := true;
  CASE InputRec.z OF
       '#'      : Scan.Token := Kreuz;
       '%'      : Scan.Token := Prozent;
       #39      : Scan.Token := Hochkomma;
       '('      : Scan.Token := RKauf;
       ')'      : Scan.Token := RKzu;
       '*'      : Scan.Token := Mal;
       '+'      : Scan.Token := Plus;
       ','      : Scan.Token := Komma;
       '-'      : Scan.Token := Minus;
       '.'      : Scan.Token := Punkt;
       '/'      : Scan.Token := Durch;
   '$', '0'..'9' : BEGIN Lies_Zahl;
                         must_read := false
                   END;
       ':'      : Scan.Token := Doppelpunkt;
       ';'      : Scan.Token := Semikolon;
       '<'      : Scan.Token := Kleiner;
       '='      : Scan.Token := Gleich;
       '>'      : Scan.Token := Groesser;
       'A'..'Z',
       'a'..'z' : BEGIN Lies_Wort;
                        must_read := false;
                        IF not Standard_Identifier
                           THEN Scan.Token := Bezeichner_T;
                  END;
       '['      : Scan.Token := EKauf;
       ']'      : Scan.Token := EKzu;
       '^'      : Scan.Token := Dach;
       '{'      : Scan.Token := GKauf;
       '}'      : Scan.Token := GKzu;
       #1       : Scan.Token := Zweipunkte
       ELSE       Scan.Token := unbekannt
    END;
  IF must_read THEN Lies;
  CASE Scan.Token OF
     Doppelpunkt  : IF (InputRec.z = '=')
                       THEN BEGIN Scan.Token := Zuweisung; Lies END;
     RKauf        : IF (InputRec.z = '*')
                       THEN BEGIN Scan.Token := GKauf; Lies END;
     Mal          : IF (InputRec.z = ')')
                       THEN BEGIN Scan.Token := GKzu; Lies END;
     Kleiner      : IF InputRec.z = '='
                       THEN BEGIN Scan.Token := Kleiner_Gleich; Lies END
                       ELSE IF InputRec.z = '>'
                               THEN BEGIN Scan.Token := Ungleich; Lies END;
     Groesser     : IF (InputRec.z = '=')
                    THEN BEGIN Scan.Token := Groesser_Gleich; Lies END;
     Punkt        : IF (InputRec.z = '.')
                    THEN BEGIN Scan.Token := Zweipunkte; Lies END;
    ELSE (* nix *)
    END;
  IF (Scan.Token=GKauf)
     THEN IF InputRec.Z = '$'
             THEN Comp_Option
             ELSE BEGIN REPEAT Scanner
                        UNTIL  (Scan.Token = GKzu) OR Not InputRec.C_Ok;
                        Scanner
                  END
 END
 ELSE Scan.Token := End_T;
END;

END.